	/*----------------------------------------------------*\
	|       This program must be compiled using the        |
	|                medium memory model                   | 
	\*----------------------------------------------------*/
#include <graphics.h>                                         
#include <stdio.h>
#include <math.h>
#include <dos.h>
#include <alloc.h>
#include <math.h>
#include <process.h>
#include "arabic.c"
#include "muslib.c"
#include "mouse.c"
#define beep putch(7)
#define UP 72
#define DOWN 80
#define RIGHT  77
#define LEFT 75
#define ESC 27
#define ENTER 13
#define F1 59
#define PI 3.1415927
int row=1,buffer[4866],positionx=135,positiony=1,numbers[390],numinit=0,slow=0;
int far *pt,*map;
float ratiox=1.3,ratioy=0.75;   /* to adjust aspect ratio on screen */
char *countries[]={             /* Country Names, in Arabic */
		"l,vdjhkdh","hgJlJyJvf","hg[J.hzJv","jJJJ,kJJs","gJdJfJdJh",
		"lJJJwJJJv","hgJsJ,]hk","[JdJf,jJd","hgJwJ,lhg","hgsu,]dJm",
		"tgJsJ'dJk","gJfJkJJhk","sJJ,vdJJh","hGv]JJJJk","hgJuJJvhr",
		"hgJ;,dJJj","hgfpJvdJk","rJJJ'JJJv","hTlJJhvhj","uJJlJJJhk",
		"hgJdJlJJk"};

/*---------------------- main () --------------------------------------*\
| This is the main function of the program.                             |
|               IN  : NONE.                                             |
|               OUT : NONE.                                             |
\*---------------------------------------------------------------------*/
main()
{
delay(1);
if(farcoreleft()>=36000)     /* if heap contains more than 36000 free bytes */
	pt=(int far*)farmalloc(35496); /* then store letters in it */
else                            /* otherwise... */
	{slow=1;init16=0;}      /* do not. Slow because we'll refer to disk */
initialize_graph();             /* initialize display to graphics mode */
start_mouse();                  /* check for mouse. Enable it if found */
while(1)                        /* Endless loop... */
	program_menu();         /* display program's main menu */
}

/*---------------------- anthems () -----------------------------------*\
| This function is specified with opening the file "anthems.dat" and    |
| reading the anthems until it reaches the desiered country then it     |
| starts plays the anthem by calling the play() function.               |
|       IN : country: no. of the selected country                       |
|       OUT: NONE.                                                      |
\*---------------------------------------------------------------------*/
anthems(country)
int country;
{
int cnt,len;
char anthem[1234];
FILE *fptr;
if(country!=11)         /* If country isn't PALESTINE */
	{               /* then it has an anthem */
	if((fptr=fopen("anthems.dat","r"))==NULL) /* try to open ANTHEMS.DAT */
			file_error("anthems.dat");  
						/* if an error, tell the user */
	for(cnt=1;cnt<=country;cnt++)
		{       /* for every country up to the required one... */
		fread(&len,2,1,fptr);   /* read length of anthems data */
		fread(anthem,1,len,fptr);       /* an then read data itself */
		}
	fclose(fptr);                   /* now close ANTHEMS.DAT */
	play(anthem,1);                 /* and play anthem of that country */
	}
else beep;              /* otherwise, if PALESTINE, just beep */
}

/*---------------------- f1_message () --------------------------------*\
| This function displays a message at the bottom of the screen that     |
| tells the user to press F1 for help.                                  |
|       IN  : NONE                                                      |
|       OUT : NONE                                                      |
\*---------------------------------------------------------------------*/
f1_message()
{
arabic_text("hqy'    H, .v hgtHvm hG,s' gglshu]m",536,325,0,1);
setcolor(11);outtextxy(460,332,"F1");
}

/*---------------------- program_menu () ------------------------------*\
| This function the the program's main menu, It calls the menu()        |
| function to get the user choice then it calls the function that       |
| represents this choice .                                              |
|          IN   : NONE                                                  |
|          OUT  : NONE                                                  |
\*---------------------------------------------------------------------*/        
program_menu()
{
FILE *fptr;
int end=0,choice=0,cnt;
char ch;
disable_cursor();               /* hide mouse cursor for now */
cleardevice();                  /* clear graphics screen */
setcolor(BROWN);rectangle(199,13,453,145); /* draw scene frame */
setcolor(WHITE);rectangle(198,12,454,146); /* complete the frame */
frame_screen();
arabic_text("[yvhtdm hguhgl hguvfd",453,150,0,1);       /* title */
setcolor(14);
for(cnt=0;cnt<=4;cnt++) rectangle(221,180+(22*cnt),436,202+(22*cnt));
setfillstyle(SOLID_FILL,LIGHTGREEN);floodfill(222,182,14);
arabic_text("rhzlm hTojdhvhj",417,181,0,1);     /* menu heading */
arabic_text("lug,lhj hgJJ],g",417,204,0,1);     /* menu items */
arabic_text("HsJJJzJJJgJJJJm",417,225,0,1);
arabic_text("tJv,r hgj,rJdJj",417,246,0,1);
arabic_text("jJp,dJJg uJJlbj",417,267,0,1);
f1_message();   /* Write "press F1 or middle button for help" in Arabic */
reverse(222,203,435,223);
enable_cursor();                /* show mouse cursor */
ratiox=1.54;ratioy=1;
save_letters();                 /* move letters array to far memory */
disable_cursor();load_map();enable_cursor(); /* draw world map */
while(end!=1)                   /* while user does not want to exit ... */
{
if(!kbhit() && check_buttons()==0)
	{       /* if neither a key-press nor a button-click */
		/* then make the map look as moving */
	disable_cursor();       /* hide mouse cursor */
	getimage(200,14,447,144,letters);getimage(448,14,452,144,buffer);
				/* get right most stripe image */
	enable_cursor();        /* show mouse cursor */
	for(cnt=0;cnt<=40;cnt++) {check_buttons();delay(1);}
				/* wait for a while */
	disable_cursor();       /* again, hide the mouse cursor */
	putimage(200,14,buffer,COPY_PUT);putimage(205,14,letters,COPY_PUT);
				/* put the two images again */
	enable_cursor();        /* an show mouse cursor */
	}
else                    /* otherwise, if a button or a key were pressed */
	{
	if(kbhit())             /* if a key was pressed */
	{
		ch=getch();     /* get that key in ch */
		if (ch==0)      /* if an extended key */
			{
			ch=getch();     /* get SCAN code */
			if(ch!=59)      /* if NOT F1 was pressed */
			   choice=menu(222,203,213,21,3,choice,ch,1);
					/* then mark the chosen item */
			else            /* if F1 was pressed */
			{load_letters();help(0);} /* display help message */
			}
		else /* if ch not equal to 0 i.e. not an extended code */
			switch(ch)
				{
				case ENTER:
					load_letters(); 
					/* retrieve letters from heap to
							letters[] array */
					enter_music();  /* play a tone */
					if(choice==0)   /* if first choice */
						{
						countries_info();       
						/* diplay countries 
								information */
						end=1; continue; /* get out */
						}
					if(choice==1)   /* if 2nd choice, QUESTIONS */
					   {if(execl("quesload.ovl","f",
					       "geo.qes","geo.ovl",0)==-1) 
					       /* if can't execute questions 
									file */
					       file_error("quesload.ovl");
							    /* tell the user */
					       }
					if(choice==2) /* Time Zones */
						{time_zones();end=1;}
					if(choice==3) /* Currency conversion */
						{currencies();end=1;}
					break;
				
				case ESC:       /* If ESC was pressed */
					esc_music();    /* play a tone */
					{if(execl("alamuna.exe","d",
					    "nointro",0)==-1) 
					    /* if can't execute ALAMUNA.EXE */
					    file_error("alamuna.exe");
							    /* tell the user */
					    }
					break;
				
				default:  /* any key rather than ENTER & ESC */
					beep;   /* beep to warn the user */
				}
	}

}
}
}

/*---------------------- load_map () ----------------------------------*\
| This function opens the file "map.dat" and read its contents in the   |
| array letters[].                                                      |
|       IN  : NONE                                                      |
|       OUT : NONE                                                      |
\*---------------------------------------------------------------------*/
load_map()
{
FILE *fptr,*fg;
int x,y;

if((fptr=fopen("map.dat","rb"))==NULL)          /* try to open MAP.DAT */
   file_error("map.dat");       /* if error in opening, tell the user */
fread(letters,2,8125,fptr);     /* read half of the map data from file */
putimage(200,14,letters,COPY_PUT);      /* display half map on screen */
fread(letters,2,265,fptr);              /* read the remaining part */
putimage(448,14,letters,COPY_PUT);      /* and display it on screen */
fclose(fptr);                           /* close MAP.DAT */
}

/*---------------------- countries_info () ----------------------------*\
| This function is specified with calling the get_country() to get the  |
| desired country then it calls the countries_info_choices() function   |
| to display the choices like anthems , population and so on.           |
|           IN    : NONE                                                |
|           OUT   : NONE                                                |
\*---------------------------------------------------------------------*/
countries_info()
{
int country;

cleardevice();                  /* clear graphics screen */
while((country=get_country("Hojv ],gm"))!=128)  /* while not get out */
	{
	while(countries_info_choices(country)==1)
		continue;
	continue;
	}
return(0);
}

/*---------------------- countries_info_choices () --------------------*\
| This function displays the choices available for the desired country  |
| like the anthems and population and according to the choice selected  |
| it calls the corresponding function like flags() , anthems(), ...     |
|               IN       : country: the country to process              |
|               OUT      : 1  if the function has to be executed again  |
|                            by the countries_info() function .         |
|                          0  if the function hasn't to be executed     |
|                            again by the countries_info() function .   |
\*---------------------------------------------------------------------*/
countries_info_choices(country)
int country;
{
int cnt,end=0,choice=0,returnvalue;
char *menu_items[]={"lJuJg,lJhj uJhlJm",
		    "hgJJJJsJJJ;JJJJhk",
		    "hgl,hv] hTrjwh]dm",
		    "hgJJJJuJJJJgJJJJl",
		    "hgkJaJJd] hgJ,'kd"};
char ch;

disable_cursor();cleardevice();row=1;   
			/* clear graphics screen after hiding the cursor */
frame_screen();         /* draw a frame around the screen */
setfillstyle(1,14);floodfill(2,40,15);
setfillstyle(1,15);floodfill(10,100,15);
setfillstyle(1,15);bar(5,3,634,31);
setcolor(6);rectangle(5,3,634,31);line(6,322,634,322);
arabic_text("hg],gm :",440,6,0,1);arabic_text(countries[country-1],330,6,0,1);
f1_message();           /* Write "Press F1 ... " in Arabic */
draw_map(country,225,35);       /* draw map of current country */
for(cnt=0;cnt<=4;cnt++)         /* for every menu item */
   arabic_text(menu_items[cnt],415,200+(22*cnt),0,1);   /* display the item */
reverse(190,200,443,220);               /* reverse first item */
enable_cursor();                        /* reshow mouse cursor */
while(end!=1)                   /* while user does not want to return back */
	{
	if(kbhit() || check_buttons()!=0)       
		{       /* if neither a key-press nor a button-click */
		ch=getch();     /* get a key */
		if (ch==0)      /* if an extended character */
			{
			ch=getch();     /* get SCAN code */
			if(ch!=F1)      /* if not F1 */
			   choice=menu(190,200,253,21,4,choice,ch,1);
					/* determine user's choice */
			else help(0);   /* otherwise, display help message */
			}
		else            /* if not an extended key */
		   switch(ch)
			{
			case ENTER:     /* if ENTER was pressed */
				enter_music();  /* play a tone */
				switch(choice)
				  {
				  case 0: /* General Information */
					  general_info(country);end=1; 
					  returnvalue=1;break;
				  
				  case 1: /* Population Information */
					  populations(country);end=1;
					  returnvalue=1;break;
				  
				  case 2: /* Financial Information */
					  petroleum(country);returnvalue=end=1;
					  break;
				  
				  case 3: /* Flag */
					  draw_flags(country);
					  end=returnvalue=1;break;
				  
				  case 4: /* Anthem */
					  anthems(country);break;
				  }
				break;
			  case ESC:     /* if ESC was pressed */
				esc_music();end=1;returnvalue=0;break;
			}
		}
	}
return(returnvalue);
}

/*---------------------- load_draw_array () ---------------------------*\
| This function opens a file and reads its contents and sends it to the |
| draw() to be drawn on the screen.                                     |
|               IN : filename : The filename of the file containing the |
|                               image array                             |
|               OUT: NONE                                               |
\*---------------------------------------------------------------------*/
load_draw_array(filename)
char *filename;
{
FILE *fptr;
int handle,array[250],array_length;
if((fptr=fopen(filename,"rb"))==NULL)   /* open the required file */
	file_error(filename);           /* exit on error */
handle=fileno(fptr);                    /* get file handler */
array_length=filelength(handle)/2;      /* get file length */
fread(array,2,array_length,fptr);       /* read array contents */
fclose(fptr);                           /* close file */
draw(array,array_length-1);             /* draw contents */
}

/*---------------------- general_info () ------------------------------*\
| This function displays some information about the active country .    |
| e.g. the capital , the area and so on and it calls the                |
| load_draw_array() to display the question mark image and after that   |
| it calls the wait_key_mouse() function then it returns.               |
|            IN : country : The active country's no.                    |
|            OUT: NONE                                                  |
\*---------------------------------------------------------------------*/
general_info(country)
int country;
{
long areas[]={1030000,446000,2381000,163000,1759000,1001000,2505000,22000,
	      637000,2149690,20770,10400,185180,91880,434920,17820,620,11000,
	      1016,212460,527970};      /* areas of countries */

char *bound1[]={"hg[.hzv , hgskyhg , hgwpvhx hgyvfdm","hg[.hzv , hgwpvhx hgyvfdm",
"gdfdh , lhgd , hgwpvhx hgyvfdm","hg[.hzv , gdfdh","hg[.hzv , jah] , lwv , hgkd[v",
"tgs'dk , gdfdh , hgs,]hk","Htvdrdh hg,s'd , jah] , lwv , Yed,fdh","Yed,fdh , hgw,lhg","[df,jd , Yed,fdh , ;dkdh",
"hguvhr , hGv]k , hg;,dj , ulhk","lwv , hGv]k , gfkhk , s,vdh","tgs'dk , s,vdh",
"hguvhr , tgs'dk , hGv]k , gfkhk","hguvhr , tgs'dk , hgsu,]dm , s,vdh",
"Ydvhk , hgsu,]dm , hGv]k , hg;,dj","hguvhr , hgsu,]dm","b d,[] Gkih [.dvm","hgsu,]dm , hTlhvhj","ulhk , hgsu,]dm , r'v",
"hgsu,]dm , hTlhvhj , hgdlk","ulhk , hgsu,]dm"}; /* first line of bounds text */

char *bound2[]={", lhgd",0,", l,vdjhkdh , j,ks , hglyvf , hgkd[v",0,", hgs,]hk , j,ks",
0,", ;dkdh ,gdfdh , H,yk]h , .hzdv",0,0,", r'v , hTlhvhj , hgdlk",0,0,", jv;dh",
0,", s,vdh , jv;dh",0,0,0,0,0,0};
char *capitals[]={"k,h;a,'","hgvfh'","hg[.hzv","j,ks","'vhfgs","hgrhivm",
"hgov',l","[df,jd","lr]da,","hgvdhq","hgr]s","fdv,j","]lar","ulhk","fy]h]","hg;,dj",
"hglkhlm","hg],pm","Hf, /fd","lsr'","wkuhx"}; /* 2nd line of bounds text */

char ruling_type[]={1,1,0,0,2,0,3,0,0,1,4,0,0,1,0,1,1,1,1,1,0};
			       /* governing system. Kingdom, Republic, ... */
char *ruling_text[]={"[li,vd","lg;d","[lhidvd","us;vd","b d,[] pde Hkih lpjgm"};
				/* text of governing systems */
struct dates {int day,month,year;};
struct dates contry[]={28,11,1960,2,3,1956,5,7,1962,20,3,1956,24,12,1951,
28,2,1922,1,1,1956,27,6,1977,1,6,1960,23,9,1932,0,13,0,22,11,1943,17,4,1946,
25,5,1946,3,10,1932,19,6,1961,15,8,1971,3,9,1971,2,10,1971,0,14,1650,30,11,1967};
char *months[]={"dkhdv","tfvhdv","lhvs","Yfvdg","lhd,","d,kd,","d,gd,","Hys's",
"sfjlfv","H;j,fv","k,tlfv","]dslfv","b d,[]","uhl"}; /* dates of ESTEKLAL */
char buff[10];

disable_cursor();                       /* hide mouse cursor */
getimage(225,35,399,177,letters);       /* get map image of country */
cleardevice();                          /* clear graphics screen */
frame_screen();setfillstyle(1,14);floodfill(10,10,15);
putimage(390,35,letters,COPY_PUT);      /* put map on screen */
load_letters();                         /* get letters info from heap */
setfillstyle(1,14);floodfill(10,10,15);
f1_message();                   /* Write : "press F1 ..." in Arabic */
ratiox=2.6;ratioy=1.9;positionx=50;positiony=25;setcolor(0);
load_draw_array("quesmark.dat");        /* draw a Question Mark */
ratio_fill(30,15,10,0,1);ratio_fill(30,70,2,0,1);
setfillstyle(1,15);bar(5,3,634,31);setcolor(6);rectangle(5,3,634,31);
line(6,189,634,189);line(308,189,308,31);line(6,322,634,322);
arabic_text("lug,lhj uhlm uk :",500,6,0,1);
arabic_text(countries[country-1],240,6,0,1);    /* write country name */
arabic_text("hguhwlm :",620,195,0,1);   /* write information titles */
arabic_text("hglshpm :         ;l",270,195,0,1);
arabic_text("k/hl hgp;l :",620,220,0,1);
arabic_text("jhvdo hTsjrbg :",620,245,0,1);
arabic_text("hgp],] :",620,270,0,1);
arabic_text(capitals[country-1],490,195,0,1);   /* write information */
arabic_text(ruling_text[ruling_type[country-1]],450,220,0,1);
arabic_text(bound1[country-1],490,270,0,1);
arabic_text(bound2[country-1],490,295,0,1);
if(contry[country-1].day!=0)    /* display ESTEKLAL date */
	{sprintf(buff,"%d",contry[country-1].day);
	 number_ltext(buff,400,245,1);}
arabic_text(months[contry[country-1].month-1],360,245,0,1);
if(contry[country-1].year!=0)
	{sprintf(buff,"%d",contry[country-1].year);number_ltext(buff,270,245,1);}
sprintf(buff,"%ld",areas[country-1]);number_ltext(buff,140,195,1); /* area */
enable_cursor();                        /* show mouse cursor */
wait_key_mouse();               /* pause for a key-press or a button-click */
}

/*frame_screen(): This function displays a frame around the screen by using
		  the rectangle() function
	    IN  : NONE
	    OUT : NONE*/
frame_screen()
{
setcolor(15);rectangle(1,1,639,349);rectangle(5,3,634,346);
setfillstyle(1,15);floodfill(2,2,15);
}

/*---------------------- draw_flags () --------------------------------*\
| This function displays three flags by calling the flags() function    |
| and then it starts moving one of them . The process of moving the     |
| flags is summarized as the following:                                 |
|               1- divide the flags into 5 equal parts                  |
|               2- display the parts alternativly one up 2 pixels and   |
|                  one down.                                            |
|       IN   : country: Active country's number                         |
|       OUT  : NONE                                                     | 
\*---------------------------------------------------------------------*/
draw_flags(country)
int country;
{
char ch;
int cnt,value=0,m=0,end=0;

disable_cursor();cleardevice(); /* hide cursor and clear screen */
frame_screen();                 /* draw a frame */
setfillstyle(1,14);floodfill(10,10,15);
f1_message();                   /* write "Press F1... " in Arabic */
setfillstyle(1,15);bar(5,3,634,31);setcolor(6);
rectangle(5,3,634,31);line(6,322,634,322);
arabic_text("ugl :",410,6,0,1);                 /* write "FLAG" in Arabic */
arabic_text(countries[country-1],330,6,0,1);    /* write country name */
setfillstyle(1,0);bar(222,64,224,290);
flags(country,225,200);                 /* draw flag */
for(cnt=0;cnt<=25;cnt++)                /* loop to raise the flag */
	{
	getimage(225,200-(cnt*5),405,295-(cnt*5),letters);
	putimage(225,195-(cnt*5),letters,COPY_PUT);
	}
load_letters();                         /* retrieve letters from heap */
flags(country,20,200);flags(country,430,200);   
				/* draw the flag twice at lower corners */
for(cnt=20;cnt<200;cnt+=30)     /* divide the flag into 5 stripes and get'em */
	getimage(cnt,195,cnt+30,295,&letters[811*((cnt-20)/30)]);
enable_cursor();                /* show cursor */
while(end!=1)                   /* while user doesn't want to return */
	{
	if(!kbhit() && check_buttons()==0)      /* while no keys or buttons */
		{
		if(m==0) m=1; else m=0;         /* up-down flag */
		for(cnt=225;cnt<405;cnt+=30)    /* Flying process of flag */
			{                       /* for each stripe */
			value=(cnt-225)/30;     /* get stripe number */
					   /* put the stripe in its place */
			if(m==0 && value%2)
				{disable_cursor();putimage(cnt,66,&letters[811*value],COPY_PUT);enable_cursor();delay(10);}
			else
				{if(m==0) {disable_cursor();putimage(cnt,67,&letters[811*value],COPY_PUT);enable_cursor();delay(10);}}
			if(m==1 && value%2)
				{disable_cursor();putimage(cnt,67,&letters[811*value],COPY_PUT);enable_cursor();delay(10);}
			else if(m==1)
				{disable_cursor();putimage(cnt,66,&letters[811*value],COPY_PUT);enable_cursor();delay(10);}
			}
		}
	else            /* if a key-press or button-click */
		{
		ch=getch();     /* get key */
		switch(ch)      
			{
			case ENTER: enter_music();end=1;break;
			case ESC: esc_music();end=1;break;
			case 0: ch=getch();     /* if extended key */
				if(ch!=59)      /* if not F1 */
				   {if((char)ch==-127) {enter_music();end=1;}}
				else            /* F1 */
					{
					load_letters();help(1);     /* display help message*/
					disable_cursor();           /* hide the mouse cursor */
					for(cnt=20;cnt<200;cnt+=30) /* get the flag in the array letters*/
						getimage(cnt,195,cnt+30,295,&letters[811*((cnt-20)/30)]);
					enable_cursor();            /* show the mouse cursor */
					}
				break;
			default: beep;
			}
		}
	}
load_letters();
}

/*---------------------- petroleum () ---------------------------------*\
| This function displays some information about the active country's    |
| economic resources calls the load_draw_array() to display the tree    |
| image and after that it calls the wait_key_mouse() function then it   |
| returns.                                                              |
|            IN : country : The active country's no.                    |
|            OUT: NONE                                                  |
\*---------------------------------------------------------------------*/
petroleum(country)
int country;
{
int petrol_production[]={0,5,55,450,521,434,0,0,0,1748,0,0,0,0,1120,700,40,
			 145,600,254,0};        /* production values */
char *exports[]={"hgp]d] hgohl , hgsl; hglpt,/","hGy`dm hglpt,/m , hgt,sthj",
"hgfjv,g , hgyh. hg'fdud","hgt,sthj , lkj[hj hgfjv,g","hgfjv,g , hgt,g hgs,]hkd",
"hgfjv,g , hgr'k","hgr'k , hgwly hguvfd","hg[g,] , hgri,m","hg[g,] , hGslh;",
"hgfjv,g","hgt,h;i , hglks,[hj","hglks,[hj , hgt,h;i","hgt,h;i , hglks,[hj",
"hGy`dm , hgt,sthj","hgfjv,g , hBbj , hgjlv","hgfjv,g","hgfjv,g , hGg,lkd,l",
"hgfjv,g , hGsl]m","hgfjv,g , hGslh;","hgfjv,g , hgkphs","hglks,[hj , hgfjv,g"};
char *imports[]={"hgfjv,g , hBbj hgerdgm","hg,r,]","hG],hj hGsjib;dm","hBbj hgwkhudm",
"hBbj , ,shzg hgl,hwbj","hBbj , hGoahf","hgfjv,g , hBbj","hgfjv,g , hglkj[hj hgy`hzdm",
"hglks,[hj , hgfjv,g","hGy`dm , hBbj","hBbj , hgfjv,g","hgfjv,g","hgfjv,g , hgluh]k",
"hglks,[hj , hgsdhvhj","hGy`dm","hGy`dm , hGsl]m","hBbj","hgl,h] hgy`hzdm , hgpd,hkhj",
"hGy`dm , hBbj","hBbj , ,shzg hgl,hwbj","hBbj hgerdgm , hglpv;hj"};
char *plants[]={"hgr'k , hg`vm hgvtdum","hgrlp , hgaudv","hgrlp , hgaudv","hgrlp , hg.dj,k",
"hgrlp , hgaudv , hg.dj,k","hgrlp , hg`vm , hGv. , hgr'k","hg`vm  hgvtdum , hgwly",
"b d,[]","hgl,. , hgr'k ,  hgt,g","hgrlp , hgjlv , hgth;im","hgrlp , hgaudv , hgr'k",
"hgth;im","hgrlp , hgaudv , hgr'k","hgrlp , hGa[hv hgljlvm","hgrlp , hgaudv , hgr'k",
"b d,[]","b d,[]","hgth;im , hgjlv","hgkodg","hgth;im , hgo,o , hgkodg",
"hg`vm , hg]ohk , hgr'k"};

char *metals[]={"hgp]d]","hgt,sthj , hgp]d]","hgt,sthj , hgp]d]","hgt,sthj , hgp]d]",
"lp],]m []h","hgp]d] , hgt,sthj , hglk[kd.","b d,[]","b d,[]","b d,[]","lp],]m []h",
"b d,[]","b d,[]","b d,[]","b d,[]","hgt,sthj","b d,[]","b d,[]","b d,[]",
"b d,[]","b d,[]","b d,[]","b d,[]"};
char *titles[]={"hTkjh[ lk hgfjv,g :","Hil hgl.v,uhj :","Hil hgluh]k :",
"Hil hgwh]vhj :","Hil hg,hv]hj :"};
char buf[15];
int end=0;

disable_cursor();                       /* hide cursor */
getimage(225,35,399,177,letters);       /* store map image */
cleardevice();                          /* clear screen */
frame_screen();setfillstyle(1,14);floodfill(10,10,15);
putimage(390,35,letters,COPY_PUT);load_letters(); /* draw map, get letters */
f1_message();                        /* Write "Press F1..." in Arabic */
ratiox=1.3;ratioy=0.8;positionx=50;positiony=25;setcolor(0);
load_draw_array("tree.dat");            /* draw a tree */
ratio_fill(80,40,10,0,9);ratio_fill(70,130,6,0,6);
setfillstyle(1,15);bar(5,3,634,31);setcolor(6);rectangle(5,3,634,31);
line(6,189,634,189);line(308,189,308,31);line(6,322,634,322);
arabic_text("hgl,hv] hTrjwh]dm td :",520,6,0,1);        /* screen title */
arabic_text(countries[country-1],220,6,0,1);            /* country name */
if((float)petrol_production[country-1]/10!=0)   
	{       /* if this country produces oil */
	sprintf(buf,"%.1f",(float)petrol_production[country-1]/10);
	load_letters();
	number_ltext(buf,340,200,1);
	arabic_text("lgd,k 'k",260,200,0,1);    /* write production value */
	}
else
	arabic_text("b d,[]",326,200,0,1);      /* otherwise, print "NONE" */
arabic_text(plants[country-1],390,225,0,1);     /* display plants info. */
arabic_text(metals[country-1],410,250,0,1);     /* print metals info. */
arabic_text(exports[country-1],410,275,0,1);    /* print exports */
arabic_text(imports[country-1],410,300,0,1);    /* print imports */
for(end=0;end<=4;end++)         /* a loop to print titles for information */
   arabic_text(titles[end],610,200+(25*end),0,1);
enable_cursor();                        /* show cursor */
wait_key_mouse();            /* wait till the user presss a key or a button */
}

/*---------------------- wait_key_mouse () ----------------------------*\ 
| This function waits for ENTER or ESC from the keyboard or the right   |
| or the left mouse buttons the keyboard's buffer is checked using      |
| kbhit() and the mouse button status is checked using the              |
| check_buttons() function .                                            |
|               IN  : NONE                                              |       
|               OUT : NONE                                              |
\*---------------------------------------------------------------------*/
wait_key_mouse()
{
int end=0;
char ch;
while(end!=1)                   /* while nothing was pressed */
	if (kbhit() || check_buttons()!=0)  /* if a key or button is pressed */
		switch(getch())
			{
			case ESC: esc_music();end=1;break;
			case 0:
				ch=getch();
				if(ch!=59)
					{if((char)ch==-127){enter_music();end=1;} else beep;}
				else help(1);
				break;
			case ENTER: enter_music();end=1;break;
			default: beep;
			}
}

/*---------------------- initialize_graph () --------------------------*\ 
| This function enters the computer into the graphics mode EGA 640*350  |
| 16 colours and it uses the registerbgidriver() to link the driver     |
| with the object so any one must use BGIOBJ.EXE to convert the driver  |
| to an object file then TLIB to add this object to any of the          |
| libraries which the program uses it such as GRAPHICS.LIB for example  |
|               IN  : NONE                                              |
|               OUT : NONE                                              |
\*---------------------------------------------------------------------*/
initialize_graph()
{
int gdriver=EGA,gmode=EGAHI,er;
closegraph();

registerbgidriver(EGAVGA_driver);       /* register driver */
initgraph(&gdriver,&gmode,"");          /* initialize graphics mode */
er=graphresult();                       /* get error status */
if (er!=grOk)                           /* if an error occured */
	{
	printf("%s",grapherrormsg(er)); /* display error message */
	exit(0);                        /* and exit to DOS */
	}
}

/*---------------------- help () --------------------------------------*\ 
| This function is responsible for displaying help messages. It copies  |
| the part of the screen in which the help message will be displayed to | 
| page no. 1 then it recopies it back to its place in page no. 0 after  |      
| the user reads th help message.                                       |
|     IN  : message : message no , It may be either 0 or 1              |
|     OUT : None .                                                      |       
\*---------------------------------------------------------------------*/    
help(message)
int message;
{
char *messages[]={"jpv; fhGsil H, fhgtHvm >","Yojv fJ     H, f.v hgtHvm hGdlk >",
"Hqy'     H, .v hgtHvm hGdsv","ggrhzlm hgshfrm >",
"Yqy'    H,     H, Hd lk H.vhv","hgtHvm hGdlk , hGdsv ggrhzlm","hgshfrm >"," "};
int enter_xs[]={398,357},enter_ys[]={120,98},esc_xs[]={440,448},
    esc_ys[]={142,98},i,end=0;

f1_music();                             /* play a tone */
save_letters();disable_cursor();  /* store letters in heap and hide cursor */
getimage(102,89,553,182,letters);       /* get background image */
setactivepage(1);putimage(102,89,letters,COPY_PUT);  /* store it on page 1 */
setactivepage(0);               /* now back to page 0 */
setfillstyle(1,6);bar(105,91,553,182);
setfillstyle(1,14);bar(102,89,550,180);
setcolor(0);rectangle(102,89,550,180);
load_letters();                 /* retrieve letters from heap */
for(i=0;i<=3;i++)               /* write message's text */
    arabic_text(messages[(message*4)+i],530,91+(22*i),0,1);
setcolor(4);
outtextxy(enter_xs[message],enter_ys[message],"Enter");
outtextxy(esc_xs[message],esc_ys[message],"Esc");
enable_cursor();                        /* show cursor */
while(end!=1)                           /* while user is reading */
	if (kbhit() || check_buttons()!=0) /* if user interrupts */
		switch(getch())
			{
			case ESC: esc_music();end=1;break;
			case 0: if((char)getch()==-127){enter_music();end=1;} else beep;
				break;
			case ENTER: enter_music();end=1;break;
			default: beep;
			}
disable_cursor();                       /* hide cursor */
setactivepage(1);getimage(102,89,553,182,letters);  /* retrive background */
setactivepage(0);putimage(102,89,letters,COPY_PUT);     /* put it back */
load_letters();                         /* retrieve letters from heap */
enable_cursor();                        /* show cursor */
}

/*---------------------- populations () -------------------------------*\ 
| This function displays the population information for the active      |
| country then it calls the draw_graph() function to display the        |
| population from 1980 to 2000 .                                        |        
|               IN    : country: active country's no.                   |
|               OUT   : NONE                                            |
\*---------------------------------------------------------------------*/
populations(country)
int country;
{
long population[][5]={1548,1996,2058,2122,2627,
		     19082,26182,26732,27293,31567,
		     18666,26022,26673,27339,32498,
		     6329,8276,8450,8627,9978,
		     3054,4351,4482,4616,5677,
		     40546,54452,55704,56986,66818,
		     19499,27220,28037,28878,35516,
		     355,346,355,364,436,
		     5352,6709,6930,7159,8986,
		     9372,17870,18621,19403,25878,
		     3896,4477,4544,4612,5119,
		     2669,3385,3432,3480,3836,
		     8704,12966,13459,13970,18138,
		     2181,3413,3556,3706,4942,
		     13043,19525,20286,21078,27551,
		     1370,2204,2283,2236,3030,
		     337,537,554,572,713,
		     229,518,545,574,824,
		     980,2390,2526,2670,3936,
		     984,1534,1588,1643,2091,
		     8843,10063,10385,10717,13361
		     }; /* population information */
float popgrowth[]={3.1,2.1,2.5,2.1,3.0,2.3,3.0,2.6,3.3,4.2,1.5,1.4,3.8,4.2,
		   3.9,3.6,3.2,5.3,5.7,3.5,3.2}; /* population growth */
int popdenisty[]={2,59,11,51,2,54,11,16,11,8,216,325,70,37,45,124,866,47,29,
		  7,19};        /* population densities */
char *years[]={"1980","1991","1992","1993","2000"},buf1[10],buf2[10],buf3[10];
int cnt;

disable_cursor();getimage(225,35,399,177,letters);cleardevice(); /* get map */
putimage(350,40,letters,COPY_PUT);load_letters();       /* put map */
setfillstyle(SOLID_FILL,14);setcolor(15);rectangle(3,3,632,346);
rectangle(1,1,635,349);floodfill(5,5,15);
rectangle(3,3,632,30);setfillstyle(SOLID_FILL,6);floodfill(5,5,15);
setcolor(0);rectangle(10,40,240,301);setfillstyle(SOLID_FILL,15);
floodfill(11,41,0);
setcolor(0);rectangle(350,40,524,182);line(3,322,632,322);
f1_message();                   /* write "press F1..." in Arabic */
arabic_text("hgs;hk fhGgt fdk",220,60,0,1);
arabic_text("uhld 0891 , 0002",220,85,0,1);
draw_graph(&population[country-1][0],15,300,150,30); /* draw pop. graph */
arabic_text("hgs;hk td :",470,5,0,2);   /* write title */
arabic_text(countries[country-1],300,5,0,1);    /* country name */
for(cnt=0;cnt<=4;cnt++)         /* for each year, write population */
	number_stext(years[cnt],40+(45*cnt),310,1);
sprintf(buf1,"%.3f",(float)population[country-1][3]/1000);
sprintf(buf2,"%.1f",popgrowth[country-1]); /* print 1993 population */
sprintf(buf3,"%i",popdenisty[country-1]);       /* print pop. density */
arabic_text("u]] hgs;hk :",610,215,0,1);number_ltext(buf1,440,215,1);
arabic_text("l kslm",350,215,0,1);
arabic_text("lu]g hgkl, hgs;hkd :",610,245,0,1);number_ltext(buf2,348,245,1);
arabic_text("hg;ehtm hgs;hkdm :",610,275,0,1);number_ltext(buf3,370,275,1);
arabic_text("kslm ;l",330,275,0,1);
number_stext("2",250,275,1);setcolor(0);
line(287,245,279,260);rectangle(287,259,288,260);rectangle(279,245,278,246);
enable_cursor();                        /* show cursor */
wait_key_mouse();                       /* wait till the user interrupts */
}

/*---------------------- draw_graph () --------------------------------*\ 
| This function draws the graph for five elements with a specified      |
| width , size and position . After it calculates the scale it calls    |
| the bar3d() function for displaying the graph .                       |
|       IN    : elements: the five elements of the array                |
|               x,y: position of the graph                              |
|               size:the length of pixels for the largest bar           |
|               width: the width of the bar                             |
|       OUT   : NONE                                                    |
\*---------------------------------------------------------------------*/
draw_graph(elements,x,y,size,width)
long elements[];
int x,y,size,width;
{
long cnt,length[5];
float largest=0;
int y1;
char buf[100];

for(cnt=0;cnt<=4;cnt++)                 /* calculate maximum value */
	if(elements[cnt]>largest)
		largest=elements[cnt];
largest/=size;                          /* maximum value per pixel */
for(cnt=0;cnt<=4;cnt++)      /* calculate length of every bar in pixels */
	length[cnt]=ceil(elements[cnt]/largest);
setcolor(0);
for(cnt=0;cnt<=4;cnt++)
	{               /* draw the 4 3-D bars */
	setfillstyle(SOLID_FILL,cnt+1);
	bar3d( x+((width*1.5)*cnt),(y-length[cnt]),
	       x+width+((width*1.5)*cnt),y,(width/4),1);
	}

for(cnt=0;cnt<=4;cnt++)
	{               /* write the value of every bar */
	sprintf(buf,"%ld",elements[cnt]);
	x=35+(45*cnt)+7;
	y1=y-length[cnt]-20;
	number_stext(buf,x,y1,1);
	}
}

/*---------------------- currencies () --------------------------------*\ 
| This function does the currency conversion . It at first get the two  |
| countries then it calculates each's ratio then it displays it with    |
| the country's currency's unit .                                       |
|       IN    : NONE                                                    |
|       OUT   : NONE                                                    |
\*---------------------------------------------------------------------*/
currencies()
{
float cur[]={81.45,8.50,22.10,0.90,0.280,3.33,90.00,177.72,2620,3.75,2.32,
	     879.0,20.25,0.68,0.31,0.29,0.38,3.64,3.67,0.39,12.95};
char *units[]={ "H,rdm","]vil","]dkhv","]dkhv","]dkhv","[kdi","[kdi","tvk;",
		"agk", "vdhg","ad;g","[kdi","[kdi","]dkhv","]dkhv","]dkhv",
		"]dkhv","vdhg","]vil","vdhg","vdhg"};
int country1,country2,value;
float money1,money2;
char buf[20];

country1=get_country("hojv hg],gm hG,gd");      /* chhose first country */
if (country1!=128)              /* if not get out! */
	{
	country2=get_country("hojv hg],gm hgehkdm"); /* get 2nd country */
	if(country2!=128)
		{
		money2=cur[country1-1]/cur[country2-1]; /* ratio 1 */
		money1=cur[country2-1]/cur[country1-1]; /* inverse ratio */
		disable_cursor();cleardevice();
		ratiox=2.5;ratioy=2;positionx=220;positiony=30;
		frame_screen();setfillstyle(1,14);floodfill(20,50,15);
		setcolor(0);load_draw_array("dollar.dat");/* draw a $ */
		ratio_fill(40,20,2,0,1);ratio_fill(40,7,2,0,1);
		ratio_fill(40,35,2,0,1);ratio_fill(40,53,2,0,1);
		ratio_fill(40,72,2,0,1);
		setcolor(0);setfillstyle(1,15);bar(5,5,635,30);
		rectangle(5,5,635,30);
		line(7,189,635,189);line(322,189,322,322);
		line(7,322,635,322);
		arabic_text("jp,dg ulbj",385,5,0,1);    /* print title */
		arabic_text(countries[country1-1],600,196,0,1);
		arabic_text(countries[country2-1],300,196,0,1);
		arabic_text(units[country1-1],450,220,0,1);
		arabic_text(units[country2-1],150,220,0,1);
		arabic_text(units[country1-1],450,244,0,1);
		arabic_text(units[country2-1],150,244,0,1);
		sprintf(buf,"%f",money2);number_ltext(buf,600,220,1);
		arabic_text(",hp]",300,220,0,1);
		sprintf(buf,"%f",money1);number_ltext(buf,300,244,1);
		arabic_text(",hp]",600,244,0,1);f1_message();
		draw_map(country1,425,40);draw_map(country2,40,40);
		enable_cursor();
		wait_key_mouse();
		}
	}
}

/*---------------------------------------------------------------------*\
| This function calculates the time differences by subtracting the      |
| difference from Greenwich of the 1st country from that of the second. |
| The differences from Greenwich are included in the array times[] then |
| it calls display_time() function to display the two analog watches at |
| the screen .                                                          |
|       IN     : NONE                                                   |
|       OUT    : NONE                                                   |
\*---------------------------------------------------------------------*/
time_zones()
{
int times[]={0,0,1,1,1,2,2,3,3,3,2,2,2,2,3,3,3,3,4,4,3}; 
					/* differences drom Greenwich */
int country1,country2,ch2,cm2,cs2,end=0,cnt;
char ch;
struct time t;

gettime(&t);                    /* read time of this comuter */
country1=get_country("Hojv hsl hg],gm hgjd j,[] fih");
				/* select home country */
if(country1!=128)               /* if the user doesn't want to cancel */
	{
	row=1;
	country2=get_country("Hojv hsl hg],gm hgjd jvd] luvtm j,rdjih");
					/* select other country */
	if (country2!=128)              /* if user wants to continue */
		{
		disable_cursor();       /* hide cursor */
		cleardevice();          /* clear screen */
		rectangle(1,1,630,348);
		rectangle(4,4,626,344);
		arabic_text(countries[country2-1],470,250,0,1); /* cntry1 */
		arabic_text(countries[country1-1],240,250,0,1); /* cntry2 */
		setcolor(15);setfillstyle(1,LIGHTGRAY);
			/*--- drawing the two analog watches ---*/
		circle(210,140,90);floodfill(210,140,15); 
		arabic_text("21",208,75,0,1);arabic_text("3",280,129,0,1);
		arabic_text("6",204,188,0,1);arabic_text("9",128,129,0,1);
		circle(410,140,90);setfillstyle(1,LIGHTGRAY);
		floodfill(410,140,15);
		arabic_text("21",408,75,0,1);arabic_text("3",480,129,0,1);
		arabic_text("6",404,188,0,1);arabic_text("9",328,129,0,1);
		number_stext("1",250,88,1);number_stext("2",274,107,1);
		number_stext("4",275,161,1);number_stext("5",248,181,1);
		number_stext("7",166,183,1);number_stext("8",141,162,1);
		number_stext("10",144,107,1);number_stext("11",169,88,1);
		number_stext("1",450,88,1);number_stext("2",474,107,1);
		number_stext("4",475,161,1);number_stext("5",448,181,1);
		number_stext("7",366,183,1);number_stext("8",341,162,1);
		number_stext("10",344,107,1);number_stext("11",369,88,1);
		enable_cursor();                /* show cursor */
		while(end!=1)                   /* while no user's interrupt */
			{
			if (!kbhit() && check_buttons()==0)
				{ /* if no keys or buttons were pressed */
				gettime(&t);    /* get current time */
				if((t.ti_min==0 || t.ti_min==15 
				   || t.ti_min==30 || t.ti_min==45) 
				   && t.ti_sec==0)
					/* every 15 minutes... */
					{sound(2000);delay(200);nosound();
					sound(2000);delay(600);nosound();}
						/* generate some tone */
				display_time(t.ti_hour,t.ti_min,t.ti_sec,150,
									100);
						/* show home time */
				t.ti_hour+=(times[country2-1]-times[country1-1]);
						/* increment by the difference */
				display_time(t.ti_hour,t.ti_min,t.ti_sec,350,100);
						/* show other time */
				}
			else                    /* on user's interrupt */
				switch(getch())
					{
					case ENTER:enter_music();end=1;break;
					case ESC:esc_music();end=1;break;
					case 0: ch=getch();
						if(ch!=F1)      /* if not F1 */
						{if((char)ch==-127) {enter_music();end=1;break;}}
						else help(1);   /* else help */
						break;
					default:beep;
					}
			}
		}
	}
}

/*---------------------- display_time () ------------------------------*\
| This function displays a watch with the time send to it the end       |
| positions of the line to seconds , hours and minutes are calculated   |
| using the cosine and sine (cos(),sin()) The watch is first displayed  |
| in page no 1. then it is copied to the page no 0                      |
|       IN      : h,m,s: hour,minutes,seconds for the time              |
|                 posx,posy:x,y coordinates of the watch in the screen  |
|       OUT     : NONE                                                  |
\*---------------------------------------------------------------------*/
display_time(h,m,s,posx,posy)
int h,m,s,posx,posy;
{
double am,ah,as,x1,y1;
int x,y;

setactivepage(1);                       /* switch to page 1 */
disable_cursor();                       /* hide cursor */
setcolor(LIGHTGRAY);setfillstyle(SOLID_FILL,LIGHTGRAY);bar(39,159,156,241);
enable_cursor();                        /* show cursor */
am=((m)*6.0)-90;                /* get the angle of the minutes in degrees */
ah=((h+(m/60.0))*30)-90;        /* get the angle of the houres in degrees */
as=((s)*6.0)-90;                /* get the angle of the seconds in degrees */
x1=cos(as*PI/180);x=ceil(53*x1);/* calculate x position of the end of seconds 
							pointer of the watch */
y1=sin(as*PI/180);y=ceil(43*y1);/* calculate y position of the end of seconds 
							pointer of the watch */
x+=100;y+=200;
disable_cursor();                       /* hide cursor */
setcolor(CYAN);line(100,200,x,y);       /* draw the pointer to seconds */
enable_cursor();                        /* show cursor */
x1=cos(am*PI/180);x=ceil(45*x1); /* and so on with the hours and the minutes 
								pointers*/
y1=sin(am*PI/180);y=ceil(35*y1);
x+=100;y+=200;
disable_cursor();                       /* hide cursor */
setcolor(BLUE);line(100,200,x,y);       /* draw pointer */
enable_cursor();                        /* show cursor */
x1=cos(ah*PI/180);x=ceil(35*x1);
y1=sin(ah*PI/180);y=ceil(25*y1);
x+=100;y+=200;
disable_cursor();                       /* hide cursor */
setcolor(GREEN);line(100,200,x,y);      /* show pointer */
setcolor(12);circle(100,200,3);setfillstyle(SOLID_FILL,12);
floodfill(100,200,12);
getimage(40,160,155,240,buffer);        /* get watch image from page 1 */
setactivepage(0);                       /* switch to page 0 */
putimage(posx,posy,buffer,COPY_PUT);    /* draw watch on page 0 */
enable_cursor();                        /* show cursor */
}

/*---------------------- get_country () -------------------------------*\
| This function starts by drawing the arab world's map by calling the   |
| draw_map() function then it waits for the user's choice of the        |
| available countries . Whenever the user moves to a country its colour |
| change on the map this is done using the paint_country() function .   |
|       IN    : message: pointer to the message displayed during getting| 
|                        user's choice .                                |
|       OUT   : NONE                                                    |
\*---------------------------------------------------------------------*/
get_country(message)
char *message;
{
int cnt,choice=0,oldchoice,oldrow,end=0,returnvalue=0,messagelen;
char ch;

row=1;
disable_cursor();                       /* hide cursor */
cleardevice();                          /* clear screen */
setcolor(15);rectangle(1,1,639,349);rectangle(5,3,635,346);
setfillstyle(1,15);floodfill(2,2,15);
setcolor(14);bar(5,138,635,163);setcolor(14);line(5,163,635,163);
messagelen=strlen(message)*12;          /* calculate mesage length in pixels */
arabic_text(message,630-((600-messagelen)/2),140,0,1); /* display message */
draw_map(22);                           /* draw Arab World map */
paint_country(1,RED);                   /* mark first country, MORITANIA */
for(cnt=2;cnt<=21;cnt++)                /* for all other countries ... */
   paint_country(cnt,YELLOW);           /* paint with ywllow */
for(cnt=0;cnt<=6;cnt++)                 /* write names of first 6 countries */
   arabic_text(countries[cnt],570,164+(cnt*22),0,1);
for(cnt=7;cnt<=13;cnt++)                /* write names of next 6 countries */
   arabic_text(countries[cnt],370,164+((cnt-7)*22),0,1);
for(cnt=14;cnt<=20;cnt++)               /* write names of last 6 countries */
   arabic_text(countries[cnt],170,164+((cnt-14)*22),0,1);
for(cnt=1;cnt<=7;cnt++)                 /* draw table */
   line(1,163+(22*cnt),640,163+(22*cnt));
f1_message();                   /* write "press F1 for help..." in Arabic */
line(215,164,215,317);line(425,164,425,317);
reverse(426,164,634,184);               /* highlight first country */
enable_cursor();                        /* show cursor */
while(end!=1)                   /* while user doesn't want to return */
	{
	if(kbhit() || check_buttons()!=0)       
	{               /* if a key or a button was pressed */
	ch=getch();                     /* read keyboard buffer */
	if (ch==0)                      /* if an extended key was pressed */
		{
		ch=getch();             /* get Scan code */
		if(ch!=F1)              /* if not F1 */
			{
			oldchoice=choice;oldrow=row;    /* mark old choice */
			choice=triple_menu(426,164,216,164,6,164,208,21,6,6,6,
								choice,ch,1);
					/* determine the new choice */
			if (oldchoice!=choice || oldrow!=row)
				{       /* if user moved hughlighting bar */
				sound(2000);delay(2);nosound(); /* tick */
				paint_country(((row-1)*7)+choice+1,RED);
							/* mark new country */
				paint_country(((oldrow-1)*7)+oldchoice+1,14);
							/* unmark old one */
				}
			}
		else help(0);   /* if user pressed F1, display help message */
		}
	else                    /* if not an extended key */
		switch(ch)
			{
			case ESC:esc_music();end=1;returnvalue=128;break;
				/* if ESC, return 128 */
			case ENTER:enter_music();end=1;
				   returnvalue=((row-1)*7+choice+1);break;
				   /* if ENTER, return number of country */
			default:beep;
			}
	}
	}       
return(returnvalue);    /* return number of selected country, or 128 if ESC */
}

/*---------------------- menu () --------------------------------------*\
| This function moves a menu bar with a specific width and coordinates  |
| returning the position of the bar among the choices. It has an        |
| advantage as it doesn't suspend the computer until the bar is moved   |
| and this enables doing any thing while the menu is displayed such as  |
| animating the map in the main menu or playing music .                 |
|   IN   :  xcord:  x coordinate of the menu                            |
|           ycord:  y coordinate of the menu                            |
|           width:  width of the menu                                   |
|           step:   no. of pixels betweem each choice and the next      |
|           itemsno:no. of items in the menu                            |
|           choice: current choice                                      |
|           excode: scan code of the key pressed                        |
|           stepping: the no. of pixels stepped between every item      |
|                     and another .                                     |
|   OUT  :  choice: current choice                                      |
\*---------------------------------------------------------------------*/
menu(xcord,ycord,width,step,itemsno,choice,excode,stepping)
int xcord,ycord,width,step,itemsno,choice,stepping;
char excode;
{
#define inverse_choice disable_cursor();reverse(xcord,ycord+(step*choice)+(stepping*choice),xcord+width,ycord+step+(step*choice)-1+(stepping*choice));enable_cursor()
union REGS r;
int mousex,mousey,cnt,old_choice,cntr;

switch(excode)                  
	{               /* examine the pressed key */
	case UP:        /* if UP arrow was pressed */
		if (choice!=0)          /* if old choice isn't the first */
		   {inverse_choice;choice--;inverse_choice;}    /* decrement */
		else {inverse_choice;choice=itemsno;inverse_choice;}
				/* otherwise, point to the last item */
		break;
	
	case DOWN:      /* if DOWN arrow was pressed */
		if (choice!=itemsno)    /* if old item isn't the last */
		   {inverse_choice;choice++;inverse_choice;}
		else            /* otherwise, point to the first item */
		   {inverse_choice;choice=0;inverse_choice;}
		break;
	
	case -127:      /* mouse button */
		mousex=get_mousex();mousey=get_mousey();
					/* get mouse coordinates */
		if (mousex>xcord && mousex<xcord+width)
			if(mousey>ycord && mousey<ycord+step+(step*itemsno))
			       /* if mouse is inside the specific rectangle */
				for(cnt=0;cnt<=itemsno;cnt++)   /* for each prvious item */
					if (mousey>ycord+(step*cnt)+(stepping*choice) && 
					    mousey<ycord+step+(step*cnt)+(stepping*choice))
						{       /* if mouse is inside that rectangle */
						inverse_choice;         /* highlight it */
						for(cntr=0;cntr<=6;cntr++)
							{
							choice=cnt;
							inverse_choice;
							delay(50);
							}
						/* insert in keyboard buffer */
						r.h.ah=5;               
						r.h.ch=0x1c;
						r.h.cl=0x0d;
						int86(0x16,&r,&r);
						}
		break;
	default:
		beep;
	}
return(choice);
}

/*---------------------- triple_menu () -------------------------------*\
| This function moves a menu bar among three rows it returns the choice |
| and sets the row number in the global variable row . It doesn't halt  |
| the computer until a key is pressed so that any thing is done while   |
| the menu is displayed such as music or animation. This function uses  |
| the function menu() in moving the bar within the row .                |
|          IN  : xleft1: first row x left coordinate                    |
|                ytop1:  first row y top coordinate                     |
|                xleft2: second row x left coordinate                   |
|                ytop2:  second row y top coordinate                    |
|                xleft3: third row x left coordinate                    |
|                ytop3:  third row y top coordinate                     |
|                width:  the width of the menu row                      |
|                step:   the no of pixels between each choice and the   |
|                        next to it                                     |
|                itemsno1: the no of items in row no. 1 of the menu     |
|                itemsno2: the no of items in row no. 2 of the menu     |
|                itemsno3: the no of items in row no. 2 of the menu     |
|                choice: current choice .                               |
|                excode: scan code of the key pressed                   |
|                stepping: the no. of pixels stepped between every item |
|                          and another .                                |
|          OUT : choice: the current choice whether the user has        |
|                        changed or not .                               |
\*---------------------------------------------------------------------*/
triple_menu(xleft1,ytop1,xleft2,ytop2,xleft3,ytop3,width,step,itemsno1,itemsno2,itemsno3,choice,excode,stepping)
int xleft1,ytop1,xleft2,ytop2,xleft3,ytop3,width,step,itemsno1,itemsno2,itemsno3,choice,stepping;
char excode;
{
#define row1_inverse disable_cursor();getimage(xleft1,ytop1+(step*choice)+(stepping*choice),xleft1+width,(ytop1+step-1)+(step*choice)+(stepping*choice),buffer);putimage(xleft1,ytop1+(step*choice)+(stepping*choice),buffer,NOT_PUT);enable_cursor()
#define row2_inverse disable_cursor();getimage(xleft2,ytop2+(step*choice)+(stepping*choice),xleft2+width,(ytop2+step-1)+(step*choice)+(stepping*choice),buffer);putimage(xleft2,ytop2+(step*choice)+(stepping*choice),buffer,NOT_PUT);enable_cursor()
#define row3_inverse disable_cursor();getimage(xleft3,ytop3+(step*choice)+(stepping*choice),xleft3+width,(ytop3+step-1)+(step*choice)+(stepping*choice),buffer);putimage(xleft3,ytop3+(step*choice)+(stepping*choice),buffer,NOT_PUT);enable_cursor()
int checked=0,xcord,ycord,itemsno,new_row=0,mousex,mousey;

if(excode==-127)
	{                       /* a mouse button */
	mousex=get_mousex();mousey=get_mousey();
	if(mousex>xleft1 && mousex<(xleft1+width) && mousey>ytop1 
	   && mousey<(ytop1+(step*(itemsno1+1))))
		{new_row=1;}
	if(mousex>xleft2 && mousex<(xleft2+width) && mousey>ytop2 
	   && mousey<(ytop2+(step*(itemsno2+1))))
		{new_row=2;}
	if(mousex>xleft3 && mousex<(xleft3+width) && mousey>ytop3 
	   && mousey<(ytop3+(step*(itemsno3+1))))
		{new_row=3;}
	if(row!=new_row) switch(new_row)
				{case 1: row1_inverse;break;
				case 2: row2_inverse;break;
				case 3: row3_inverse;break;}
	if(row!=new_row && row==1 && new_row!=0) {row1_inverse;}
	if(row!=new_row && row==2 && new_row!=0) {row2_inverse;}
	if(row!=new_row && row==3 && new_row!=0) {row3_inverse;}
	if(new_row!=0) row=new_row;
	}
if (excode==RIGHT)              /* if right arrow was pressed */
	{
	if(row==1)              /* if old row was right */
		{row=3;         /* new row is the left one */
		row1_inverse;           /* unmark right row */
		if(choice>itemsno3)     /* if we go behind last choice */
			choice=itemsno3;        /* point to last choice */
		row3_inverse;                   /* invert this choice */
		checked=1;}
		/* sets checked to 1 to avoid neutralizing the effect
		   of the statement by the statement next to it */
	
	if (row==2 && checked!=1)       /* if we were in middle column */
		{row=1;                 /* go to the right one */
		row2_inverse;           /* and unmark the middle */
		if(choice>itemsno1)     /* if we exceed the last item... */
			choice=itemsno1;        /* ... go up to it */
		row1_inverse;           /* and mark the right choice */
		checked=1;}             /* mark checked for next IF */
	
	if (row==3 && checked!=1)       /* if we were in left column */
		{row=2;                 /* go to middle column */
		row3_inverse;           /* unmark left row */
		if(choice>itemsno2)     /* if we exceed the last choice... */
			choice=itemsno2;        /* ...then go up to it */
		row2_inverse;           /* mark the chosen item */
		checked=1;}
	}
if (excode==LEFT)                       /* if Left arrow was pressed */
	{
	if(row==1)                      /* if we were in right column */
		{row=2;                 /* switch to the middle one */
		row1_inverse;           /* unmark the old choice */
		if(choice>itemsno2)     /* if we exceed the last choice ... */
			choice=itemsno2;        /* ... then go to it */
		row2_inverse;           /* mark the chosen item */
		checked=1;}             
		/* sets checked to 1 to avoid neutralizing the effect of the 
		   statement by the statement next to it                 */
	
	if (row==2 && checked!=1)       /* if we were in the middle column */
		{row=3;                 /* switch to the left one */
		row2_inverse;           /* unmark old choice */
		if(choice>itemsno3)     /* if we exceed the last choice */
			choice=itemsno3;        /* go to it */
		row3_inverse;           /* mark the new choice */
		checked=1;}             /* mark checked fot the next IF */
	
	if (row==3 && checked!=1)       /* if we were in the left column */
		{row=1;                 /* go to the right one */
		row3_inverse;           /* unmark old choice */
		if(choice>itemsno1)     /* if exceeded the last choice */
			choice=itemsno1;        /* go to it */
		row1_inverse;           /* mark the new choice */
		checked=1;}             /* mark checked */
	}

			   /*--  calculate coordinates --*/
if (row==1)
	{xcord=xleft1;ycord=ytop1;itemsno=itemsno1;}
if (row==2)
	{xcord=xleft2;ycord=ytop2;itemsno=itemsno2;}
if (row==3)
	{xcord=xleft3;ycord=ytop3;itemsno=itemsno3;}

if(checked!=1)
	choice=menu(xcord,ycord,width,step,itemsno,choice,excode,stepping);
else
	checked=0;

return(choice);
}

/*---------------------- clear () -------------------------------------*\
| This function clears an area of the screen which is specified by the  |
| calling function .                                                    |
|      IN    :   x1,y1 : represent the top left x,y coordinates of the  |
|                        area.                                          |
|                x2,y2 : represent the bottom right x,y coordinates of  |
|                        the area.                                      |
|      OUT   :   NONE .                                                 |
\*---------------------------------------------------------------------*/
clear(x1,y1,x2,y2)
int x1,y1,x2,y2;
{
setfillstyle(1,0);
setcolor(0);
bar(x1,y1,x2,y2);
}

/*---------------------- pain_country () ------------------------------*\
| This function paints a specific country by calling the ratio_fill()   |
| function with a specific coordinates and colour . The border is       |
| considered always as white.                                           |
|       IN      : NONE                                                  |
|       OUT     : NONE                                                  |
\*---------------------------------------------------------------------*/
paint_country(countryno,color)
int countryno,color;
{
disable_cursor();                       /* hide cursor */
switch(countryno)
{               /* examine country number */
case 1:ratio_fill(40,80,color,WHITE,SOLID_FILL);break;/*Muritania*/
case 2:ratio_fill(60,30,color,WHITE,SOLID_FILL);break;/*Moroco*/
case 3:ratio_fill(100,50,color,WHITE,SOLID_FILL);break;/*Algerie*/
case 4:ratio_fill(122,30,color,WHITE,SOLID_FILL);break;/*Tunisia*/
case 5:ratio_fill(150,60,color,WHITE,SOLID_FILL);break;/*Libia*/
case 6:ratio_fill(190,60,color,WHITE,SOLID_FILL);
       ratio_fill(204,54,color,WHITE,SOLID_FILL);break;/*EGYPT & Sinai*/
case 7:ratio_fill(190,120,color,WHITE,SOLID_FILL);break;/*Sudan*/
case 9:ratio_fill(270,134,color,WHITE,SOLID_FILL);break;/*Sumalia*/
case 8:ratio_fill(238,131,color,WHITE,SOLID_FILL);break;/*Gebuty*/
case 10:ratio_fill(250,80,color,WHITE,SOLID_FILL);break;/*Saudi Arabia*/
case 21:ratio_fill(270,105,color,WHITE,SOLID_FILL);break;/*Yemen*/
case 20:ratio_fill(295,80,color,WHITE,SOLID_FILL);break;/*Oman*/
case 19:ratio_fill(285,70,color,WHITE,SOLID_FILL);break;/*UAE*/
case 18:ratio_fill(269,70,color,WHITE,SOLID_FILL);break;/*Qatar*/
case 15:ratio_fill(240,45,color,WHITE,SOLID_FILL);break;/*Iraq*/
case 13:ratio_fill(220,35,color,WHITE,SOLID_FILL);break;/*Syria*/
case 14:ratio_fill(212,55,color,WHITE,SOLID_FILL);break;/*Jordan*/
case 11:ratio_fill(207,54,color,WHITE,SOLID_FILL);break;/*Phalastine*/
case 12:setfillstyle(1,color);floodfill(408,30,15);break;/*Lebnan*/
case 17:putpixel(479,51,color);break;/*Bahrain*/
case 16:ratio_fill(253,56,color,WHITE,SOLID_FILL);break;/*Kuwait*/
}
enable_cursor();                        /* show cursor */
}

/*---------------------- draw () --------------------------------------*\
| This function draws a picture which is divided into many lines with   |
| coordinates stored in the array argument with length in the argument  |
| size. The x and y scales must be sent in the global vaariables ratiox |
| and ratioy . The origin point x,y coordinates is stored in the global |
| variables positionx and position y .                                  |
| In this function if the coordinates are +ve a line is drawn from the  |
| current position to the point and if the coordinates are -ve the      |
| current position is changed to the coordinates without drawing , this |
| helps in drawing the non-continuous pictures .                        |
|       IN: array: array of coordinates of the points                   |
|           size: size of the array                                     |
|       OUT: NONE                                                       |
\*---------------------------------------------------------------------*/
draw(array,size)
int array[],size;
{
int count,x,y;

for (count=0;count<=size;count+=2)              /* for each point */
{
float result;
if ( (array[count]<0) && (array[count+1]< 0) )
{       /* if negative coordinaes , then move without drawing */
x=positionx+floor((-array[count])*ratiox);      /* calculate x-ccord. */
y=positiony+floor((-array[count+1])*ratioy);    /* calculate y-coord. */
moveto(x,y);}                                   /* move to there */

else                                    /* otherwise, draw */
   {
   x=positionx+floor(array[count]*ratiox);      /* calculate x-coord. */
   y=positiony+floor(array[count+1]*ratioy);    /* calculate y-coord. */
   lineto(x,y);}                                /* draw a line */
   }
}

/*---------------------- ratio_fill () --------------------------------*\
| This function paints a specific area but it differs from the          |
| floodfill() function that the coordinates of the place is calculated  |
| using the x,y scales in the global variables ratiox and ratioy and it |
| paints starting from the origin point with coordinates positionx and  |
| positiony .                                                           |
|       IN    : xcord,ycord: x,y coordinates of the place to paint      |
|               color: the colour to paint with.                        |
|               border: the border                                      |
|               pattern: The fill pattern .                             |
|               See floodfill() and setfillstyle() for more information |
|               about the border and thepattern arguments .             |
|       OUT   : NONE                                                    |
\*---------------------------------------------------------------------*/
ratio_fill(xcord,ycord,color,border,pattern)
int xcord,ycord,color,border,pattern;
{
setfillstyle(pattern,color);
xcord=positionx+floor(xcord*ratiox);
ycord=positiony+floor(ycord*ratioy);
floodfill(xcord,ycord,border);
}

/*---------------------- number_stext () ------------------------------*\
| This function writes a number from right to left in arabic This is    |
| done by using the putimage() function in the numbers array. First the |
| function checks if the array is loaded with the numbers array and if  |
| it isn't it calls the num_init() function to load it then it starts a |
| loop to the length of the numbers string and starts displaying the    |       
| numbers images.                                                       |
|       IN      : buf: The pointer to the string containing the number. |
|                 x,y: x,y coords for the number to be displayed        |
|                 put: The put which will be send to the putimage()     |
|       OUT     : NONE                                                  |
\*---------------------------------------------------------------------*/
number_stext(buf,x,y,put)
char buf[10];
int x,y,put;
{
int cnt,i,foundin;
char num[]={'0','1','2','3','4','5','6','7','8','9','0'};

if (numinit!=1)                 /* if numbers were not read from disk... */
	num_init();             /* ... then read their data from file */

for(cnt=strlen(buf)-1;cnt>=0;cnt--)     /* for each digit in the buffer */
	{
	for(i=0;i<=9;i++)                       /* determine the nnumber */
		{if(buf[cnt]==num[i])
			foundin=i;
		}
	putimage(x,y,&numbers[39*foundin],put); /* display Hindi number */
	x-=7;                   /* decrement coordinate by 7, width of num */
	}
}

/*---------------------- num_init () ----------------------------------*\
| This function opens the file "smallfon.dat" and read its contents in  |
| the array numbers . This file contains the arrays of the images of    |
| the small font of the arabic numerals                                 |
|       IN  : NONE                                                      |
|       OUT : NONE                                                      |
\*---------------------------------------------------------------------*/
num_init()
{
FILE *f;

if((f=fopen("smallfon.dat","rb"))==NULL)        /* try to open SMALLFON.DAT */
	file_error("smallfon.dat");             /* tell the user if error */
fread(numbers,2,390,f);                         /* read numbers into array */
fclose(f);                                      /* close file */
numinit=1;                    /* indicates that numbers were read from file */
}

/*---------------------- number_ltext () ------------------------------*\
| This function uses the arabic_text() function to display arabic       |
| numerals in a direction from right to left  .                         |
|       IN      : buf: The pointer to the string containing the number. |
|                 x,y: x,y coords for the number to be displayed        |
|                 put: The put which will be send to the putimage()     |
|       OUT     : NONE                                                  |
\*---------------------------------------------------------------------*/
number_ltext(buf,x,y,put)
char buf[20];
int x,y,put;
{
char buf1[20];
int cnt;
			/*--- reverse digits order ---*/
for(cnt=0;cnt<=strlen(buf)-1;cnt++)     /* for each character in buf */
	{if(buf[cnt]=='.')              /* if char is '.' */
		buf[cnt]='>';           /* change to its Arabic equivalent */
	buf1[strlen(buf)-1-cnt]=buf[cnt];}
buf1[strlen(buf)]='\x0';                /* terminating character */
arabic_text(buf1,x,y,0,put);            /* display number */
}

/*---------------------- save_letters () ------------------------------*\
| This function copies the array letters to far memory if the memory is |
| available and this is checked through the variable slow which is set  |
| on to (1) in the main() function and if the far memory isn't          |
| available it does. nothing.                                           |
|       IN      : NONE                                                  |
|       OUT     : NONE                                                  |
\*---------------------------------------------------------------------*/
save_letters()
{
int i;

if(slow!=1)    /* if we are not in the slow mode, ie. letters are in memory */
for(i=0;i<=17748;i++)   /* for each character in letters[] array */
   *(pt+i)=letters[i];  /* copy it to heap */
}

/*---------------------- load_letters () ------------------------------*\
| This function copies the memory at the offset *pt to the letters[]    |
| array and this memory contains the array of the arabic letters and if |
| the memory wasn't available and the save_letters function hasn't      |
| copied the letters[] array to the memory it sets the global variable  |
| (init16) to (0) which will cause the arabic_text() function to load   |
| the arabic letters array from the file letdat.16c and this needs more |
| time than copying it from memory so, the program is in the slow mode. |
|       IN       : NONE.                                                |
|       OUT      : NONE.                                                |
\*---------------------------------------------------------------------*/
load_letters()
{
int i;
if(slow!=1)                     /* if not in slow mode */
for(i=0;i<=17748;i++)           /* for each charcater in heap */
	letters[i]=*(pt+i);             /* copy it in letters[] */
else
	init16=0;            /* else mark that characters are not in array */
}

/*---------------------- enter_music () -------------------------------*\
| This function plays the music when ENTER is pressed.                  |
|       IN      : NONE                                                  |
|       OUT     : NONE                                                  |
\*---------------------------------------------------------------------*/
enter_music()
{
play("ml o5 l32 a b c d e d a c",0);
}

/*---------------------- esc_music () ---------------------------------*\
| This function plays the music when ESC is pressed.                    |
|       IN     : NONE                                                   |
|       OUT    : NONE                                                   |
\*---------------------------------------------------------------------*/
esc_music()
{
play("ml o5 l32 f c d a b c d f",0);
}

/*---------------------- f1_music () ----------------------------------*\
| This function plays the music when F1 is pressed.                     |
|       IN   : NONE                                                     |
|       OUT  : NONE                                                     |
\*---------------------------------------------------------------------*/
f1_music()
{
play("ml l20 o5 a b d a c d f",0);
}

/*---------------------- file_error () --------------------------------*\
| This function displays an error message indicating that an error      |
| occured while opening a file.                                         |
|         IN  : fn: pointer to the filename                             |
|         OUT : NONE                                                    |
\*---------------------------------------------------------------------*/
file_error(fn)
char *fn;
{
closegraph();                   /* switch back to text mode */
printf("\nAn error occured while opening \"%s\" .",fn);
printf("\nCheck and rerun ....\n");
exit(2);                        /* exit with errorlevel of 2 */
}

/*---------------------- reverse () -----------------------------------*\
| This function reverses the colour of a portion of the screen.         |
|       IN : x1,y1:start x,y coordinates of the area                    |
|            x1,y2:end x,y coordinates of the area                      |
|       OUT: NONE                                                       |
\*---------------------------------------------------------------------*/
reverse(x1,y1,x2,y2)
int x1,y1,x2,y2;
{
getimage(x1,y1,x2,y2,buffer);                   /* get the image */
putimage(x1,y1,buffer,NOT_PUT);                 /* put it reversed */
}

/*---------------------- clear_buffer () ------------------------------*\
| This function checks the keyboard's buffer and emptys it.             |
|       IN        : NONE                                                |
|       OUT       : NONE                                                |
\*---------------------------------------------------------------------*/
clear_buffer()
{
while (kbhit())                 /* while the buffer isn't empty... */
	getch();                        /* ... remove a character from it */
}

/*---------------------- draw_map () ----------------------------------*\
| This function opens the file maps.dat and read its contents in arrays |
| and then it starts drawing the country sending this arrays to the     |
| draw() function and painting either with the ratio_fill() or the      |
| floodfill() function. In this function all the drawing are done in    |
| page no.1 and the final image is copied to page 0 using the getimage()|
| in page 1 and putimage() in page 0 . switching between the two pages  |
| is done using the setactivepage() function .                          |
|       IN   :  country: The country no.                                |
|               cx,cy: The x,y coordinates in which the final image of  |
|                      the map will be put                              |
|       OUT  : NONE                                                     |
\*---------------------------------------------------------------------*/
draw_map(country,cx,cy)
int country,cx,cy;
{
int africa[208], europe[146], africa2[56], asia[142], afcountries[244],
ascountries[122], dgibuty[110],phl_jord[142],lebnan[70],kuwait[108],
qatar_bahr[192];
int x,y,get_or_not=1,i;
FILE *fptr;

if((fptr=fopen("mapdataa","rb"))==NULL) /* try to open the MAPDATAA file */
	file_error("map1.dat"); /* on error, tell the user and exit */
		
		/*--- read data from file to arrays ---*/
fread(africa,2,208,fptr);fread(europe,2,146,fptr);      
fread(africa2,2,56,fptr);fread(asia,2,142,fptr);fread(afcountries,2,244,fptr);
fread(ascountries,2,122,fptr);fread(dgibuty,2,110,fptr);
fread(phl_jord,2,142,fptr);fread(lebnan,2,70,fptr);fread(kuwait,2,108,fptr);
fread(qatar_bahr,2,192,fptr);
fcloseall();                    /* close file */
setactivepage(1);cleardevice();         /* switch to page 1 */
setlinestyle(0,1,1);setcolor(15);
switch (country)        
	{               /* which country you want its map? */
	case 1: ratiox=2.5;ratioy=2;positionx=positiony=0;
		draw(africa,sizeof(africa)/2-1);
		draw(afcountries,sizeof(afcountries)/2-1);
		paint_country(2,14);paint_country(3,14);
		floodfill(60,110,15);
		paint_country(1,RED);
		rectangle(0,74,174,216);
		setfillstyle(1,14);floodfill(140,180,15);
		setfillstyle(1,LIGHTBLUE);floodfill(1,75,15);
		x=0;y=74;
		break;
	case 2: ratiox=2.5;ratioy=2;positionx=positiony=0;x=40;y=6;
		draw(africa,sizeof(africa)/2-1);draw(afcountries,sizeof(afcountries)/2-1);
		paint_country(2,RED);paint_country(3,14);
		paint_country(1,14);setfillstyle(1,14);floodfill(60,110,15);
		rectangle(40,6,214,216-68);setfillstyle(1,LIGHTBLUE);floodfill(41,7,15);
		setfillstyle(1,14);floodfill(150,140,15);
		break;
	case 3: ratiox=2;ratioy=1.6;positionx=positiony=0;x=90;y=12;
		draw(africa,sizeof(africa)/2-1);
		draw(afcountries,sizeof(afcountries)/2-1);
		paint_country(1,14);paint_country(1,14);paint_country(3,RED);
		paint_country(4,14);paint_country(5,14);
		rectangle(90,12,90+174,12+216-74);
		setfillstyle(1,14);floodfill(140,40,15);floodfill(130,130,15);
		floodfill(91,70,15);setfillstyle(1,LIGHTBLUE);
		floodfill(120,20,15);
		break;
	case 4: ratiox=4;ratioy=3;positionx=positiony=0;x=426;y=32;
		draw(africa,sizeof(africa)/2-1);
		draw(afcountries,sizeof(afcountries)/2-1);
		paint_country(4,RED);paint_country(5,14);paint_country(3,14);
		rectangle(426,32,426+174,32+216-74);
		setfillstyle(1,LIGHTBLUE);floodfill(427,33,15);
		break;
	case 5: ratiox=2.5;ratioy=2;positionx=positiony=0;
		draw(africa,sizeof(africa)/2-1);
		draw(afcountries,sizeof(afcountries)/2-1);
		paint_country(5,RED);paint_country(4,14);paint_country(3,14);
		rectangle(276,66,276+174,208);
		setfillstyle(1,9);floodfill(410,70,15);
		setfillstyle(1,14);floodfill(440,130,15);
		setfillstyle(1,14);floodfill(440,190,15);
		setfillstyle(1,14);floodfill(360,190,15);
		x=276;y=66;
		break;
	case 6: ratiox=2.7;ratioy=2;positionx=positiony=0;
		draw(africa2,sizeof(africa2)/2-1);
		draw(africa,sizeof(africa)/2-1);
		draw(asia,sizeof(asia)/2-1);
		draw(ascountries,sizeof(ascountries)/2-1);
		draw(afcountries,sizeof(afcountries)/2-1);
		paint_country(5,14);paint_country(6,4);paint_country(7,14);
		rectangle(429,59,603,201);
		paint_country(11,14);paint_country(13,14);paint_country(14,14);
		setfillstyle(1,14);floodfill(511,63,15);floodfill(539,63,15);
		floodfill(569,77,15);floodfill(600,87,15);floodfill(595,126,15);
		floodfill(434,196,15);floodfill(574,61,15);
		setfillstyle(1,9);floodfill(574,161,15);floodfill(525,84,15);
		x=429;y=59;
		break;
	case 7: ratiox=2;ratioy=1.6;positionx=positiony=0;
		draw(africa2,sizeof(africa2)/2-1);
		draw(africa,sizeof(africa)/2-1);
		draw(afcountries,sizeof(afcountries)/2-1);
		rectangle(294,134,468,276);
		setfillstyle(1,14);floodfill(308,161,15);floodfill(315,140,15);floodfill(350,140,15);
		setfillstyle(1,9);floodfill(441,147,15);
		paint_country(7,4);
		x=294;y=134;
		break;
	case 8: ratiox=2.2;ratioy=1.7;positionx=positiony=0;
		draw(dgibuty,sizeof(dgibuty)/2-1);
		rectangle(20,6,194,148);
		setfillstyle(1,4);floodfill(147,35,15);setfillstyle(1,14);floodfill(49,21,15);
		setfillstyle(1,9);floodfill(182,14,15);
		x=20;y=6;
		break;
	case 9: ratiox=2.5;ratioy=2;positionx=-100;positiony=-50;
		draw(africa2,sizeof(africa2)/2-1);
		draw(africa,sizeof(africa)/2-1);
		draw(afcountries,sizeof(afcountries)/2-1);
		rectangle(460,178,460+174,320);
		setfillstyle(1,9);floodfill(539,189,15);setfillstyle(1,4);floodfill(539,224,15);
		setfillstyle(1,14);floodfill(504,210,15);floodfill(483,210,15);
		x=460;y=178;
		break;
	case 10:ratiox=2;ratioy=1.6;positionx=-200;positiony=0;
		draw(africa2,sizeof(africa2)/2-1);
		draw(africa,sizeof(africa)/2-1);
		draw(asia,sizeof(asia)/2-1);
		draw(ascountries,sizeof(ascountries)/2-1);
		draw(afcountries,sizeof(afcountries)/2-1);
		paint_country(10,4);
		paint_country(13,14);paint_country(16,14);paint_country(18,14);
		paint_country(19,14);paint_country(20,14);paint_country(21,14);
		paint_country(15,14);rectangle(220,52,394,194);
		setfillstyle(1,9);floodfill(350,105,15);floodfill(371,175,15);floodfill(245,161,15);
		setfillstyle(1,14);floodfill(364,63,15);floodfill(224,63,15);
		floodfill(224,168,15);floodfill(224,140,15);floodfill(245,182,15);
		x=220;y=52;
		break;
	case 11:ratiox=1.3;ratioy=1.3;positionx=100;positiony=0;
		draw(phl_jord,sizeof(phl_jord)/2-1);
		x=65;y=24;rectangle(65,24,239,166);
		setfillstyle(1,14);floodfill(112,112,15);floodfill(161,112,15);
		floodfill(217,98,15);floodfill(189,49,15);floodfill(153,28,15);
		setfillstyle(1,9);floodfill(154,84,15);floodfill(133,35,15);
		setfillstyle(1,4);floodfill(140,84,15);
		break;
	case 12:ratiox=4;ratioy=3;positionx=100;positiony=100;
		rectangle(100,140,274,282);
		draw(lebnan,sizeof(lebnan)/2-1);
		setfillstyle(1,14);floodfill(245,245,15);
		setfillstyle(1,4);floodfill(231,189,15);
		setfillstyle(1,9);floodfill(147,196,15);
		x=100;y=140;
		break;
	case 13:ratiox=5;ratioy=5;positionx=-620;positiony=0;
		draw(africa,207);draw(europe,145);draw(africa2,56);draw(asia,141);
		draw(afcountries,243);draw(ascountries,121);
		putpixel(424,210,15);line(426,244,430,244);
		x=385;y=116;paint_country(14,14);paint_country(15,14);
		rectangle(385,116,559,258);setfillstyle(1,9);floodfill(413,182,15);
		setfillstyle(1,4);floodfill(434,217,15);setfillstyle(1,14);floodfill(490,252,15);floodfill(434,203,15);
		floodfill(420,252,15);floodfill(455,133,15);
		break;
	case 14:ratiox=1.4;ratioy=1.2;positionx=0;positiony=100;
		draw(phl_jord,141);
		x=14;y=119;rectangle(14,119,218,261);
		setfillstyle(1,14);floodfill(21,217,15);
		floodfill(35,203,15);floodfill(36,257,15);floodfill(119,252,15);
		setfillstyle(1,9);floodfill(28,147,15);floodfill(57,182,15);
		setfillstyle(1,4);floodfill(98,224,15);
		break;
	case 15:ratiox=4;ratioy=4;positionx=-420;positiony=0;
		draw(asia,141);draw(ascountries,112);
		x=456;y=98;rectangle(456,98,630,240);
		setfillstyle(1,14);floodfill(476,140,15);floodfill(462,182,15);
		floodfill(476,217,15);floodfill(476,105,15);floodfill(495,217,15);
		floodfill(581,238,15);floodfill(606,238,15);
		setfillstyle(1,9);floodfill(623,231,15);setfillstyle(1,4);floodfill(567,203,15);
		break;
	case 16:ratiox=1.4;ratioy=1.1;positionx=100;positiony=100;x=113;y=110;
		draw(kuwait,107);
		rectangle(113,110,287,252);
		setfillstyle(1,14);floodfill(140,154,15);floodfill(140,224,15);
		setfillstyle(1,4);floodfill(196,175,15);
		setfillstyle(1,9);floodfill(226,182,15);
		break;
	case 17:ratiox=2.7;ratioy=2.25;positionx=100;positiony=100;x=103;y=95;
		draw(qatar_bahr,sizeof(qatar_bahr)/2-1);
		rectangle(103,95,277,237);
		setfillstyle(1,14);floodfill(119,217,15);floodfill(252,217,15);
		setfillstyle(1,9);floodfill(189,217,15);
		setfillstyle(1,4);floodfill(175,140,15);
		break;
	case 18:ratiox=1.4;ratioy=1.1;positionx=100;positiony=100;x=113;y=90;
		draw(qatar_bahr,sizeof(qatar_bahr)/2-1);
		rectangle(113,90,287,232);
		setfillstyle(1,14);floodfill(140,112,15);floodfill(133,203,15);
		setfillstyle(1,4);floodfill(175,203,15);
		setfillstyle(1,9);floodfill(161,112,15);
		break;
	case 19:ratiox=3.4;ratioy=3.1;positionx=-500;positiony=-100;x=404;y=78;
		draw(asia,141);draw(ascountries,122);
		rectangle(404,78,578,220);
		paint_country(19,4);paint_country(20,14);paint_country(18,14);
		setfillstyle(1,14);floodfill(482,104,15);floodfill(441,91,15);
		floodfill(441,217,15);floodfill(434,196,15);
		setfillstyle(1,9);floodfill(441,112,15);
		break;
	case 20:ratiox=3.4;ratioy=3.1;positionx=-500;positiony=-100;x=434;y=112;
		draw(asia,141);draw(ascountries,122);
		rectangle(434,112,608,254);paint_country(19,14);paint_country(20,4);
		setfillstyle(1,9);floodfill(441,119,15);floodfill(518,119,15);
		setfillstyle(1,14);floodfill(455,154,15);
		line(457,224,457,227);floodfill(448,224,15);
		break;
	case 21:ratiox=3.2;ratioy=3;positionx=-500;positiony=-100;x=245;y=182;
		draw(asia,141);draw(ascountries,122);
		rectangle(245,182,419,324);
		line(401,215,401,217);line(266,231,268,231);
		setfillstyle(1,14);floodfill(259,203,15);floodfill(413,203,15);
		setfillstyle(1,9);floodfill(266,301,15);
		paint_country(21,4);
		break;
	case 22:get_or_not=0;setactivepage(0);
		ratiox=1.3;ratioy=0.75;positionx=135;positiony=1;setcolor(15);
		draw(africa,207);draw(europe,146);draw(africa2,55);draw(asia,141);
		draw(afcountries,243);draw(ascountries,122);rectangle(104,1,539,139);rectangle(105,2,539,138);ratio_fill(90,120,BROWN,WHITE,SOLID_FILL);
		ratio_fill(225,120,BROWN,WHITE,SOLID_FILL);ratio_fill(30,55,14,WHITE,SOLID_FILL);
		ratio_fill(290,10,15,WHITE,SOLID_FILL);ratio_fill(170,5,15,WHITE,SOLID_FILL);
		ratio_fill(136,4,15,WHITE,SOLID_FILL);ratio_fill(124,7,15,WHITE,SOLID_FILL);
		ratio_fill(80,10,15,WHITE,SOLID_FILL);ratio_fill(137,24,15,WHITE,SOLID_FILL);
		ratio_fill(10,10,LIGHTBLUE,WHITE,SOLID_FILL);ratio_fill(210,75,LIGHTBLUE,WHITE,SOLID_FILL);
		break;
	}
if(get_or_not==1)   /* if the map is required to be copied to page 0 */
	{               
	save_letters();                 /* copy letters information to heap */
	getimage(x,y,x+174,y+142,letters);      /* get map from page 1 */
	setactivepage(0);                       /* switch to page 0 */
	putimage(cx,cy,letters,COPY_PUT);       /* put the map on page 0 */
	rectangle(cx,cy,cx+174,cy+142);         /* draw a frame around it */
	load_letters();                         /* restore letters from heap */
	}
}

/*---------------------- flags () -------------------------------------*\
| This function draws the flags of the specified country . I noticed    |
| that the arabian flags have many common features such as having stars |
| and cresents so I wrote some functions that are used all over the     |
| arabian flags and these functions are triangle(), v_cresent(),        |
| h_cresent(), draw_star() and as for the exceptions such as the flags  |
| of Saudi arabia I draw the flag using the draw() function with the    |
| suitable data .                                                       |
|       IN: country: the country's no. of which the flag will be drawn  |
|           x,y: x,y coordinates of the place where the flag will be    |
|                drawn                                                  |
|       OUT: NONE                                                       |
\*---------------------------------------------------------------------*/
flags(country,x,y)
int country,x,y;
{
int cnt;

setlinestyle(0,1,1);
clear(x,y,x+180,y+90);                  /* clear flag's portion on screen */
setcolor(15);rectangle(x,y,x+180,y+90); /* draw frame of flag */
switch(country)
	{               /* which country do you want its flag? */
	case 1: setcolor(14);
		rectangle(x,y,x+180,y+90);
		draw_star(x+80,y+25,14,14);
		h_cresent(x+80,y+25,14);
		setfillstyle(1,GREEN);floodfill(x+1,y+1,14);
		break;
	case 2:
		setcolor(14);
		rectangle(x,y,x+180,y+90);
		draw_star(x+80,y+32,RED,14);
		setfillstyle(1,RED);floodfill(x+1,y+1,14);
		break;
	case 3:
		v_cresent(x+90,y+30,RED,RED);
		draw_star(x+90,y+36,RED,RED);
		putpixel(x+91,y+31,RED);
		putpixel(x+91,x+63,RED);
		line(x+90,y,x+90,y+90);
		rectangle(x,y,x+180,y+90);
		setfillstyle(1,GREEN);floodfill(x+2,y+3,RED);setcolor(GREEN);
		floodfill(x+89,y+40,RED);setfillstyle(1,15);floodfill(x+91,y+2,RED);
		line(x+90,y,x+90,y+29);line(x+90,y+65,x+90,y+90);line(x+90,y+34,x+90,y+58);
		break;
	case 4:
		setcolor(RED);
		rectangle(x,y,x+180,y+90);
		v_cresent(x+87,y+30,RED,RED);
		draw_star(x+87,y+36,RED,RED);
		circle(x+91,y+47,30);
		setfillstyle(1,RED);floodfill(x+1,y+1,RED);
		setfillstyle(1,15);floodfill(x+84,y+50,RED);
		break;
	case 5:
		setcolor(GREEN);
		rectangle(x,y,x+180,y+90);
		setfillstyle(1,GREEN);floodfill(x+1,y+1,GREEN);
		break;
	case 6:
		setcolor(15);
		rectangle(x,y,x+180,y+90);
		line(x,y+30,x+180,y+30);
		line(x,y+60,x+180,y+60);
		setfillstyle(1,RED);floodfill(x+1,y+1,15);
		setfillstyle(1,15);floodfill(x+1,y+31,15);
		setfillstyle(1,0);floodfill(x+1,y+61,15);
		break;
	case 7:
		triangle(x,y,GREEN,15);
		line(x+39,y+30,x+180,y+30);
		line(x+39,y+60,x+180,y+60);
		setfillstyle(1,RED);floodfill(x+20,y+1,15);
		setfillstyle(1,WHITE);floodfill(x+80,y+32,15);
		setfillstyle(1,0);floodfill(x+40,y+61,15);
		break;
	case 8:
		setcolor(15);
		rectangle(x,y,x+180,y+90);
		triangle(x,y,15,15);
		line(x,y+45,x+180,y+45);
		setfillstyle(1,GREEN);floodfill(x+50,y+1,15);
		setfillstyle(1,BLUE);floodfill(x+50,y+50,15);
		draw_star(x+10,y+36,RED,RED);
		break;
	case 9:
		draw_star(x+80,y+32,15,15);
		setfillstyle(1,LIGHTBLUE);
		floodfill(x+1,y+1,15);
		break;
	case 10:
		setcolor(GREEN);
		rectangle(x,y,x+180,y+90);
		setfillstyle(1,GREEN);floodfill(x+1,y+1,GREEN);
		positionx=x+19;positiony=y+17;ratiox=2.3;ratioy=1.5;
		setcolor(14);load_draw_array("saudi.dat");
		break;
	case 11:
		triangle(x,y,RED,15);
		line(x+39,y+30,x+180,y+30);
		line(x+39,y+60,x+180,y+60);
		setfillstyle(1,0);floodfill(x+20,y+1,15);
		setfillstyle(1,WHITE);floodfill(x+80,y+32,15);
		setfillstyle(1,GREEN);floodfill(x+40,y+61,15);
		break;
	case 12:
		line(x,y+30,x+180,y+30);
		line(x,y+60,x+180,y+60);
		setfillstyle(1,RED);
		floodfill(x+1,y+1,15);
		floodfill(x+1,y+61,15);
		setfillstyle(1,15);floodfill(x+1,y+31,15);
		setcolor(6);line(x+85,y+56,x+86,y+50);line(x+86,y+50,x+94,y+50);
		line(x+94,y+50,x+95,y+56);line(x+95,y+56,x+85,y+56);
		setfillstyle(1,6);floodfill(x+87,y+54,6);setfillstyle(1,10);
		setcolor(10);line(x+78,y+49,x+102,y+49);line(x+102,y+49,x+90,y+39);
		line(x+78,y+49,x+90,y+39);floodfill(x+84,y+46,10);
		break;
	case 13:
		line(x,y+30,x+180,y+30);
		line(x,y+60,x+180,y+60);
		setfillstyle(1,RED);floodfill(x+1,y+1,15);
		setfillstyle(1,BLACK);floodfill(x+1,y+61,15);
		setfillstyle(1,15);floodfill(x+1,y+31,15);
		draw_star(x+50,y+32,GREEN,GREEN);
		draw_star(x+103,y+32,GREEN,GREEN);
		break;
	case 14:
		triangle(x,y,RED,15);
		draw_star(x+10,y+36,15,15);
		line(x+39,y+30,x+180,y+30);
		line(x+39,y+60,x+180,y+60);
		setfillstyle(1,0);floodfill(x+50,y+1,15);
		setfillstyle(1,15);floodfill(x+70,y+31,15);
		setfillstyle(1,GREEN);floodfill(x+70,y+61,15);
		break;
	case 15:
		line(x,y+30,x+180,y+30);
		line(x,y+60,x+180,y+60);
		setfillstyle(1,RED);floodfill(x+1,y+1,15);
		setfillstyle(1,BLACK);floodfill(x+1,y+61,15);
		setfillstyle(1,15);floodfill(x+1,y+31,15);
		draw_star(x+27,y+32,GREEN,GREEN);
		draw_star(x+77,y+32,GREEN,GREEN);
		draw_star(x+127,y+32,GREEN,GREEN);
		break;
	case 16:
		line(x,y,x+50,y+30);line(x+50,y+30,x+50,y+60);
		line(x+50,y+60,x,y+90);line(x+50,y+30,x+180,y+30);
		line(x+50,y+60,x+180,y+60);
		setfillstyle(1,0);floodfill(x+1,y+30,15);
		setfillstyle(1,GREEN);floodfill(x+71,y+1,15);
		setfillstyle(1,15);floodfill(x+71,y+31,15);
		setfillstyle(1,RED);floodfill(x+71,y+61,15);
		break;
	case 17:
		for(cnt=0;cnt<=8;cnt++)
			{
			line(x+60,y+(10*cnt),x+50,y+5+(10*cnt));
			line(x+50,y+5+(10*cnt),x+60,y+10+(10*cnt));
			}
		setfillstyle(1,15);floodfill(x+1,y+1,15);
		setfillstyle(1,RED);floodfill(x+70,y+8,15);
		break;
	case 18:
		for(cnt=0;cnt<=8;cnt++)
			{
			line(x+60,y+(10*cnt),x+50,y+5+(10*cnt));
			line(x+50,y+5+(10*cnt),x+60,y+10+(10*cnt));
			}
		setfillstyle(1,15);floodfill(x+1,y+1,15);
		setfillstyle(1,BROWN);floodfill(x+70,y+8,15);
		break;
	case 19:
		line(x+40,y,x+40,y+90);line(x+40,y+30,x+180,y+30);
		line(x+40,y+60,x+180,y+60);
		setfillstyle(1,RED);floodfill(x+1,y+1,15);
		setfillstyle(1,GREEN);floodfill(x+51,y+1,15);
		setfillstyle(1,15);floodfill(x+51,y+31,15);
		setfillstyle(1,0);floodfill(x+51,y+61,15);
		break;
	case 20:
		setcolor(RED);
		rectangle(x,y,x+180,y+90);
		line(x+55,y,x+55,y+30);
		line(x+55,y+30,x+180,y+30);
		line(x+180,y+60,x+55,y+60);
		line(x+55,y+60,x+55,y+90);
		setfillstyle(1,RED);floodfill(x+1,y+1,RED);
		setfillstyle(1,WHITE);floodfill(x+61,y+1,RED);
		setfillstyle(1,GREEN);floodfill(x+61,y+71,RED);
		break;
	case 21:
		line(x,y+30,x+180,y+30);
		line(x,y+60,x+180,y+60);
		setfillstyle(1,RED);floodfill(x+1,y+1,15);
		setfillstyle(1,15);floodfill(x+1,y+31,15);
		setfillstyle(1,0);floodfill(x+1,y+61,15);
		draw_star(x+78,y+34,GREEN,GREEN);
		break;
	}
setcolor(0);rectangle(x,y,x+180,y+90);  /* make frame black */
}

/*---------------------- draw_star () ---------------------------------*\
| This function draws a star at the specified position on screen with   |
| the specified border color. The filling color is passed to it.        |
|       IN  : x,y: coordinates of star,                                 |
|             color: filling color,                                     |
|             border: border color.                                     |
|       OUT : NONE.                                                     |
\*---------------------------------------------------------------------*/
draw_star(x,y,color,border)
int x,y,color,border;
{
setcolor(border);
line(x,y+6,x+24,y+6);line(x+24,y+6,x+6,y+18);line(x+6,y+18,x+12,y);
line(x+12,y,x+18,y+18);line(x+18,y+18,x,y+6);   /* draw outline */
setfillstyle(1,color);
floodfill(x+12,y+4,border);floodfill(x+3,y+7,border);floodfill(x+20,y+7,border);
floodfill(x+12,y+7,border);floodfill(x+8,y+16,border);floodfill(x+16,y+16,border);
							/* fill the star */
}

/*---------------------- h_cresent () ---------------------------------*\
| This function draws a horizontal cresent on the screen.               |
|       IN  : x,y : coordinates of cresent,                             |
|             color : its color.                                        |
|       OUT : NONE.                                                     |
\*---------------------------------------------------------------------*/
h_cresent(x,y,color)
int x,y,color;
{
setcolor(color);
arc(x+11,y+10,180,360,23);
arc(x+11,y+16,170,370,23);
floodfill(x+10,y+30,color);
}

/*---------------------- v_cresent () ---------------------------------*\
| This function draws a vertical cresent on the screen.                 |
|       IN  : x,y : coordinates of cresent,                             |
|             color : its color.                                        |
|       OUT : NONE.                                                     |
\*---------------------------------------------------------------------*/
v_cresent(x,y,color)
int x,y,color;
{
setcolor(color);
arc(x+11,y+17,90,270,23);
arc(x+5,y+17,80,280,23);
setfillstyle(1,color);
floodfill(x-14,y+18,color);
}

/*---------------------- triangle () ----------------------------------*\
| This function draws a triangle on the screen with specified color and |
| border. The location is passed to the function.                       |
|       IN  : x,y : coordinates of triangle,                            |
|             color : its color.                                        |
|             border: border's color.                                   |
|       OUT : NONE.                                                     |
\*---------------------------------------------------------------------*/
triangle(x,y,color,border)
int x,y,color,border;
{
setcolor(border);
line(x,y,x,y+90);               /* draw outline */
line(x,y,x+60,y+45);
line(x+60,y+45,x,y+90);
setfillstyle(1,color);
floodfill(x+3,y+10,border);     /* fill the triangle */
}


/***********************************************************************\
|             E N D   O F   G E O . C   S O U R C E   C O D E           |
\***********************************************************************/
