#include <stdio.h>
#include <graphics.h>
#include <string.h>
#include <math.h>
#include <alloc.h>
#include <stdlib.h>
#include <time.h>
#include <dos.h>
#include "arabic.c"
#include "muslib.c"
#include "mouse.c"
#define beep putch('\x7')
#define UP 72
#define DOWN 80
#define LEFT 75
#define RIGHT 77
#define F1 59
#define ENTER 13
#define ESC 27
#define TRUE 1
int far *pt;
int buffer[2503],slow=0,positionx=79,positiony=1;
int sy=10,sy1=10,sy2=127,deltay,titlelen,send;
float ratiox,ratioy; /* the x and y ratios of the map used by draw_map() */
int row=1;

/*---------------------- main () --------------------------------------*\
| This is the main function of the program. Execution of the program    |
| starts here.                                                          |
|       IN  : NONE.                                                     |
|       OUT : NONE.                                                     |
\*---------------------------------------------------------------------*/
main()
{
initialize_graph();                             /* start graphics mode */
start_mouse();                                  /* detect mouse driver */
if(farcoreleft()<=36000)                 /* if enough heap isn't found */
	{slow=TRUE;init16=0;}            /* mark slow mode. */
else                                     /* otherwise,... */
	pt=(int far*) farmalloc(35496);  /* allocate memory for letters info */
while(1)
   {init16=0;program_menu();}            /* display main menu */
}

/*---------------------- progra_menu () -------------------------------*\
| This function displays the tarikh's menu while animating the horse    |
| using frame animation.                                                |
|           IN   :  NONE                                                |
|           OUT  :  NONE                                                |
\*---------------------------------------------------------------------*/
program_menu()
{
int end=0,choice=0,frame_no=0,cnt;
char ch;
int hills[]={-20,-36,43,16,55,11,60,10,65,11,75,14,80,17,91,25,108,40,120,31,
	     124,26,132,17,137,13,140,11,145,10,150,11,160,14,165,18,172,23,
	     184,40,-91,-25,108,20,110,19,112,20,124,25};
					/* coords. of background hills */
disable_cursor();                               /* hide cursor */
cleardevice();                                  /* clear screen */
setcolor(BROWN);
rectangle(199,13,453,145);                      /* Scene Frame */
setcolor(WHITE);
rectangle(198,12,454,146);
rectangle(1,1,638,345);                         /* Screen Frame */
rectangle(2,2,637,344);
arabic_text("jhvdo hguhgl hguvfd",440,160,0,1); /* prog. title */
setcolor(14);
for(cnt=0;cnt<=2;cnt++)
	rectangle(221,200+(22*cnt),436,222+(22*cnt));
setfillstyle(SOLID_FILL,LIGHTGREEN);floodfill(222,202,14);
arabic_text("rhzlm hGojdhvhj",417,201,0,1);     /* display menu header */
arabic_text("lug,lhj jhvdodm",417,224,0,1);     /* display menu items */
arabic_text("HsJJJJzJJJgJJJm",417,245,0,1);
arabic_text("hqy'    H, .v hgtHvm hG,s' gglshu]m",526,320,0,1);setcolor(14);
outtextxy(450,327,"F1");
save_letters();                                 /* store letters in heap */
load_horse();                                   /* get hourse images info */
reverse(222,223,435,243);                       /* highlight 1st choice */
ratiox=1.54;ratioy=1;
positionx=170;positiony=16;setcolor(BROWN);
draw(hills,(sizeof(hills)/2-1));                 /* draw background hills */
setfillstyle(SOLID_FILL,YELLOW);floodfill(221,140,BROWN);
floodfill(330,45,BROWN);
setfillstyle(SOLID_FILL,LIGHTBLUE);floodfill(200,15,BROWN);
enable_cursor();                                /* show cursor */
while(end!=1)
   {            /* while user does not want to exit */
   if(!kbhit() && check_buttons()==0)
	{       /* if no key or button was pressed */
				/* animate the hourse */
	disable_cursor();               /* hide cursor */
	getimage(200,25,205,56,buffer);getimage(206,25,452,56,&buffer[68]);
					/* divide the image into two parts */
	putimage(200,25,&buffer[68],COPY_PUT);  /* move parts alternatively */
	putimage(447,25,buffer,COPY_PUT);
	putimage(280,64,&letters[1504*frame_no],COPY_PUT); /* a horse frame */
	enable_cursor();                        /* show cursor */
	delay(30);                              /* delay a while */
	frame_no+=1;                            /* next frame in horse */
	if(frame_no==11) frame_no=0;            /* if all frames diplayed... */
						/* ... start over */
	}
   else
	{
	if(kbhit())                             /* if a key was pressed */
	{
		ch=getch();                     /* get key from buffer */
		if (ch==0)                      /* if an extended key */
			{       
			ch=getch();             /* get Scan code */
			if(ch!=F1)              /* if not F1 */
			   choice=menu(222,223,213,21,1,choice,ch,1);
						/* operform user's action */
			else                    /* if F1 */
			   {load_letters();help(0);load_horse();} /* help */
			}
		else /* if ch not equal to 0 i.e. not an extended code */
			switch(ch)
				{       /* examine the pressed key */   
				case ENTER:     /* if ENTER */
					enter_music();
					if(choice==0)   /* if 1st choice */
						{
						if (history_info(0)==1)
							{ 
							while(history_info(1)==1)
							continue;
							}
						end=1;
						continue;
						}
					if(choice==1)
						{               /* questions */
						if(execl("quesload.ovl","f","history.qes","history.ovl",0)==-1) file_error("quesload.ovl");end=1;}
					break;
				
				case ESC:               /* if ESC */
					esc_music();            
					if(execl("alamuna.exe","f","nointro",0)==-1) file_error("alamuna");
							/* back to ALAMUNA.EXE */
					break;
				
				default:
					beep;

				}
	}

}
}
}

/*---------------------- load_horse () --------------------------------*\
| This function loads the horse's image array into the array letters[]  |
|       IN    : NONE                                                    |
|       OUT   : NONE                                                    |
\*---------------------------------------------------------------------*/
load_horse()
{
FILE *fptr;

if ((fptr=fopen("horse.img","rb"))==NULL)       /* try to open HORSE.IMG */
file_error("horse.img");                /* on error, tell the user and exit */
fread(letters,2,16544,fptr);            /* read data from disk */
fclose(fptr);                           /* close the file */
}

/*wait_key_mouse(): This function waits for either a keystroke from
		    the keyboard or a click from the mouse
	IN        : NONE
	OUT       : NONE*/
wait_key_mouse()
{
int end=0;
char ch;
while(end!=1)
	if (kbhit() || check_buttons()!=0)
		switch(getch())
			{
			case ESC: esc_music();end=1;break;
			case 0: if((char)getch()==-127){enter_music();end=1;} else beep;break;
			case ENTER: enter_music();end=1;break;
			default: beep;
			}
}

/*---------------------- help () --------------------------------------*\
| This function is responsible for displaying help messages. It copies  |
| the part of the screen in which the help message will be displayed to |
| page no. 1 then it recopies it back to its place in page no. 0 after  |
| the user reads th help message.                                       |
|     IN  : message : message no , It may be either 0 or 1              |
|     OUT : None .                                                      |
\*---------------------------------------------------------------------*/
help(message)
int message;
{
char *messages[]={"jpv; fhGsil H, fhgtHvm >","Yojv fJ     H, f.v hgtHvm hGdlk >",
"Hqy'     H, .v hgtHvm hGdsv","ggrhzlm hgshfrm >",
"Ysjo]l hGsil H, Yqy' lvfud hGsil ","gjpvd; hg;bl >","Yqy'    H, hglvfu hgug,d ggj;lgm >","Yqy'    H, hg.v hGdsv ggov,[ >"};
int enter_xs[]={398,444},enter_ys[]={120,140},esc_xs[]={440,450},esc_ys[]={142,164},i;
f1_music();
save_letters();disable_cursor();
getimage(102,89,342,182,letters);
setactivepage(1);putimage(0,0,letters,COPY_PUT);setactivepage(0);
getimage(343,89,553,182,letters);
setactivepage(1);putimage(0,100,letters,COPY_PUT);setactivepage(0);
setfillstyle(1,6);bar(105,91,553,182);
setfillstyle(1,14);bar(102,89,550,180);
setcolor(0);rectangle(102,89,550,180);
load_letters();
for(i=0;i<=3;i++) arabic_text(messages[(message*4)+i],530,91+(22*i),0,1);
setcolor(4);outtextxy(enter_xs[message],enter_ys[message],"Enter");
outtextxy(esc_xs[message],esc_ys[message],"Esc");
enable_cursor();wait_key_mouse();
disable_cursor();
setactivepage(1);getimage(0,0,240,93,letters);setactivepage(0);putimage(102,89,letters,COPY_PUT);
setactivepage(1);getimage(0,100,210,193,letters);setactivepage(0);putimage(343,89,letters,COPY_PUT);
load_letters();
enable_cursor();
}

/*---------------------- history_info () ------------------------------*\
| This function displays the history information choices which are the  |
| Sadr Eslam and so on and it calls the info_menu() function to get the |
| user choice.                                                          |
|       IN       : map : when not equal to the the map will be drawn>   |
|                        if map equals 1 the map will not be drawn      |
|       OUT      : 1 if the function must be executed again             |
|                  2 if the function mustn't be executed again          |
\*---------------------------------------------------------------------*/
history_info(map)
int map;
{
FILE *fptr;
int cntr,returnvalue=0;
char *choices[]={"uJwJv w]v hTsJbl","hgogthx hgvha]dk","hgJ],gJm hGl,dJm",
		 "hgobtm hgufhsdJm","jpldJg lJk hgrvw"};
load_letters();                         /* load letters from heap */
disable_cursor();                       /* hide cursor */
if(map!=1)
   {
   setcolor(15);cleardevice();setactivepage(1);
   cleardevice();setactivepage(0);          /* clear both pages */
   setvisualpage(1);       /* in page 1 while displaying the empty page 0 */
	ratioy=1.1;ratiox=1.8;
	positionx=79;positiony=1;
	draw_map();
   }
setvisualpage(0);
clear(0,152,639,349);
setcolor(WHITE);
rectangle(2,151,638,175);               /* Small frame */
rectangle(3,152,637,174);
setfillstyle(SOLID_FILL,YELLOW);floodfill(4,154,15);
rectangle(2,174,638,349);               /* Large frame */
rectangle(3,175,637,348);
rectangle(2,325,638,349);               /* Bottom frame */
rectangle(3,324,637,348);
floodfill(4,326,15);
arabic_text("lug,lhj jhvdodm",405,153,0,1);
arabic_text("hqy'    H, .v hgtHvm hG,s' gglshu]m",526,327,0,1);
setcolor(1);outtextxy(450,334,"F1");
setcolor(15);
for(cntr=0;cntr<=4;cntr++)
	{
	rectangle(213,194+(22*cntr),445,216+(22*cntr));
	arabic_text(choices[cntr],423,195+(22*cntr),0,1);
	}
switch(info_menu()) /* calls the infomenu() function and check its values */
	{
	case 1: while(sadr_eslam()==1) continue;returnvalue=1;break;
	case 2: while(kholf_rash()==1) continue;returnvalue=1;break;
	case 3: while(omajjids()==1) continue;returnvalue=1;break;
	case 4: while(abassids()==1) continue;returnvalue=1;break;
	case 5: while(disk_lessons()==1) continue;returnvalue=1;break;
	case 6: returnvalue=2;
	}
return(returnvalue);
}

/*---------------------- info_menu () ---------------------------------*\
| This function is called only from the history_info() function.        |
| It gets the user choice from the five options and returns it to the   |
| history_info() function .                                             |
|     IN     : NONE                                                     |
|     OUT    : User's Choice                                            |
\*---------------------------------------------------------------------*/
info_menu()
{
int ch,choice=0,end=0,returnvalue;

reverse(214,195,444,215);                       /* highlight 1st choice */
enable_cursor();                                /* show cursor */
while(end!=1)                           /* while user doesn't want to exit */
	{
	if (kbhit())                    /* if a key was pressed */
	   {
	   ch=getch();
	   if(ch==0)                    /* if ch is an extended code */
		{
		ch=getch();                     /* get Scan code */
		if(ch!=F1)                      /* if not F1 */
		   choice=menu(214,195,230,21,4,choice,ch,1);
						/* perform user's axtion */
		else help(0);                   /* otherwise, help message */
		}
	else                            /* ch isn't an extended code */
		switch(ch)
			{       /* what key is that? */
			case ENTER:     /* ENTER */
				 enter_music();end=1;
				 returnvalue=(choice+1);break;
			case ESC:esc_music();end=1;
				 returnvalue=6;break;
			default:beep;
			}
	}
	else                    /* if no key was pressed... */
		check_buttons();        /* check mouse */
	}
return(returnvalue);
}

/*---------------------- sadr_eslam () --------------------------------*\
| This function displays and gets the user choice out of the (built in) |
| Sadr Eslam lesson ... When it gets the choice it calls the event()    |
| function to display the lesson if the choice isn't the 12th choice    |
| else it calls the all_events() to display all the lessons in sequence.|
|       IN     : NONE                                                   |
|       OUT    : 1 if the function must be executed again               |
|                0 if the function mustn't be executed again            |
\*---------------------------------------------------------------------*/
sadr_eslam()
{
int markers1[11][2]={490,102,490,102,490,102,490,102,489,93,481,82,489,87,
		    489,87,490,102,490,102,490,102};/*positions of the markers*/
int markers2[11][2]={-1,-1, -1,-1, -1,-1, 489,87, -1,-1, -1,-1, -1,-1, -1,-1, -1,-1,
		    -1,-1, -1,-1};
char *choices[]={"l,g] hgvs,g","hgvshgm","rvda ,hTsbl","i[vm hgvs,g","y.,m f]v",
		 "y.,m Hp]","y.,m hgok]r","wgp hgp]dfdm","tjp l;m","p[m hg,]hu",
		 ",thm hgvs,g","[ldu hGp]he"};
int no=0,choice=0,returnvalue=0,returnyn=0;
char ch,che;

row=1;
disable_cursor();                               /* hide cursor */
clear(4,176,636,323);                           
setcolor(15);
for(no=0;no<=5;no++)
	{                                       /* display menu */
	rectangle(4,183+(no*22),636,205+(no*22));
	arabic_text(choices[no],600,184+(no*22),0,1);
	arabic_text(choices[no+6],250,184+(no*22),0,1);
	}
setfillstyle(INTERLEAVE_FILL,YELLOW);floodfill(6,182,15);floodfill(6,316,15);
line(320,183,320,315);
reverse(321,184,635,204);                       /* highlight 1st choice */
enable_cursor();                                /* show cursor */
while(returnyn!=1)
   {
   if(kbhit())                                  /* if a key was pressed */
      {
      ch=getch();                                       /*  read buffer */
      if (ch==0)                                        /* if extended key */
	{
	ch=getch();                                     /* get Scan code */
	if(ch!=59)                                      /* if not F1 */
	   choice=double_menu(321,184,5,184,314,21,5,5,choice,ch,1);
						/* perform user's action */
	else help(0);                   /* otherwise, display ahelp message */
	}
   else                                 /* i not an extended key */
	switch(ch)
		{                       /* examine the pressed key */
		case ENTER:                     /* ENTER */
			enter_music();
			clear(4,176,636,323);
			if (row==1)           /* calculate choice depending */ 
					      /* on what column we are */
				no=choice;
			if (row==2)
				no=choice+6;
			if (no==11)             /* all events */
			   all_events("sadrel",10,markers1,markers2);
			else                    /* a single event */
			   event("sadrel",no,no,markers1,markers2);
			returnyn=returnvalue=1;
			break;
		case ESC:                       /* ESC */
			 esc_music();
			 returnyn=1;returnvalue=2;
			 break;
		default:
			 beep;
		}
}
else                                    /* if no keys were pressed */
	check_buttons();                /* check mouse */
} /* for the while(returnvalue!=1) */
load_letters();                         /* get letters info from heap */
return(returnvalue);
}

/*---------------------- kholf_rash () --------------------------------*\
| This function displays the khalifas and gets the user's choice and    |
| returns 1 if it's to be executed again and 2 if the previous menu is  |
| to be executed . This function calls four function representing the   |
| four khalifs and the four functions are: abubakr() , omar() , othman()|
| and aly() .                                                           |
|        IN    : NONE                                                   |
|        OUT   : 1 if it's to be executed again                         |
|                2 if the previous menu must be executed                |
\*---------------------------------------------------------------------*/
kholf_rash()
{
int choice=0,returnyn=0,returnvalue=0,ch,cntr;
char *choices[]={"Hf, f;v  hgw]dr","ulv  fk  hgo'hf","uelhk  fk  uthk","ugd fk Hfd 'hgf"};

disable_cursor();                               /* hide cursor */
clear(4,176,636,323);
setcolor(15);
for(cntr=0;cntr<=3;cntr++)
	{                               /* display the 4 khalifas' names */
	rectangle(213,206+(22*cntr),445,228+(22*cntr));
	arabic_text(choices[cntr],415,207+(22*cntr),0,1);
	}
line(2,205,636,205);
arabic_text("j,gd Hlv hglsgldk td i`i hgtjvm Hvfu ogthx ,il :",620,180,0,1);
reverse(214,207,444,227);                       /* highlight 1 st choice */
enable_cursor();                                /* show cursor */
while(returnyn!=1)
{                       /* while no ENTER or ESC was pressed */
if(kbhit())             /* if a key was pressed */
{
ch=getch();                     /* get it from buffer */
if(ch==0)                       /* if an extended key was pressed */
	{
	ch=getch();             /* get Scan code */
	if(ch!=F1)              /* if not F1 */
	   choice=menu(214,207,230,21,3,choice,ch,1);
				/* perform user's action */
	else help(0);           /* otherwise, display a help message */
	}
else                            /* if a normal key was pressed */
	switch(ch)
		{               /* what key? */
		case ENTER:             /* ENTER */
			enter_music();
			switch(choice)  
				{       /* what choice */
				case 0:         /* ABU BAKR */
					while(abubakr()==1) continue;
					returnyn=returnvalue=1;
					break;
				
				case 1:         /* OMAR */
					while(omar()==1) continue;
					returnyn=returnvalue=1;
					break;
				
				case 2:         /* OTHMAN */
					while(othman()==1) continue;
					returnyn=returnvalue=1;
					break;
				
				case 3:         /* ALY */
					while(aly()==1) continue;
					returnyn=returnvalue=1;
					break;
				}
			break;
		case ESC:               /* ESC */
			esc_music();returnyn=1;returnvalue=2;continue;
		}
}
else                            /* if no key was pressed ... */
	check_buttons();                /* ...check mouse */

}
return(returnvalue);
}

/*---------------------- abu_bakr () ----------------------------------*\
| This function contains Abu Bakr Al Sediek lesson and gets the user    |
| choice and send it to the event() function to display the lesson .    |
|  IN   :    NONE                                                       |
|  OUT  :    1 if the function must be executed again                   |
|            0 if the function mustn't be executed again                |
\*---------------------------------------------------------------------*/
abubakr()
{
int markers1[6][2]={490,102,500,81,501,47,451,57,490,102};
int markers2[6][2]={-1,-1,-1,-1,-1,-1,-1,-1,-1,-1};
char *menu_items[]={"j,gd hgobtm","hgrqhx ugd hglvj]dk","jlid] tjp hguvhr",
		    "jlid] tjp hgahl",",thm Hfd f;v","sv] [ldu hGp]he"};
int choice=0,returnyn=0,returnvalue=0,cnt;
char ch,che;
disable_cursor();                       /* hide cursor */
clear(4,176,636,323);
arabic_text("Hf, f;v hgw]dr :",610,180,0,1);
for(cnt=0;cnt<=5;cnt++)                 /* display menu items */
   arabic_text(menu_items[cnt],400,180+(21*cnt),0,1);
reverse(153,180,418,200);               /* highlight 1st item */
enable_cursor();                        /* show cursor */
while(returnyn!=1)
{               /* while no ENTER or ESC was pressed */
if(kbhit())     /* if a key was pressed */
{
ch=getch();     /* read it */
if (ch==0)      /* if it is an extended key... */
	{
	ch=getch();     /* get Scan code */
	if(ch!=F1)      /* if not F1 */
	   choice=menu(153,180,265,21,5,choice,ch,0);   
				/* perform user's action */
	else help(0);           /* otherwise, display a help message */
	}
else                            /* if a normal key was pressed */
	switch(ch)
		{               /* what key ? */
		case ENTER:             /* ENTER */
			enter_music();
			clear(4,176,636,323);
			if(choice==5)  /* show all events */
			   all_events("abubakr",4,markers1,markers2);
			else                    /* show one event */
			   event("abubakr",choice,choice,markers1,markers2);
			returnyn=returnvalue=1;
			break;
		case ESC:                       /* ESC */
			  esc_music();returnyn=1;returnvalue=2;
			  break;
		default : beep;
		}
}
else check_buttons();   /* if no key was pressed, check mouse */
}/*for the while(returnyn!=1) loop*/
load_letters();                         /* get letters from heap */
return(returnvalue);
}

/*---------------------- omar () --------------------------------------*\
| This function contains Omar Ibn Al Khatab lesson and gets the user    |
| choice and send it to the event() function to display the lesson .    |
|  IN   :    NONE                                                       |
|  OUT  :    1 if the function must be executed again                   |
|            2 if the function mustn't be executed again                |
\*---------------------------------------------------------------------*/
omar()
{
int choice=0,returnyn=0,returnvalue=0;
int markers1[5][2]={490,102,451,57,501,47,419,69,490,102};
int markers2[5][2]={-1,-1,-1,-1,-1,-1,-1,-1,-1,-1};
char ch,che;

disable_cursor();
clear(4,176,636,323);
arabic_text("ulv fk hgo'hf :",610,180,0,1);arabic_text("j,gd hgobtm",400,180,0,1);
arabic_text("h;lhg tjp hgahl",400,201,0,1);arabic_text("h;lhg tjp hguvhr",400,222,0,1);
arabic_text("tjp lwv",400,243,0,1);arabic_text(",thm ulv fk hgo'hf",400,264,0,1);
arabic_text("sv] [ldu hGp]he",400,285,0,1);
reverse(153,180,418,200);
enable_cursor();
while(returnyn!=1)              /* the following portion works exactly as the
						similar one in abu_bakr() */
{
if(kbhit())
{
ch=getch();
if (ch==0)
	{
	ch=getch();
	if(ch!=F1) choice=menu(153,180,265,21,5,choice,ch,0);
	else help(0);
	}
else
	switch(ch)
		{
		case ENTER:
			enter_music();
			clear(4,176,636,323);
			if(choice==5) all_events("omar",4,markers1,markers2);
			else event("omar",choice,choice,markers1,markers2);
			returnyn=returnvalue=1;
			break;
		case ESC: esc_music();returnyn=1;returnvalue=2;
			  break;
		default : beep;
		}
}
else check_buttons();
}/*for the while(returnyn!=1) loop*/
load_letters();
return(returnvalue);
}

/*---------------------- othman () ------------------------------------*\
| This function contains Othman Ibn Affan lesson and gets the user      |
| choice and send it to the event() function to display the lesson .    |
|  IN   :    NONE                                                       |
|  OUT  :    1 if the function must be executed again                   |
|            2 if the function mustn't be executed again                |
\*---------------------------------------------------------------------*/
othman()
{
int choice=0,returnyn=0,returnvalue=0;
int markers1[4][2]={490,102,419,49,419,69,490,102};
int markers2[4][2]={-1 ,-1 ,490,102,441,43, -1,-1};
char ch,che;

disable_cursor();               /* this function works exactly as abu_bakr() */
clear(4,176,636,323);
arabic_text("uelhk fk uthk :",610,180,0,1);arabic_text("j,gd hgobtm",400,180,0,1);
arabic_text("hulhg uelhk hg]hogdm",400,201,0,1);arabic_text("Hulhg uelhk hgpvfdm",400,222,0,1);
arabic_text(",thm uelhk",400,243,0,1);arabic_text("sv] [ldu hGp]he",400,264,0,1);
reverse(153,180,418,200);
enable_cursor();
while(returnyn!=1)
{
if(kbhit())
{
ch=getch();
if (ch==0)
	{
	ch=getch();
	if(ch!=F1) choice=menu(153,180,265,21,4,choice,ch,0);
	else help(0);
	}
else
	switch(ch)
		{
		case ENTER:
			enter_music();
			clear(4,176,636,323);
			if(choice==4) all_events("othman",3,markers1,markers2);
			else event("othman",choice,choice,markers1,markers2);
			returnyn=returnvalue=1;
			break;
		case ESC: esc_music();returnyn=1;returnvalue=2;
			  break;
		default : beep;
		}
}
else check_buttons();
}/*for the while(returnyn!=1) loop*/
load_letters();
return(returnvalue);
}

/*---------------------- aly () ---------------------------------------*\ 
| This function contains Aly Ibn Aby Taleb lesson and gets the user     |
| choice and send it to the event() function to display the lesson .    |
|  IN   :    NONE                                                       |
|  OUT  :    1 if the function must be executed again                   |
|            2 if the function mustn't be executed again                |
\*---------------------------------------------------------------------*/
aly()
{
int choice=0,returnyn=0,returnvalue=0;
int markers1[5][2]={492,104,534,64,492,52,518,52,516,56};
int markers2[5][2]={-1,-1,-1,-1,-1,-1,-1,-1,-1,-1};
char ch,che;

disable_cursor();       /* this function works exactly as abu_bakr () */
clear(4,176,636,323);
arabic_text("ugd fk Hfd 'hgf :",610,180,0,1);arabic_text("j,gd hgobtm",380,180,0,1);
arabic_text("l,rum hg[lg",380,201,0,1);arabic_text("l,rum wtdk",380,222,0,1);
arabic_text("l,rum hgkiv,hk",380,243,0,1);arabic_text("lrjg ugd",380,264,0,1);
arabic_text("sv] [ldu hGp]he",380,285,0,1);
reverse(153,180,398,200);
enable_cursor();
while(returnyn!=1)
{
if(kbhit())
{
ch=getch();
if (ch==0)
	{
	ch=getch();
	if(ch!=F1) choice=menu(153,180,245,21,5,choice,ch,0);
	else help(0);
	}
else
	switch(ch)
		{
		case ENTER:
			enter_music();
			clear(4,176,636,323);
			if(choice==5) all_events("aly",4,markers1,markers2);
			else event("aly",choice,choice,markers1,markers2);
			returnyn=returnvalue=1;
			break;
		case ESC: esc_music();returnyn=1;returnvalue=2;
			  break;
		default : beep;
		}
}
else check_buttons();
}/*for the while(returnyn!=1) loop*/
load_letters();
return(returnvalue);
}

/*---------------------- disk_lessons () ------------------------------*\ 
| This function display the lessons name written by lesson preparing    |
| program included with the program I first opens the "lessons.sav"     |
| then it reads the lessons names and displays them in the suitable     |
| form (either in one or two rows) then it waits for the user's choice  |
| then it sends the corresponding lesson file name to the disk_load()   |
| function .                                                            |
|       IN       : NONE                                                 |
|       OUT      : 1 if the function must be executed again             |
|                  0 if the function mustn't be executed again          |
\*---------------------------------------------------------------------*/
disk_lessons()
{
FILE *fptr;
int lessons_no,cntr,end=0,choice=0,returnvalue=0,items_row1,items_row2;
char lessonname[12][20],filename[12][13],ch;
row=1;
disable_cursor();
clear(4,176,636,323);
if((fptr=fopen("lesson.sav","r"))==NULL)        /* try to open LESSON.SAV */
   file_error("lesson.sav");                    /* on error, tell the user */
fscanf(fptr,"%d",&lessons_no);                  /* read number of lessons */
for(cntr=0;cntr<=lessons_no-1;cntr++)
	{               /* read lessons names and filesname */
	fread(&lessonname[cntr][0],1,20,fptr);
	fread(&filename[cntr][0],1,13,fptr);
	}
fclose(fptr);           /* close lessons files */
if(lessons_no<=6)
	{               /* if no. of lessons is less than 6 */
	setcolor(15);
	for(cntr=0;cntr<=5;cntr++)       
	rectangle(189,183+(22*cntr),450,205+(22*cntr));
	for(cntr=0;cntr<=lessons_no-1;cntr++)   /* write lessons names */
		arabic_text(&lessonname[cntr][0],432,184+(22*cntr),0,1);
	reverse(190,184,449,204);       /* highlight 1st choice */
	}
else                            /* if number of lessons > 6, use two columns */
	{
	setcolor(15);
	for(cntr=0;cntr<=5;cntr++)
	   rectangle(4,183+(cntr*22),636,205+(cntr*22));
	setfillstyle(INTERLEAVE_FILL,YELLOW);floodfill(6,182,15);floodfill(6,316,15);
	line(320,183,320,315);
	items_row2=ceil(lessons_no/2)-1;        /* items in 2nd column */
	items_row1=lessons_no-items_row2-2;     /* items in 1st column */
	for(cntr=0;cntr<=items_row1;cntr++)     /* print 1st column items */
	   arabic_text(&lessonname[cntr][0],600,184+(22*cntr),0,1);
	for(cntr=items_row1+1;cntr<=lessons_no-1;cntr++) /* 2nd col. items */
	   arabic_text(&lessonname[cntr][0],250,184+(22*(cntr-items_row1-1)),0,1);
	reverse(321,184,635,204);               /* highlight 1st choice */
	}
enable_cursor();                                /* show cursor */
while(end!=1)
	{                       /* while user doesn't want to get back */
	if(kbhit())
	{                       /* if a key was pressed */
	ch=getch();
	if(ch==0)               /* if an extended key */
		{
		ch=getch();     /* read the Scan code */
		if(ch!=F1)      /* if not F1 */
			{
			if(lessons_no<=6)       /* if a one-column menu */
			   choice=menu(190,184,259,21,lessons_no-1,choice,ch,1);
			if(lessons_no>=7)       /* if a two-column menu */
			   choice=double_menu(321,184,5,184,314,21,items_row1,items_row2,choice,ch,1);
					/* perform users action */
			}
		else help(0);                   /* display a help message */

	}
	else                            /* if a normal key */
		switch(ch)
			{               /* what key ? */
			case ESC:       /* Esc */
				  esc_music();end=1;returnvalue=2;break;
			case ENTER: enter_music();      /* ENTER */
				    if(row==2 && lessons_no>=7)
						choice+=(items_row1+1);
				    if (lessons_no %2==1 && lessons_no>=7 && choice==lessons_no)
					{end=1;returnvalue=2;}
				    else
					{
					while(disk_load(&filename[choice][0])==1) continue;
					end=1;returnvalue=1;
					}
				    break;
			}
		}
		else check_buttons();   /* if no key, check mouse */
	}
return(returnvalue);
}

/*---------------------- disk_load () ---------------------------------*\ 
| This function opens the header file (filename+".hdr") name for the    |
| lesson and displays the pages of the lesson and wait for the user's   |
| choice then it sends the body file name (filename+".bdy" to the event |
| function to display the page .                                        |
|       IN    : filename : the file name of the lesson                  |
|       OUT   : 1 if the function must be executed again                |
|               0 if the function mustn't be executed again             |
\*---------------------------------------------------------------------*/
disk_load(filename)
char filename[13];
{
int markers[12][2],size,pages_no,cntr,end=0,choice=0,returnvalue=0,items_row1,items_row2,twelve=1;
FILE *hdrptr,*bodyptr;
char title[20],ch;

row=1;                                  /* 1st menu column */
disable_cursor();                       /* hide cursor */
clear(4,176,636,323);
size=strlen(filename);                  /* filename length */
strcpy(&filename[size],".hdr");         /* add .hdr extension to filename */
if((hdrptr=fopen(filename,"r"))==NULL)  /* try to open the .hdr file */
   file_error(filename);                /* on error, tell the user and exit */
fscanf(hdrptr," %d ",&pages_no);        /* read number of pages in lesson */
strcpy(&filename[size],".bdy");         /* add .bdy extension */
if (pages_no<=11)                       /* if less than 12 pages */
	{twelve=0;pages_no+=1;}
if(pages_no<=6)                         /* if less than 7 pages */
	{
	setcolor(15);
	for(cntr=0;cntr<=5;cntr++)
	   rectangle(189,183+(22*cntr),450,205+(22*cntr));
	for(cntr=0;cntr<=pages_no-2;cntr++)
		{               /* for every page */
		fread(title,1,20,hdrptr);       /* read page title */
		fscanf(hdrptr," %d %d ",&markers[cntr][0],&markers[cntr][1]);
						/* read markers coordinates */
		arabic_text(title,432,184+(22*cntr),0,1); /* display title */
		}
	arabic_text("sv] [ldu hGp]he",432,184+(22*cntr),0,1);
	reverse(190,184,449,204);               /* highlight first item */
	}
if(pages_no>=7)                         /* if more than 6 pages */
	{
	setcolor(15);
	for(cntr=0;cntr<=5;cntr++)
	   rectangle(4,183+(cntr*22),636,205+(cntr*22));
	setfillstyle(INTERLEAVE_FILL,YELLOW);
	floodfill(6,182,15);floodfill(6,316,15);
	line(320,183,320,315);
	items_row2=ceil(pages_no/2)-1;          /* items in 2nd column */
	items_row1=pages_no-items_row2-2;       /* items in 1st column */
	for(cntr=0;cntr<=items_row1;cntr++)
		{                       /* for each item in 1st column */
		fread(title,1,20,hdrptr);       /* read title */
		fscanf(hdrptr," %d %d ",&markers[cntr][0],&markers[cntr][1]);
		arabic_text(title,600,184+(22*cntr),0,1); /* display title */
		}
	for(cntr=items_row1+1;cntr<=items_row1+items_row2;cntr++)
		{                       /* for each item in 2nd column */
		fread(title,1,20,hdrptr);       /* read title */
		fscanf(hdrptr," %d %d ",&markers[cntr][0],&markers[cntr][1]);
		arabic_text(title,250,184+(22*(cntr-items_row1-1)),0,1);
						/* display title */
		}
	if(twelve==0)
		arabic_text("sv] [ldu hGp]he",250,184+(22*(cntr-items_row1-1)),0,1);
	else
		pages_no-=1;
	reverse(321,184,635,204);               /* highlight 1st item */
	}
fclose(hdrptr);                                 /* close header file */
enable_cursor();                                /* show cursor */
while(end!=1)
	{                       /* while user doesn't want to go back */
	if(kbhit())
	{                       /* if a key was pressed */
	ch=getch();
	if(ch==0)               /* if an extended key */
		{
		ch=getch();     /* read Scan code */
		if(ch!=F1)      /* if not F1 */
			{
			if(pages_no<=6)
			   choice=menu(190,184,259,21,pages_no-1,choice,ch,1);
			if(pages_no>=7)
			   choice=double_menu(321,184,5,184,314,21,items_row1,
						      items_row2,choice,ch,1);
						/* perform user's action */
			}
		else help(0);           /* if F1, display help message */
		}
	else                            /* if a normal key */
		switch(ch)
			{               /* examine the pressed key */
			case ENTER:enter_music();
				   if(pages_no>=7 && row==2)
					choice+=(items_row1+1);
				   if(choice==pages_no-1 && twelve==0)
					all_events(filename,pages_no-2,markers,markers);
				   else
					event(filename,choice,choice,markers,markers);
					filename[size]='\x0';
					end=1;returnvalue=1;
				   break;
			case ESC:esc_music();
				 end=1;
				 returnvalue=2;
				 break;
			}
		}
		else check_buttons();   /* if no keys, check moue */
	}
load_letters();                         /* get letters info. from heap */
return(returnvalue);
}

/*file_error: This function displays an error message indicating that a file
		error has occured .
	IN  : NONE
	OUT : NONE*/
file_error(fn)
char *fn;
{
closegraph();
printf("\nAn error occured while opening \"%s\"",fn);
printf("\nCheck and rerun . . .\n");
exit(2);
}

/*---------------------- omajjids () ----------------------------------*\ 
| This function contains the Omajjids lesson and gets the user choice   |
| and send it to the event() function to display the lesson .           |
|  IN   :    NONE                                                       |
|  OUT  :    1 if the function must be executed again                   |
|            2 if the function mustn't be executed again                |
\*---------------------------------------------------------------------*/
omajjids()
{
int markers1[9][2]={460,44,626,8,-1,-1,514,8,374,20,300,26,222,8,-1,-1,460,44};
int markers2[9][2]={-1,-1, -1,-1, -1,-1, -1,-1, -1,-1, 156,42, -1,-1, -1,-1, -1,-1};
char *choices[]={"jHsds hg],gm hGl,dm","tjp lh ,vhx hgkiv","tjp fb] hgsk]","tjp Nsdh hgwyvd","lph,gm tjp hgrs'k'dkdm",
		 "tjp alhg Htvdrdm","tjp hGk]gs","lph,gm tjp fb] hgtvk[m","Ykidhv hg],gm hGl,dm","sv] [ldu hGp]he"};
int no=0,choice=0,returnvalue=0,returnyn=0;
char ch,che;

row=1;
disable_cursor();                       /* hide cursor */
clear(4,176,636,323);
setcolor(15);
for(no=0;no<=4;no++)
	{                               /* display items */
	rectangle(4,193+(no*22),636,215+(no*22));
	arabic_text(choices[no],600,194+(no*22),0,1);
	arabic_text(choices[no+5],284,194+(no*22),0,1);
	}
setfillstyle(INTERLEAVE_FILL,YELLOW);floodfill(6,182,15);floodfill(6,316,15);
line(320,193,320,305);
reverse(321,194,635,214);               /* highlight 1st choice */
enable_cursor();                        /* show cursor */
while(returnyn!=1)
{                               /* while neither ENTER nor ESC */
if(kbhit())
{                               /* if a key was pressed */
ch=getch();                     
if (ch==0)                      /* if an extended key */
	{
	ch=getch();                     /* get Scan code */
	if(ch!=F1)                      /* if not F1 */
	   choice=double_menu(321,194,5,194,314,21,4,4,choice,ch,1);
						/* perform user's action */
	else help(0);                   /* if F1, display help message */
	}
else                                    /* if a normal key */
	switch(ch)
		{                       /* examine the pressed key */
		case ENTER:
			enter_music();
			clear(4,176,636,323);
			if (row==1)
				no=choice;
			if (row==2)
				no=choice+5;
			if (no==9) all_events("omaj",8,markers1,markers2);
			else event("omaj",no,no,markers1,markers2);
			returnyn=returnvalue=1;
			break;
		case ESC:
			 esc_music();
			 returnyn=1;returnvalue=2;
			 break;
		default:
			 beep;
		}
}
else check_buttons();                   /* if no keys, check the mouse */
} /*for the while(returnvalue!=1)*/
load_letters();                         /* get letters from heap */
return(returnvalue);
}

/*---------------------- abassids () ----------------------------------*\ 
| This function contains the abasseyien lesson and gets the user choice |
| and send it to the event() function to display the lesson .           |
|  IN   :    NONE                                                       |
|  OUT  :    1 if the function must be executed again                   |
|            2 if the function mustn't be executed again                |
\*---------------------------------------------------------------------*/
abassids()
{
int markers1[5][2]={516,52,516,52,516,52,516,52,516,52};
int markers2[5][2]={-1,-1,-1,-1,-1,-1,-1,-1,-1,-1};
char *choices[]={"rdhl hgobtm hgufhsdm","hguwv hgufhsd hG,g","Hf, [utv hglkw,v",
"ihv,k hgvad]","hguwv hgufhsd hgehkd","sv] [ldu hGp]he"};
int no=0,choice=0,returnvalue=0,returnyn=0,cntr;
char ch,che;

row=1;
disable_cursor();                               /* hide cursor */
clear(4,176,636,323);
setcolor(15);
for(cntr=0;cntr<=5;cntr++)
	{                                       /* display item */
	rectangle(178,179+(22*cntr),460,201+(22*cntr));
	arabic_text(choices[cntr],438,180+(22*cntr),0,1);
	}
reverse(179,180,459,200);                       /* highlight 1st item */
enable_cursor();                                /* show cursor */
while(returnyn!=1)
{                               /* while neither ENTER nor ESC is pressed */
if(kbhit())
{                                               /* if a key was pressed */
ch=getch();
if (ch==0)                                      /* if an extended key */
	{
	ch=getch();                             /* get Scan code */
	if(ch!=F1)                              /* if not F1 */
	   choice=menu(179,180,280,21,5,choice,ch,1);
						/* perform user's action */
	else help(0);                           /* if F1, display help */
	}
else                                            /* if a normal key */
	switch(ch)
		{                               /* examine key */
		case ENTER:
			enter_music();
			clear(4,176,636,323);
			if (row==1)
				no=choice;
			if (row==2)
				no=choice+5;
			if (no==5) all_events("abas",4,markers1,markers2);
			else event("abas",no,no,markers1,markers2);
			returnyn=returnvalue=1;
			break;
		case ESC:
			 esc_music();
			 returnyn=1;returnvalue=2;
			 break;
		default:
			 beep;
		}
}
else
	check_buttons();                /* if no key, check mouse */
} /*for the while(returnvalue!=1)*/
load_letters();                         /* get file info from heap */
return(returnvalue);
}

/*---------------------- initialize_graph () --------------------------*\ 
| This function is used to set on the graphics system to the mode       |
| 640x350, 16 colours .                                                 |
|               IN      :  NONE .                                       |
|               OUT     :  NONE.                                        |
\*---------------------------------------------------------------------*/
initialize_graph()
{
int gdriver=EGA,gmode=EGAHI,err;
closegraph();
registerbgidriver(EGAVGA_driver);       /* register driver */
initgraph(&gdriver,&gmode,"");          /* initialize graphics mode */
err=graphresult();                      /* check for errors */
if (err!=grOk)                          /* if not OK */
	printf("%s",grapherrormsg(err));        /* display error message */
}

/*---------------------- scrolling_display () -------------------------*\
| This function checks the scan code of the key pressed on the keyboard |
| and checks if it is Up or Down scroll the lesson text by copying a    |
| part of it from the page no.2 to the page no 1. and it checks also    |
| for the mouse character -127 and if it is pressed it checks the       |
| position of the mouse cursor if it is at the box it pokes ENTER into  |
| the keyboard's buffer and it is at the arrows boxes it pokes UP or    |
| down and it checks for the F1 key and if it is pressed it calls the   |
| help() function to display the suitable help message .                |
|               IN    : position : It may be either 1 or 0              |
|                                  1: the text will be scrolled on the  |
|                                     left part of the screen .         |
|                                  0: the text will be scrolled on the  |
|                                     right area of the screen .        |
|                       ch : the scan code of the character pressed it  |
|                            checks for the previously mentioned        |
|                            characters and if the scan code wasn't one |
|                            of them it beeps the computer speaker .    |
|               OUT   : NONE                                            |
\*---------------------------------------------------------------------*/
scrolling_display(position,ch)
int position;
char ch;
{
int xspace,x,y;

disable_cursor();                       /* hide cursor */
if(position==1) xspace=18;              /* determine text coordinates */
else xspace=238;
	switch(ch)
		{               /* which was pressed ? */
		case UP:                /* Up arrow */
			if (sy1>20)
				{
				sy1-=20;sy2-=20;
				setactivepage(1);       /* go to page 1 */
				getimage(242,sy1,635,sy2,letters);
							/* get part of text */
				setactivepage(0);       /* now page 0 */
				putimage(xspace,198,letters,COPY_PUT);
							/* put it there */
				}
			else
				beep;
			break;
		
		case DOWN:              /* Down arrow */
			deltay=sy-sy2;
			if (deltay>=19)
				{
				sy1+=20;sy2+=20;
				setactivepage(1);       /* go to page 1 */
				getimage(242,sy1,635,sy2,letters);
							/* get part of text */
				setactivepage(0);       /* now page 0 */
				putimage(xspace,198,letters,COPY_PUT);
							/* put text there */
				}
			else      /* if no remaining text in that direction */
				beep;
			break;
		
		case -127:              /* Left mouse button */
			x=get_mousex();y=get_mousey();  /* get cursor location */
			if(x>=xspace-15 && x<=xspace-2)
				if(y>176 && y<=198)  /* if within up-left corner */
					buffer_put(ENTER);      
					       /* put ENTER in keyb. buffer */
			
			if(x>=xspace-15 && x<=xspace-2)
				if(y>198 && y<=213) /* if at UP direction of the scroll bar */
					buffer_put(UP); /* put UP in the keyb. buf. */
			
			if(x>=xspace-15 && x<=xspace-2)
				if(y>307 && y<=322) /* if at DOWN direction of scroll bar */
					buffer_put(DOWN);       /* put DOWN in keyb. buf. */
			break;
		case F1:                /* F1 */
			enable_cursor();load_letters(); /* get letters info */
			help(1);disable_cursor();break; /* display help */
		default:
			beep;
		}
enable_cursor();                        /* show cursor */
}

/*---------------------- event () -------------------------------------*\
| This function opens a file and display the event specified by the     |
| caller function and it displays the marker on the screen indicating   |
| the place of the event it calls the load_info() function for loading  |
| the event into the display page no. 2 and the scrolling_display() to  |
| scroll the text .                                                     |
|    IN  : filename: This file name in which the event is included      |
|          no: The no. of the event selected                            |
|          position: The position of the text if 1 the text will be at  |
|                    the left of the screen and if it's 2 the text will |
|                    be at the right area of the screen .               |
|          markers1,markers2: The coordinates of the markers indicating |
|                             the place of the event. This values are   |
|                             sent to the display_marker() function to  |
|                             display them .                            |
\*---------------------------------------------------------------------*/
event(filename,no,position,markers1,markers2)
char filename[11];
int no,position,markers1[11][2],markers2[11][2];
{
int end=0;
char che;

disable_cursor();                       /* hide cursor */
clear(4, 176,636,323);
load_info(filename,no,position%2);      /* load event information */
switch(position%4)      
	{                               /* what story teller? */
	case 0: draw_face();break;      /* man 1 */
	case 1: draw_man2();break;      /* man 2 */
	case 2: draw_woman();break;     /* woman */
	case 3: draw_man3();break;      /* man 3 */
	}
enable_cursor();                        /* show cursor */

while(end!=1)
	{                               /* while user doesn't want to return */
	if(!kbhit() && check_buttons()!=1)
		{       /* if neither a key nor a button was pressed */
		switch(position%4)
			{               /* animate face */
			case 0: move_man();break;
			case 1: move_man2();break;
			case 2: animate_woman();break;
			case 3: move_man3();break;
			}
		display_marker(markers1[no][0],markers1[no][1]);
		display_marker(markers2[no][0],markers2[no][1]);
					/* flash the marker */
		}
	else                    /* if a key or a button was pressed */
		{
		che=getch();    /* what key? */
		switch(che)
			{
			case '\x0':     /* if an extended key */
				che=getch();    /* get Scan code */
					scrolling_display(position%2,che);
						/* scroll text or help */
					break;
			
			default:                /* if a normal key */
				switch (che)
					{       /* if ENTER or ESC, exit */
					case ENTER:enter_music();end=1;
					continue;
					case ESC:esc_music();end=1;continue;
					default:beep;
					}
			}
		}
	}
}

/*---------------------- all_events () --------------------------------*\
| This function opens a file and display all the events in sequence     |
| while displaying the marker on the screen indicating the place of the |
| event it calls the load_info() function for loading the event into    |
| the display page no. 2 and the scrolling_display() to scroll the text.|
|    IN  : filename: This file name in which the event is included      |
|          itemsno: The no. of events in the file .                     |
|          markers1,markers2: The positions of the markers indicating   |
|                             the place of the event this values are    |
|                             sent to the display_marker() function to  |
|                             display them.                             |
\*---------------------------------------------------------------------*/
all_events(filename,itemsno,markers1,markers2)
char filename[11];
int itemsno,markers1[11][2],markers2[11][2];
{
char che;
union REGS r;
int cntr,end=0;

save_letters();                         /* put letters info in heap */
disable_cursor();                       /* hide cursor */
clear(4,176,636,323);                   /* clear lesson area */
enable_cursor();                        /* show cursor */
for(cntr=0;cntr<=itemsno;cntr++)
	{                               /* for each event */
	disable_cursor();               /* hide cursor */
	load_info(filename,cntr,cntr%2);/* load lesson's information */
	switch(cntr%4)
	    {                           /* alter story teller */
	    case 0: draw_face();break;          /* man 1 */
	    case 1: draw_man2();break;          /* man 2 */
	    case 2: draw_woman();break;         /* woman */
	    case 3: draw_man3();break;          /* man 3 */
	    }
	enable_cursor();                /* show cursor */
	while(end!=1)
		{                       /* while user doesn't want to end */
		if(!kbhit() && check_buttons()!=1)
			{       /* if no key or button was pressed */ 
			switch(cntr%4)
			   {            /* animate face */
			   case 0: move_man();break;
			   case 1: move_man2();break;
			   case 2: animate_woman();break;
			   case 3: move_man3();break;
			   }
			display_marker(markers1[cntr][0],markers1[cntr][1]);
			display_marker(markers2[cntr][0],markers2[cntr][1]);
						/* flash the marker */
			}
		else            /* a key or a button was pressed */
			{
			che=getch();            /* what key? */
			if (che=='\x0')         /* if an extended key */
				{disable_cursor();      /* hide cursor */
				scrolling_display(cntr%2,getch());
						/* scroll lines or help */
				enable_cursor();}
			else            /* if a normal key */
				switch(che)
					{       /* if Esc or Enter, then end. */
					case ESC: esc_music();end=1;cntr=itemsno+1;break;
					case ENTER: enter_music();end=1;break;
					default: beep;
					}
			}
		}
		disable_cursor();               /* hide cursor */
		clear(4,176,636,323);           /* clear lessons area */
		enable_cursor();                /* show cursor */
		load_letters();                 /* get letters info. */
		end=0;                          /* do not end now */
	}
}

/*---------------------- load_info () ---------------------------------*\
| This function opens a file and reads the event text and write it on   |
| the display page no. 1 and then it copies the begining of the text to |
| the display page no. 0 .                                              |
|       IN   : filename: the name of the file containing the event      |
|              infono: the no. of the event in the file                 |
|              position: the place of the text on the screen if it's 1  |
|                        the text will be displayed on the bottom left  |
|                        else it'll be displayed on the bottom right .  |
|       OUT  : NONE                                                     |
\*---------------------------------------------------------------------*/
load_info(filename,infono,position)
char filename[12];
int infono,position;
{
int cntr,xspace;
char lines[31],title[31];
FILE *fptr;

setactivepage(1);                       /* switch to page 1 */
if(position==1) xspace=9;               /* determine text position */
else xspace=228;
if((fptr=fopen(filename,"rb"))==NULL)   /* try to open the file */
   file_error(filename);                /* on error, tell the user and exit */
for(cntr=0;cntr<=infono;cntr++)
   {                                    /* for each event in file */
   send=0;sy=sy1=10;sy2=129;            
   fread(title,1,31,fptr);              /* read lesson's title */
   titlelen=strlen(title);              /* calculate title's length */
   if(cntr==infono)                     /* if last lesson */
	{
	setfillstyle(SOLID_FILL,RED);
	setcolor(5);
	rectangle(1,1,401,27);floodfill(4,4,5);
	arabic_text(title,(titlelen*13)+((400-(titlelen*13))/2),2,0,1);
					/* write lesson title */
	getimage(1,1,399,23,buffer);    /* get it from page 1 */
	cleardevice();                  /* clear screen */
	setactivepage(0);               /* switch to page 0 */
	putimage(xspace+8,176,buffer,COPY_PUT); /* put title there */
	setactivepage(1);               /* back to page 1 */
	}
   
   while(send!=1)
	{                               /* a loop to display lesson lines */
	fread(lines,1,31,fptr);                 /* read a line from file */
	if(lines[1]!='\x0')                     /* if not a NULL line */
		{
		if(cntr==infono)                /* if last item */
		{arabic_text(lines,620,sy,0,1); /* display line on page 1 */
		sy+=20;}                        /* increment coordinate */
		}
	else                                    /* if a NULL line */
		send=1;                         /* get out of this loop */
	}
   }
getimage(240,sy1,635,sy2,letters);              /* get 1st part of text */
getimage(0,0,200,30,buffer);                    /* title */
setactivepage(0);                               /* switch to page 0 */ 
		/*---- prepare display for lesson ----*/
setcolor(2);rectangle(xspace+8,198,xspace+407,281+41);
setcolor(1);rectangle(xspace+9,199,xspace+408,282+41);
rectangle(xspace-5,198,xspace+8,322);
rectangle(xspace-5,198,xspace+8,213);setfillstyle(1,DARKGRAY);
floodfill(xspace-3,199,1);
rectangle(xspace-5,307,xspace+8,322);setfillstyle(1,DARKGRAY);
floodfill(xspace-3,309,1);
setfillstyle(1,LIGHTGRAY);floodfill(xspace-3,215,1);
setcolor(0);line(xspace-2,210,xspace+5,210);line(xspace-2,310,xspace+5,310);
line(xspace+1,202,xspace-2,210);line(xspace+1,202,xspace+5,210);
line(xspace+1,318,xspace-2,310);line(xspace+1,318,xspace+5,310);
setcolor(1);
rectangle(xspace-5,176,xspace+8,198);setfillstyle(1,BLUE);floodfill(xspace-3,177,1);
setcolor(LIGHTBLUE);
line(xspace-3,187,xspace+4,187);
putimage(xspace+10,198,letters,COPY_PUT);       /* display text */
fclose (fptr);                                  /* close file */
}

/*---------------------- menu () --------------------------------------*\
| This function moves a menu bar with a specific width and coordinates  |
| returning the position of the bar among the choices. It has an        |
| advantage as it doesn't suspend the computer until the bar is moved   |
| and this enables doing any thing while the menu is displayed such as  |
| animating the map in the main menu or playing music .                 |
|   IN   :  xcord:  x coordinate of the menu                            |
|           ycord:  y coordinate of the menu                            |
|           width:  width of the menu                                   |
|           step:   no. of pixels betweem each choice and the next      |
|           itemsno:no. of items in the menu                            |
|           choice: current choice                                      |
|           excode: scan code of the key pressed                        |
|           stepping: the no. of pixels stepped between every item      |
|                     and another .                                     |
|   OUT  :  choice: current choice                                      |
\*---------------------------------------------------------------------*/
menu(xcord,ycord,width,step,itemsno,choice,excode,stepping)
int xcord,ycord,width,step,itemsno,choice,stepping;
char excode;
{
#define inverse_choice disable_cursor();reverse(xcord,ycord+(step*choice)+(stepping*choice),xcord+width,ycord+step+(step*choice)-1+(stepping*choice));enable_cursor()
union REGS r;
int mousex,mousey,cnt,old_choice,cntr;

switch(excode)
	{               /* examine the pressed key */
	case UP:        /* if UP arrow was pressed */
		if (choice!=0)          /* if old choice isn't the first */
		   {inverse_choice;choice--;inverse_choice;}    /* decrement */
		else {inverse_choice;choice=itemsno;inverse_choice;}
				/* otherwise, point to the last item */
		break;
	
	case DOWN:      /* if DOWN arrow was pressed */
		if (choice!=itemsno)    /* if old item isn't the last */
		   {inverse_choice;choice++;inverse_choice;}
		else            /* otherwise, point to the first item */
		   {inverse_choice;choice=0;inverse_choice;}
		break;
	
	case -127:      /* mouse button */
		mousex=get_mousex();mousey=get_mousey();
					/* get mouse coordinates */
		if (mousex>xcord && mousex<xcord+width)
			if(mousey>ycord && mousey<ycord+step+(step*itemsno))
			       /* if mouse is inside the specific rectangle */
				for(cnt=0;cnt<=itemsno;cnt++)   /* for each prvious item */
					if (mousey>ycord+(step*cnt)+(stepping*choice) && 
					    mousey<ycord+step+(step*cnt)+(stepping*choice))
						{       /* if mouse is inside that rectangle */
						inverse_choice;         /* highlight it */
						for(cntr=0;cntr<=6;cntr++)
							{
							choice=cnt;
							inverse_choice;
							delay(50);
							}
						/* insert in keyboard buffer */
						r.h.ah=5;               
						r.h.ch=0x1c;
						r.h.cl=0x0d;
						int86(0x16,&r,&r);
						}
		break;
	default:
		beep;
	}
return(choice);
}

/*---------------------- double_menu () -------------------------------*\
| This function moves a menu bar among two rows it returns the choice   |
| and sets the row number in the global variable row . It doesn't halt  |
| the computer until a key is pressed so that any thing is done while   |
| the menu is displayed such as music or animation. This function uses  |
| the function menu() in moving the bar within the row .                |
|          IN  : xleft1: first row x left coordinate                    |
|                ytop1:  first row y top coordinate                     |
|                xleft2: second row x left coordinate                   |
|                ytop2:  second row y top coordinate                    |
|                width:  the width of the menu row                      |
|                step:   the no of pixels between each choice and the   |
|                        next to it                                     |
|                itemsno1: the no of items in row no. 1 of the menu     |
|                itemsno2: the no of items in row no. 2 of the menu     |
|                choice: current choice .                               |
|                excode: scan code of the key pressed                   |
|                stepping: the no. of pixels stepped between every item |
|                          and another .                                |
|          OUT : choice: the current choice whether the user has changed|
|                        it or not .                                    |
\*---------------------------------------------------------------------*/
double_menu(xleft1,ytop1,xleft2,ytop2,width,step,itemsno1,itemsno2,choice,excode,stepping)
int xleft1,ytop1,xleft2,ytop2,width,step,itemsno1,itemsno2,choice,stepping;
char excode;
{
#define row1_inverse disable_cursor();reverse(xleft1,ytop1+(step*choice)+(stepping*choice),xleft1+width,(ytop1+step-1)+(step*choice)+(stepping*choice));enable_cursor()
#define row2_inverse disable_cursor();reverse(xleft2,ytop2+(step*choice)+(stepping*choice),xleft2+width,(ytop2+step-1)+(step*choice)+(stepping*choice));enable_cursor()
union REGS r;
int checked=0,xcord,ycord,itemsno,mousex,mousey;

if(excode==-127)
	{       /* if left button was pressed */
	r.x.ax=3;
	int86(0x33,&r,&r);
	mousex=r.x.cx;mousey=r.x.dx;    /* get mouse coordinates */
				/* check mouse location */
	if(mousex>xleft1 && mousex<(xleft1+width) && row==2 && mousey>ytop1 && mousey<(ytop1+(step*(itemsno1+1))))
		{row2_inverse;row=1;row1_inverse;}
	if(mousex>xleft2 && mousex<(xleft2+width) && row==1 && mousey>ytop2 && mousey<(ytop2+(step*(itemsno2+1))))
		{row1_inverse;row=2;row2_inverse;}
	}

if (excode==RIGHT || excode==LEFT)
	{               /* if Right or Left arrow was pressed */
	if(row==1)              /* if we are in the 1st column */
		{row=2;         /* switch to column 2 */
		row1_inverse;   /* unmark old choice */
		if(choice>itemsno2)     /* if we exceed 2nd column items */
			choice=itemsno2;        /* go to last u=item there */
		row2_inverse;           /* highlight new choice */
		checked=1;}     
		/* set checked to 1 to avoid neutralizing the effect
		  of the statement by the statement next to it */
	
	if (row==2 && checked!=1)       /* if we are in 2nd column */
		{row=1;                 /* switch to 1st column */
		row2_inverse;           /* unmark old choice */
		if(choice>itemsno1)     /* if we exceed 1st col. items */
			choice=itemsno1;        /* go to last item there */
		row1_inverse;           /* highlight new choice */
		checked=1;}
	}

if (row==1) {xcord=xleft1;ycord=ytop1;itemsno=itemsno1;}
if (row==2) {xcord=xleft2;ycord=ytop2;itemsno=itemsno2;}
if(checked!=1)   /* if we did not check before, no Right or Left was pressed */
   choice=menu(xcord,ycord,width,step,itemsno,choice,excode,stepping);
				/* perform user's action in current column */
else checked=0;
return(choice);                 /* tell current choice */
}

/*---------------------- clear () -------------------------------------*\
| This function clears an area of the screen which is specified by the  |
| calling function .                                                    |
|      IN    :   x1,y1 : represent the top left x,y coordinates of the  |
|                        area.                                          |
|                x2,y2 : represent the bottom right x,y coordinates of  |
|                        the area.                                      |
|      OUT   :   NONE .                                                 |
\*---------------------------------------------------------------------*/
clear(x1,y1,x2,y2)
int x1,y1,x2,y2;
{
setfillstyle(1,0);
setcolor(0);
bar(x1,y1,x2,y2);
}

/*---------------------- draw_map () ----------------------------------*\
| This function draws the map displayed at the history_info section of  |
| the program it sends the arrays of the map to the draw_array()        |
| function and it paints it by calling the ratio_fill() function .      |
|       IN   : NONE                                                     |
|       OUT  : NONE                                                     |
\*---------------------------------------------------------------------*/
draw_map()
{
int africa[]={-91,-185,90,179,92,181,94,175,98,176,95,173,95,168,98,164,97,162,
99,157,98,156,95,156,93,150,90,148,89,150,80,147,74,138,50,147,48,147,44,145,
35,147,24,137,22,132,21,130,11,124,10,114,6,106,5,102,5,97,8,98,8,86,4,77,
5,71,18,52,21,47,21,46,35,31,37,31,40,33,46,32,50,31,51,30,55,24,56,22,61,21,
69,17,70,16,73,16,73,19,76,20,80,19,84,22,88,19,90,21,93,18,100,20,105,19,110,21,
112,19,120,22,124,20,126,22,125,24,129,23,126,27,127,31,122,36,126,37,126,40,
139,45,139,47,151,54,155,52,155,47,157,45,167,45,168,49,184,53,187,56,192,52,
198,52,195,53,207,50,208,43,211,37,210,30,207,30,205,29,204,29,200,34,192,29,
190,34,183,30,181,27,179,19,183,11,187,12,190,11,194,12,200,8,208,8,226,11,
228,5,224,1};
int europe[]={-186,-1,183,5,186,8,184,9,178,10,178,12,171,12,173,14,170,16,
169,16,167,14,165,16,173,23,171,24,167,20,166,22,170,25,165,29,161,25,162,22,
160,18,158,17,158,9,159,6,150,1,-141,-1,140,3,144,5,148,5,147,8,154,12,152,14,
148,13,145,21,143,18,146,14,138,8,135,8,132,1,-142,-22,140,24,142,25,140,28,
134,25,134,23,142,22,-128,-1,125,3,128,6,125,14,122,12,121,15,120,13,120,8,
121,7,120,5,123,3,121,1,-100,-1,94,6,95,10,90,11,90,13,85,13,83,15,79,12,
74,13,69,13,68,10,64,10,62,7,64,3,63,1};
int africa2[]={-198,-52,200,59,199,63,205,69,208,79,211,82,210,85,215,88,
216,94,216,97,220,104,222,105,223,108,228,116,233,118,235,120,244,129,241,132,
250,136,278,126,279,129,279,133,277,135,277,141,271,149,271,156,267,163,
245,185};
int asia[]={-199,-58,201,60,202,62,206,66,208,60,210,62,208,66,210,66,216,76,
216,80,219,81,224,87,225,94,228,98,231,99,240,111,240,114,241,117,244,123,
244,126,249,127,280,110,280,106,290,104,290,100,295,98,295,94,299,93,300,89,
298,88,299,85,302,86,301,81,305,77,296,72,291,73,290,72,290,68,289,65,287,65,
281,72,278,75,271,75,271,68,268,67,268,74,267,75,265,75,264,74,264,66,261,64,
260,65,257,61,257,58,254,56,260,52,265,55,265,59,267,58,271,62,282,65,284,62,
288,61,290,62,292,66,293,67,307,65,308,64,309,59,310,58,311,58};
int afcountries[]={-8,-94,16,89,28,99,32,97,35,93,38,95,47,94,49,91,51,71,
56,59,49,45,49,42,25,42,-49,-45,49,49,48,50,36,50,35,51,35,61,34,62,32,62,
31,64,30,65,28,70,27,71,5,71,-49,-42,53,40,57,37,63,39,73,38,81,35,84,32,
82,28,84,22,-56,-58,74,80,76,77,80,84,84,85,83,90,86,92,122,79,120,74,116,73,
116,66,112,65,118,62,118,51,119,42,115,40,115,36,112,36,113,32,118,29,120,22,
-118,-50,122,47,122,42,126,40,-122,-79,129,83,135,80,165,98,166,98,168,97,
170,95,170,56,172,54,170,54,174,50,-170,-89,215,89,-165,-98,165,112,160,114,
160,117,157,121,155,125,161,138,160,144,161,145,168,147,169,151,176,161,
179,164,187,162,189,167,192,166,200,168,208,164,216,162,217,159,202,149,
206,147,208,140,208,137,210,135,210,130,215,127,216,120,218,111,224,109,
-242,-127,240,129,237,130,235,133,239,134,240,137,244,134,-240,-137,238,139,
247,146,250,145,265,146,256,155,250,155,246,157,241,165,242,168,242,179,246,183};
int ascountries[]={-205,-51,208,60,209,53,209,42,213,41,213,38,211,37,
-210,-49,213,48,221,43,223,48,216,52,219,55,210,62,-221,-43,229,36,229,31,
232,26,215,30,214,32,210,30,-232,-26,240,25,240,31,245,32,242,39,250,43,
252,50,258,54,252,53,247,60,239,59,238,55,223,48,-268,-74,271,75,280,77,
290,75,290,68,287,65,-290,-75,291,91,280,98,282,105,-280,-98,264,102,
251,119,254,110,243,108,240,110};
draw(africa,(sizeof(africa)/2)-1);draw(europe,(sizeof(europe)/2)-1);
draw(africa2,(sizeof(africa2)/2)-1);draw(asia,(sizeof(asia)/2)-1);
draw(afcountries,(sizeof(afcountries)/2)-1);draw(ascountries,(sizeof(ascountries)/2)-1);
clear(2,151,638,210);setcolor(15);rectangle(3,1,638,151);rectangle(4,2,637,152);
ratio_fill(90,120,DARKGRAY,WHITE,SOLID_FILL);/*not arabic countries in africa);*/
ratio_fill(225,120,DARKGRAY,WHITE,SOLID_FILL);
ratio_fill(30,55,LIGHTGRAY,WHITE,SOLID_FILL);/*Moroco desert*/
ratio_fill(40,80,LIGHTCYAN,WHITE,SOLID_FILL);/*Muritania*/
ratio_fill(60,30,CYAN,WHITE,SOLID_FILL);/*Moroco*/
ratio_fill(100,50,LIGHTGREEN,WHITE,SOLID_FILL);/*Algerie*/
ratio_fill(122,30,LIGHTCYAN,WHITE,SOLID_FILL);/*Tunisia*/
ratio_fill(150,60,YELLOW,WHITE,SOLID_FILL);/*Libia*/
ratio_fill(190,60,GREEN,WHITE,SOLID_FILL);/*EGYPY*/
ratio_fill(190,120,BROWN,WHITE,SOLID_FILL);/*Sudan*/
ratio_fill(270,134,LIGHTCYAN,WHITE,SOLID_FILL);/*Sumalia*/
ratio_fill(238,131,GREEN,WHITE,SOLID_FILL);/*Gebuty*/
ratio_fill(250,80,YELLOW,WHITE,SOLID_FILL);/*Saudi Arabia*/
ratio_fill(204,54,GREEN,WHITE,SOLID_FILL);/*Sinai*/
ratio_fill(270,105,CYAN,WHITE,SOLID_FILL);/*Yemen*/
ratio_fill(295,80,BROWN,WHITE,SOLID_FILL);/*Oman*/
ratio_fill(285,70,LIGHTCYAN,WHITE,SOLID_FILL);/*UAE*/
ratio_fill(269,70,CYAN,WHITE,SOLID_FILL);/*Qatar*/
ratio_fill(240,45,CYAN,WHITE,SOLID_FILL);/*Iraq*/
ratio_fill(220,35,YELLOW,WHITE,SOLID_FILL);/*Syria*/
ratio_fill(213,53,BROWN,WHITE,SOLID_FILL);/*Jordan*/
ratio_fill(207,54,CYAN,WHITE,SOLID_FILL);/*Phalastine*/
ratio_fill(211,41,GREEN,WHITE,SOLID_FILL);/*Lebnan*/
ratio_fill(290,10,WHITE,WHITE,SOLID_FILL);/*unarabian countries in Asia*/
ratio_fill(170,5,WHITE,WHITE,SOLID_FILL);/*European Countries*/
ratio_fill(136,4,WHITE,WHITE,SOLID_FILL);
ratio_fill(124,7,WHITE,WHITE,SOLID_FILL);
ratio_fill(80,10,WHITE,WHITE,SOLID_FILL);
ratio_fill(137,24,WHITE,WHITE,SOLID_FILL);
ratio_fill(10,10,LIGHTBLUE,WHITE,SOLID_FILL);/*the atlantic ocean and the mediteranian*/
ratio_fill(210,75,LIGHTBLUE,WHITE,SOLID_FILL);/*the read sea,the pacefic ocean and the gulf*/
}                       

/*---------------------- draw_woman () --------------------------------*\
| This function draws the woman and the several frames of the eyes and  |
| the mouth in the display page no. 1                                   |
|       IN    : NONE                                                    |
|       OUT   : NONE                                                    |
\*---------------------------------------------------------------------*/
draw_woman()
{
int face[]={-2,-100,5,99,20,95,30,87,32,83,-25,-91,20,82,13,60,12,50,14,40,
20,26,30,16,40,10,50,9,54,10,60,13,68,20,72,30,75,40,76,50,74,60,73,63,73,55,
72,51,-73,-63,71,78,70,80,65,86,60,91,50,98,46,100,-49,-83,41,78,35,70,30,61,
27,52,27,49,29,40,34,32,45,25,50,23,55,23,60,25,63,26,67,30,70,35,71,45,70,55,
68,65,65,70,62,73,60,74,54,77,50,76,40,70,30,60,-70,-80,100,100,-34,-42,40,39,43,38,
46,39,49,41,-58,-41,64,39,66,39,70,41,-51,-48,51,55,49,57,-71,-67,68,74,65,80,
62,83,59,85};
int eyes1[]={-37,-46,40,44,43,43,46,44, 48,45, 45,46, 43,47, 38,45,
-60,-46,64,43,66,43,69,45,67,46,66,47,65,47,61,46,-42,-43,42,46,-44,-44,44,46,
-64,-43,64,47,-66,-43,66,47};
int eyes2[]={-38,-47,48,47,48,48,38,48,38,47,-61,-47,69,47,69,48,61,48,61,47};
int mouth1[]={-49,-66,53,64,55,65,57,64,61,66,49,66,55,68,57,68,61,66};
int mouth2[]={-49,-66,51,63,54,61,55,62,56,61,59,63,61,66,58,65,55,64,54,64,
49,66,54,69,56,69,61,66,55,67,49,66};
int mouth3[]={-49,-66,54,63,55,64,56,63,61,66,55,65,49,66,53,68,55,69,57,68,
61,66,55,68,49,66};

ratioy=1.6;ratiox=2.2;positionx=3;positiony=164;
setcolor(15);
draw(face,sizeof(face)/2-1);
ratio_fill(40,20,10,15,1);
ratio_fill(70,90,2,15,1);
ratio_fill(50,35,14,15,1);
setactivepage(1);
setfillstyle(1,14);bar(20,100,200,350);
setcolor(0);positiony=194;draw(eyes1,sizeof(eyes1)/2-1);positiony=204;
draw(eyes2,sizeof(eyes2)/2-1);
setfillstyle(1,15);floodfill(92,266,0);floodfill(102,266,0);
floodfill(142,266,0);floodfill(150,266,0);
setfillstyle(1,0);floodfill(98,264,0);floodfill(146,266,0);
setcolor(12);line(94,268,94,264);
positiony-=10;draw(mouth1,sizeof(mouth1)/2-1);positiony+=20;
draw(mouth2,sizeof(mouth2)/2-1);positiony+=20;
draw(mouth3,sizeof(mouth3)/2-1);
setfillstyle(1,12);floodfill(120,298,12);
floodfill(128,298,12);
floodfill(124,300,12);
floodfill(124,314,12);floodfill(124,322,12);
floodfill(120,336,12);floodfill(124,343,12);
setactivepage(0);                       /* switch to page 0 */
}

/*---------------------- draw_face () ---------------------------------*\
| This function draws the first man's face and the several frames of    |
| the eyes and the mouth in the display page no. 1 .                    |
|       IN    : NONE                                                    |
|       OUT   : NONE                                                    |
\*---------------------------------------------------------------------*/
draw_face()
{
int turban[]={-19,-71,7,55,6,51,5,45,6,34,7,27,20,15,40,7,46,5,51,5,56,7,
70,15,85,33,86,38,85,50,76,70,70,51,64,42,63,41,48,39,30,41,29,42,23,54,
19,71,-7,-51,11,36,11,36,16,30,21,26,30,20,41,16,53,16,66,24,76,34,80,38,
85,50,-46,-24,40,30,46,36,52,30,46,24};
int lash1[]={-27,-59,32,56,47,58,31,59,27,59};
int eye1[]={-34,-62,38,61,42,61,46,62,-45,-64,42,65,39,65,37,65,35,64,-39,-65,
38,63,39,61,-43,-61,42,65};
int lash2[]={-51,-58,59,56,68,58,51,58};
int eye2[]={-56,-62,61,61,67,62,-66,-64,61,65,57,64,-61,-65,59,62,-63,-65,64,62};
int closed1[]={-35,-62,46,62,46,63,35,63};
int closed2[]={-56,-62,66,62,66,63,56,63};
int nose[]={-46,-66,46,71,-43,-76,41,79,44,80,48,80,50,81,52,80,58,80,59,78,
57,76,-55,-71,55,66};
int moustache[]={-31,-91,50,88,69,91,59,84, 50,85,39,84,31,91};
int mouth3[]={-37,-92,49,89,62,92,51,96,49,96,37,92,50,91,62,92,-55,-92,
50,94,42,92};
int mouth2[]={-37,-92,50,91,62,92,50,93,37,92};
int mouth1[]={-37,-92,50,90,62,92,50,94,37,92,62,92};
int beard[]={-19,-71,33,107,42,114,50,117,59,114,69,104,76,69,66,93,59,99,
51,101,41,99,32,91,19,71};
int clothes[]={-29,-98,1,120,-22,-104,43,120,-71,-95,100,120,-78,-101,61,120};
setactivepage(0);
setcolor(15);
ratioy=1.3;ratiox=1.95;positionx=29;positiony=170;
draw(clothes,(sizeof(clothes)/2-1));
ratio_fill(20,115,BLUE,WHITE,BKSLASH_FILL);ratio_fill(85,115,BLUE,WHITE,SLASH_FILL);
draw(turban,(sizeof(turban)/2-1));
ratio_fill(30,30,DARKGRAY,WHITE,SOLID_FILL);ratio_fill(30,15,LIGHTGRAY,WHITE,SOLID_FILL);ratio_fill(45,30,GREEN,WHITE,SOLID_FILL);
draw(nose,(sizeof(nose)/2-1));
draw(moustache,(sizeof(moustache)/2-1));ratio_fill(50,86,BROWN,WHITE,INTERLEAVE_FILL);
draw(beard,(sizeof(beard)/2-1));ratio_fill(50,110,BROWN,WHITE,INTERLEAVE_FILL);
ratio_fill(50,97,YELLOW,WHITE,SOLID_FILL);ratio_fill(50,50,YELLOW,WHITE,SOLID_FILL);
ratio_fill(30,106,YELLOW,WHITE,SOLID_FILL);
setcolor(BROWN);
draw(moustache,(sizeof(moustache)/2-1));
draw(lash1,(sizeof(lash1)/2-1));draw(lash2,(sizeof(lash2)/2-1));
ratio_fill(32,57,BROWN,BROWN,SOLID_FILL);
ratio_fill(59,57,BROWN,BROWN,SOLID_FILL);
setcolor(WHITE);setfillstyle(SOLID_FILL,YELLOW);
positiony=180;
setactivepage(1);
setcolor(YELLOW);bar(40,0,160,350);setcolor(WHITE);
draw(closed1,(sizeof(closed1)/2-1));draw(closed2,(sizeof(closed2)/2-1));
positiony=190;
draw(eye1,(sizeof(eye1)/2-1));draw(eye2,(sizeof(eye2)/2-1));
ratio_fill(41,63,LIGHTBLUE,WHITE,SOLID_FILL);
ratio_fill(60,63,LIGHTBLUE,WHITE,SOLID_FILL);
setcolor(RED);
positiony=180;draw(mouth1,(sizeof(mouth1)/2-1));
ratio_fill(50,91,LIGHTRED,RED,SOLID_FILL);
ratio_fill(50,93,LIGHTRED,RED,SOLID_FILL);
positiony=200;draw(mouth2,(sizeof(mouth2)/2-1));
ratio_fill(50,92,LIGHTRED,RED,SOLID_FILL);
positiony=220;draw(mouth3,(sizeof(mouth3)/2-1));setcolor(15);
ratio_fill(50,90,LIGHTRED,RED,SOLID_FILL);
ratio_fill(51,92,BLACK,RED,SOLID_FILL);
ratio_fill(51,95,LIGHTRED,RED,SOLID_FILL);
ratio_fill(43,91,LIGHTRED,RED,SOLID_FILL);
ratio_fill(43,93,LIGHTRED,RED,SOLID_FILL);
floodfill(115,341,RED);floodfill(139,338,RED);
setactivepage(0);
}

/*---------------------- animate_woman () -----------------------------*\
| This function animates the woman's eyes and mouth by calling the      |
| animate_eye() and animate_mouth() functions .                         |
|       IN       : NONE                                                 |
|       OUT      : NONE                                                 |
\*---------------------------------------------------------------------*/
animate_woman()
{
animate_eye(76,230,76,260,76,274,82,10);
animate_mouth(102,263,102,292,102,312,102,332,40,15);
}

/*---------------------- move_man () ----------------------------------*\
| This function animates the 1st man's eyes and mouth by calling the    |
| animate_eye() and animate_mouth() functions .                         |
|       IN       : NONE                                                 |
|       OUT      : NONE                                                 |
\*---------------------------------------------------------------------*/
move_man()
{
animate_eye(92,247,95,268,95,258,65,7);
animate_mouth(101,285,101,295,101,315,101,335,49,9);
}

/*---------------------- move_man2 () ---------------------------------*\
| This function animates the 2nd man's eyes and mouth by calling the    |
| animate_eye() and animate_mouth() functions .                         |
|       IN       : NONE                                                 |
|       OUT      : NONE                                                 |
\*---------------------------------------------------------------------*/
move_man2()
{
animate_eye(482,254,52,260,52,270,70,10);
animate_mouth(496,289,104,295,104,315,104,335,44,9);
}


/*---------------------- move_man3 () ---------------------------------*\
| This function animates the 3rd man's eyes and mouth by calling the    |
| animate_eye() and animate_mouth() functions .                         |
|       IN       : NONE                                                 |
|       OUT      : NONE                                                 |
\*---------------------------------------------------------------------*/
move_man3()
{
animate_eye(490,253,52,260,52,270,70,10);
animate_mouth(502,285,104,295,104,315,104,335,44,9);
}

/*---------------------- draw_man3 () ---------------------------------*\
| This function draws the third man's face and the several frames of    |
| the eyes and the mouth in the display page no. 1 .                    |
|       IN    : NONE                                                    |
|       OUT   : NONE                                                    |
\*---------------------------------------------------------------------*/
draw_man3()
{
int face[]={-26,-67,26,82,32,90,40,96,45,97,50,96,62,85,63,62,63,64,58,74,
51,83,45,84,39,83,30,75,26,68,26,54,30,45,36,42,45,40,54,42,60,45,62,49,
63,62,-26,-67,17,65,10,57,9,40,11,30,20,16,30,10,40,9,50,10,60,12,70,18,
79,30,80,36,79,42,78,56,74,63,63,64,-26,-56,20,50,19,45,20,40,32,26,36,23,
56,12,-48,-16,64,25,77,42,79,46,-35,-24,52,30,64,40,74,52,76,60,
-41,-63,41,65,40,70,42,71,
-46,-62,46,66,47,70,45,71,-26,-77,1,100,-62,-77,90,100};
int lashes[]={-29,-57,32,54,38,54,43,56,34,56,29,57,-45,-56,50,53,54,53,59,56,51,55,45,56,
-32,-78,37,74,43,73,52,74,58,78,50,76,39,76,32,78};
int eyes[]={-26,-95,30,92,33,92,36,92,40,97,-40,-96,36,98,31,98,26,95,-31,-98,
30,94,32,91,-35,-92,36,94,35,98,-60,-96,64,92,70,92,75,95,70,98,65,98,60,96,
-65,-98,65,94,66,92,69,92,70,96,69,98};
int eyes2[]={-26,-95,40,95,40,96,26,96,-60,-96,75,96,75,97,60,97};
int mouth2[]={-37,-92,50,91,62,92,50,93,37,92};
int mouth1[]={-37,-92,50,90,62,92,50,94,37,92,62,92};
int mouth3[]={-37,-92,49,89,62,92,51,96,49,96,37,92,50,91,62,92,-55,-92,50,94,42,92};
setcolor(15);ratiox=2.45;ratioy=1.65;positionx=415;positiony=161;
draw(face,sizeof(face)/2-1);
ratio_fill(40,50,14,15,1);ratio_fill(30,20,4,15,1);ratio_fill(40,35,12,15,1);ratio_fill(50,25,4,15,1);
ratio_fill(60,17,12,15,1);ratio_fill(40,90,6,15,6);ratio_fill(20,95,2,15,1);
positiony=159;setcolor(0);draw(lashes,sizeof(lashes)/2-1);
setfillstyle(6,0);floodfill(546,248,0);floodfill(502,250,0);floodfill(516,282,0);
floodfill(554,250,0);floodfill(489,252,0);
ratiox=1.3;ratioy=0.9;setactivepage(1);setfillstyle(1,14);bar(40,0,160,350);
positionx=20;positiony=180;setfillstyle(1,14);bar(40,0,160,350);
setcolor(0);draw(eyes,(sizeof(eyes)/2-1));
ratio_fill(67,96,BROWN,0,SOLID_FILL);ratio_fill(72,96,WHITE,0,SOLID_FILL);/*fill eyes*/
ratio_fill(28,95,WHITE,0,SOLID_FILL);ratio_fill(38,96,WHITE,0,SOLID_FILL);
ratio_fill(33,95,BROWN,0,SOLID_FILL);ratio_fill(63,96,WHITE,0,SOLID_FILL);
positiony+=10;draw(eyes2,sizeof(eyes2)/2-1);
ratioy=1.3;ratiox=1.95;positionx=29;setcolor(4);
positiony=180;draw(mouth1,(sizeof(mouth1)/2-1));
ratio_fill(50,91,RED,RED,SOLID_FILL);ratio_fill(50,93,RED,RED,SOLID_FILL);
positiony=200;draw(mouth2,(sizeof(mouth2)/2-1));
ratio_fill(50,92,RED,RED,SOLID_FILL);
positiony=220;draw(mouth3,(sizeof(mouth3)/2-1));setcolor(15);
ratio_fill(50,90,RED,RED,SOLID_FILL);ratio_fill(51,92,BLACK,RED,SOLID_FILL);
ratio_fill(51,95,RED,RED,SOLID_FILL);ratio_fill(43,91,RED,RED,SOLID_FILL);
ratio_fill(43,93,RED,RED,SOLID_FILL);floodfill(115,341,RED);floodfill(139,338,RED);
setactivepage(0);
}

/*---------------------- draw_man2 () ---------------------------------*\
| This function draws the second man's face and the several frames of   |
| the eyes and the mouth in the display page no. 2 .                    |
|       IN    : NONE                                                    |
|       OUT   : NONE                                                    |
\*---------------------------------------------------------------------*/
draw_man2()
{int face1[]={-51,-7,49,9,49,30,44,30,44,32,35,35,28,38,19,45,11,58,10,60,5,65,
5,67,10,67,5,71,4,73,5,76,5,90,19,109,21,115,22,121,23,125,26,126,32,134,
40,140,44,141,54,142,64,141,71,136,73,135,78,129,82,118,84,110,85,100,
88,110,85,100,79,91,71,80,52,58,47,57,44,55,16,84,17,80,16,84,15,88,18,92,
19,96,16,99,17,104,18,109};
int face2[]={-89,-110,93,102,93,99,94,96,93,88,96,89,97,83,94,77,97,73,96,66,
89,55,70,40,57,34,57,30,53,30,53,9,51,7,-53,-30,44,30,44,34,57,34,-11,-58,
29,50,43,46,43,51,44,56,-43,-46,46,44,51,42,58,44,59,50,58,55,55,58,52,58,
-59,-46,96,67};
int beard[]={-19,-108,19,121,20,150,21,154,27,158,31,160,42,159,45,162,52,162,
55,164,60,163,74,162,83,154,85,151,86,142,89,108};
int moustache[]={-28,-129,43,122,60,122,77,130,-75,-132,61,127,43,127,30,131};
int nose[]={-54,-97,54,106,55,110,55,112,53,117,-57,-111,60,111,63,113,64,115,
60,118,57,118,52,120,47,118,42,118,40,115,41,112};
int lashes[]={-21,-88,21,85,29,81,34,83,45,84,46,89,32,87,29,87,25,87,21,88,
-54,-88,59,87,63,83,66,83,78,89,78,91,69,89,63,90,58,90,54,88};
int eyes[]={-26,-95,30,92,33,92,36,92,40,97,-40,-96,36,98,31,98,26,95,-31,-98,
30,94,32,91,-35,-92,36,94,35,98,-60,-97,64,93,70,93,75,96,70,99,65,99,60,97,
-65,-99,65,95,66,93,69,93,70,97,69,99};
int eyes2[]={-26,-95,40,95,40,96,26,96,-60,-97,75,97,75,98,60,98};
int clothes[]={-86,-142,140,170,-21,-140,-30,170,-93,-103,99,112,105,151};
int mouth2[]={-37,-92,50,91,62,92,50,93,37,92};
int mouth1[]={-37,-92,50,90,62,92,50,94,37,92,62,92};
int mouth3[]={-37,-92,49,89,62,92,51,96,49,96,37,92,50,91,62,92,-55,-92,
50,94,42,92};
setcolor(15);ratiox=1.3;ratioy=0.9;positionx=450;positiony=175;
draw(face1,(sizeof(face1)/2-1));draw(face2,(sizeof(face2)/2-1));
draw(beard,(sizeof(beard)/2-1));draw(moustache,(sizeof(moustache)/2-1));
draw(nose,(sizeof(nose)/2-1));draw(lashes,(sizeof(lashes)/2-1));
draw(clothes,(sizeof(clothes)/2-1));
ratio_fill(50,150,WHITE,WHITE,INTERLEAVE_FILL);
ratio_fill(50,151,LIGHTGRAY,WHITE);             /* fill beard */
ratio_fill(50,125,WHITE,WHITE,INTERLEAVE_FILL);
ratio_fill(50,126,DARKGRAY,WHITE);              /* fill moustache */
ratio_fill(50,135,YELLOW,WHITE,SOLID_FILL);
ratio_fill(50,80,YELLOW,WHITE,SOLID_FILL);      /* fill face */
ratio_fill(20,70,LIGHTGREEN,WHITE,SOLID_FILL);
ratio_fill(80,70,LIGHTGREEN,WHITE,SOLID_FILL);
ratio_fill(30,40,LIGHTGRAY,WHITE,SOLID_FILL);
ratio_fill(50,32,DARKGRAY,WHITE,SOLID_FILL);
ratio_fill(51,20,DARKGRAY,WHITE,SOLID_FILL);
ratio_fill(50,50,LIGHTRED,WHITE,SOLID_FILL);    /* fill head wearings */
ratio_fill(28,84,LIGHTGRAY,WHITE,SOLID_FILL);
ratio_fill(65,87,LIGHTGRAY,WHITE,SOLID_FILL);   /* fill eye lashes */
ratio_fill(10,160,LIGHTBLUE,WHITE,SOLID_FILL);
ratio_fill(90,120,GREEN,WHITE,SOLID_FILL);
setactivepage(1);setfillstyle(1,14);bar(40,0,160,350);
positionx=20;positiony=180;setfillstyle(1,14);bar(40,0,160,350);
setcolor(0);draw(eyes,(sizeof(eyes)/2-1));
ratio_fill(67,96,BROWN,0,SOLID_FILL);ratio_fill(72,96,WHITE,0,SOLID_FILL);
						/*fill eyes*/
ratio_fill(28,95,WHITE,0,SOLID_FILL);ratio_fill(38,96,WHITE,0,SOLID_FILL);
ratio_fill(33,95,BROWN,0,SOLID_FILL);ratio_fill(63,96,WHITE,0,SOLID_FILL);
positiony+=10;draw(eyes2,sizeof(eyes2)/2-1);
ratioy=1.3;ratiox=1.95;positionx=29;setcolor(4);
positiony=180;draw(mouth1,(sizeof(mouth1)/2-1));
ratio_fill(50,91,LIGHTRED,RED,SOLID_FILL);
ratio_fill(50,93,LIGHTRED,RED,SOLID_FILL);
positiony=200;draw(mouth2,(sizeof(mouth2)/2-1));
ratio_fill(50,92,LIGHTRED,RED,SOLID_FILL);
positiony=220;draw(mouth3,(sizeof(mouth3)/2-1));setcolor(15);
ratio_fill(50,90,LIGHTRED,RED,SOLID_FILL);
ratio_fill(51,92,BLACK,RED,SOLID_FILL);
ratio_fill(51,95,LIGHTRED,RED,SOLID_FILL);
ratio_fill(43,91,LIGHTRED,RED,SOLID_FILL);
ratio_fill(43,93,LIGHTRED,RED,SOLID_FILL);
floodfill(115,341,RED);floodfill(139,338,RED);
setactivepage(0);
}

/*---------------------- animate_eye () -------------------------------*\
| This function copies one of the frames drawn in the display page no.  |
| 1 into the display page no . 0 .                                      |
| The frame is chosen at random .                                       |
|       IN      : p1x,p1y: x,y coordinates of the place in which the    |
|                 eyes will be put .                                    |
|                 p2x1,p2y1,p2x2,p2y2: x,y corrdinates for the frames   |
|                                      on the display page no. 1        |
|                 length: length of the frame                           |
|                 width : width of the frame                            |
|       OUT     : NONE                                                  |
\*---------------------------------------------------------------------*/
animate_eye(p1x,p1y,p2x1,p2y1,p2x2,p2y2,length,width)
int p1x,p1y,p2x1,p2y1,p2x2,p2y2,length,width;
{
int rand_no;

rand_no=rand();                 /* pick a random number */
disable_cursor();               /* hide cursor */
setactivepage(1);               /* switch to page 1 */
if (rand_no<=28000)             /* determine which image to get */
getimage(p2x1,p2y1,p2x1+length,p2y1+width,buffer);
else getimage(p2x2,p2y2,p2x2+length,p2y2+width,buffer);
setactivepage(0);               /* switch to page 0 */
putimage(p1x,p1y,buffer,COPY_PUT);      /* put image there */
enable_cursor();                        /* show cursor */
}

/*---------------------- animate_mouth () -----------------------------*\
| This function animates the mouth of tehs tory teller.                 |
| It works in a very similar manner like the animate_eye() function.    |
|       IN  : p1x, ... p2y3: coords. of three images of mouth.          |
|             lenght, width: of a mouth image.                          |
|       OUT : NONE.                                                     |
\*---------------------------------------------------------------------*/
animate_mouth(p1x,p1y,p2x1,p2y1,p2x2,p2y2,p2x3,p2y3,length,width)
int p1x,p1y,p2x1,p2y1,p2x2,p2y2,p2x3,p2y3,length,width;
{
int rand_no;

rand_no=rand();                         /* pick a random number */
disable_cursor();                       /* hide cursor */
setactivepage(1);                       /* switch to page 1 */
				/* determine which image to display */
if (rand_no<=32767) getimage(p2x1,p2y1,p2x1+length,p2y1+width,buffer);
if (rand_no<=20000) getimage(p2x2,p2y2,p2x2+length,p2y2+width,buffer);
if (rand_no<=10000) getimage(p2x3,p2y3,p2x3+length,p2y3+width,buffer);
setactivepage(0);                       /* switch to page 0 */ 
putimage(p1x,p1y,buffer,COPY_PUT);      /* put image there */
enable_cursor();                        /* show cursor */
}

/*---------------------- display_marker -------------------------------*\
| This function displays a marker on the map. That marker determines the|
| location of the event being told now.                                 |
|               IN  : markx, marky: coordinates of the marker.          |
|                     if one of them is -ve, the function delays only.  |
|               OUT : NONE.                                             |
\*---------------------------------------------------------------------*/
display_marker(markx,marky)
int markx,marky;
{
if(markx>=0 && marky>=0)
{
	disable_cursor();                       /* hide cursor */
	getimage(markx-5,marky-5,markx+5,marky+5,buffer);/* get back. image */
	setcolor(4);circle(markx,marky,5);circle(markx,marky,3);/* draw */
	setfillstyle(SOLID_FILL,4);floodfill(markx,marky,4);
	enable_cursor();                        /* show cursor */
	delay(75);                              /* delay */
	disable_cursor();                       /* hide cursor */
	putimage(markx-5,marky-5,buffer,COPY_PUT);      /* restore backgr. */
	enable_cursor();                        /* show cursor */
}
else delay(75);
}
/*---------------------- draw () --------------------------------------*\
| This function draws a picture which is divided into many lines with   |
| coordinates stored in the array argument with length in the argument  |
| size. The x and y scales must be sent in the global vaariables ratiox |
| and ratioy . The origin point x,y coordinates is stored in the global |
| variables positionx and position y .                                  |
| In this function if the coordinates are +ve a line is drawn from the  |
| current position to the point and if the coordinates are -ve the      |
| current position is changed to the coordinates without drawing , this |
| helps in drawing the non-continuous pictures .                        |
|       IN: array: array of coordinates of the points                   |
|           size: size of the array                                     |
|       OUT: NONE                                                       |
\*---------------------------------------------------------------------*/
draw(array,size)
int array[],size;
{
int count,x,y;

for (count=0;count<=size;count+=2)              /* for each point */
{
float result;
if ( (array[count]<0) && (array[count+1]< 0) )
{       /* if negative coordinaes , then move without drawing */
x=positionx+floor((-array[count])*ratiox);      /* calculate x-ccord. */
y=positiony+floor((-array[count+1])*ratioy);    /* calculate y-coord. */
moveto(x,y);}                                   /* move to there */

else                                    /* otherwise, draw */
   {
   x=positionx+floor(array[count]*ratiox);      /* calculate x-coord. */
   y=positiony+floor(array[count+1]*ratioy);    /* calculate y-coord. */
   lineto(x,y);}                                /* draw a line */
   }
}

/*---------------------- ratio_fill () --------------------------------*\
| This function paints a specific area but it differs from the          |
| floodfill() function that the coordinates of the place is calculated  |
| using the x,y scales in the global variables ratiox and ratioy and it |
| paints starting from the origin point with coordinates positionx and  |
| positiony .                                                           |
|       IN    : xcord,ycord: x,y coordinates of the place to paint      |
|               color: the colour to paint with.                        |
|               border: the border                                      |
|               pattern: The fill pattern .                             |
|               See floodfill() and setfillstyle() for more information |
|               about the border and thepattern arguments .             |
|       OUT   : NONE                                                    |
\*---------------------------------------------------------------------*/
ratio_fill(xcord,ycord,color,border,pattern)
int xcord,ycord,color,border,pattern;
{
setfillstyle(pattern,color);
xcord=positionx+floor(xcord*ratiox);
ycord=positiony+floor(ycord*ratioy);
floodfill(xcord,ycord,border);
}

/*---------------------- reverse () -----------------------------------*\
| This function reverses the colour of a portion of the screen.         |
|       IN : x1,y1:start x,y coordinates of the area                    |
|            x1,y2:end x,y coordinates of the area                      |
|       OUT: NONE                                                       |
\*---------------------------------------------------------------------*/
reverse(x1,y1,x2,y2)
int x1,y1,x2,y2;
{
getimage(x1,y1,x2,y2,buffer);                   /* get the image */
putimage(x1,y1,buffer,NOT_PUT);                 /* put it reversed */
}

/*---------------------------buffer_put()---------------------------*\
| This function pokes a character into the keyboard's buffer , this  |
| may be either esc , enter , up , down .			     |
| This is done by calling service 1 of function 16 using the int86   |
| function .                                                         |
| In : ch: The character to be put in the buffer                     |
| Out: None							     |
\*------------------------------------------------------------------*/
buffer_put(ch)
char ch;
{
union REGS r;
switch((char)ch)
	{
	case ESC:
		r.h.ch=01;
		r.h.cl=0x1b;
		break;
	case ENTER:
		r.h.ch=0x1c;
		r.h.cl=0xd;
		break;
	case UP:
		r.h.ch=0x48;
		r.h.cl=0xe0;
		break;
	case DOWN:
		r.h.ch=0x50;
		r.h.cl=0xe0;
		break;
	default:
		printf("Unknown Error");exit(0);
	}
clear_buffer();
r.h.ah=5;
int86(0x16,&r,&r);
}
/*---------------------- save_letters () ------------------------------*\
| This function copies the array letters to far memory if the memory is |
| available and this is checked through the variable slow which is set  |
| on to (1) in the main() function and if the far memory isn't          |
| available it does. nothing.                                           |
|       IN      : NONE                                                  |
|       OUT     : NONE                                                  |
\*---------------------------------------------------------------------*/
save_letters()
{
int i;

if(slow!=1)    /* if we are not in the slow mode, ie. letters are in memory */
for(i=0;i<=17748;i++)   /* for each character in letters[] array */
   *(pt+i)=letters[i];  /* copy it to heap */
}

/*---------------------- load_letters () ------------------------------*\
| This function copies the memory at the offset *pt to the letters[]    |
| array and this memory contains the array of the arabic letters and if |
| the memory wasn't available and the save_letters function hasn't      |
| copied the letters[] array to the memory it sets the global variable  |
| (init16) to (0) which will cause the arabic_text() function to load   |
| the arabic letters array from the file letdat.16c and this needs more |
| time than copying it from memory so, the program is in the slow mode. |
|       IN       : NONE.                                                |
|       OUT      : NONE.                                                |
\*---------------------------------------------------------------------*/
load_letters()
{
int i;
if(slow!=1)                     /* if not in slow mode */
for(i=0;i<=17748;i++)           /* for each charcater in heap */
	letters[i]=*(pt+i);             /* copy it in letters[] */
else
	init16=0;            /* else mark that characters are not in array */
}

/*---------------------- enter_music () -------------------------------*\
| This function plays the music when ENTER is pressed.                  |
|       IN      : NONE                                                  |
|       OUT     : NONE                                                  |
\*---------------------------------------------------------------------*/
enter_music()
{
play("ml o5 l32 a b c d e d a c",0);
}

/*---------------------- esc_music () ---------------------------------*\
| This function plays the music when ESC is pressed.                    |
|       IN     : NONE                                                   |
|       OUT    : NONE                                                   |
\*---------------------------------------------------------------------*/
esc_music()
{
play("ml o5 l32 f c d a b c d f",0);
}

/*---------------------- f1_music () ----------------------------------*\
| This function plays the music when F1 is pressed.                     |
|       IN   : NONE                                                     |
|       OUT  : NONE                                                     |
\*---------------------------------------------------------------------*/
f1_music()
{
play("ml l20 o5 a b d a c d f",0);
}

/*---------------------- clear_buffer () ------------------------------*\
| This function checks the keyboard's buffer and emptys it.             |
|       IN        : NONE                                                |
|       OUT       : NONE                                                |
\*---------------------------------------------------------------------*/
clear_buffer()
{
while (kbhit())                 /* while the buffer isn't empty... */
	getch();                        /* ... remove a character from it */
}

/***********************************************************************\
|        E N D   O F   H I S T O R Y . C   S O U R C E   C O D E        |
\***********************************************************************/

