struct music
	{
	int octave,leg_or_stac,length,last_freq,last_leg_or_stac;
	};
struct music current;

/*---------------------- play () --------------------------------------*\
| This function plays a music tone passed to it a string of characters. |
| It emulates the PLAY statement of BASIC language. This function is    |
| a general one and can be used in any other program to make playing    |
| music easier.                                                         |
|               IN  : str, the string to play.                          |
|                     check, determines if the user has the ability to  |
|                            interrupt playing the note by clicking     |
|                            a mouse button or pressing a key.          |
|               OUT :                                                   |
\*---------------------------------------------------------------------*/
play (str,check)
char str[];
int check;
{
#define staccato 1
#define legato 0
char ch;
int i=0,value,strln,bufclear=0;

strln=strlen(str);              /* calculate string length */
current.last_freq=0;            
if(check==2) {bufclear=1;check=1;}
while (i!=strln+1)
{
if ((!kbhit() && check_buttons()==0) || ((kbhit() || check_buttons()!=0) && 
     check==0))
	switch(str[i])          /* examine current character */
		{
		case 'o':       /* If 'o', then change octave */
					/* octave number follows 'o' */
			sscanf(&str[i+1],"%d ",&value); 
			current.octave=value+2; /* Set octave of tone */
			i+=3;  /* increment character counter by three to 
							skip octave value */
			break;
		
		case 'm':       /* If 'm', determine staccato or legato */
			sscanf(&str[i+1],"%c",&ch); /* check next char */
			switch(ch)
				{
				case 's':       /* if s, staccato */
					current.leg_or_stac=staccato;
					break;
				case 'l':       /* if l, legato */
					current.leg_or_stac=legato;
					break;
				}
			i+=3;           /* increment character counter */
			break;
		
		case 'l':       /* if 'L', then determine tone length */
			sscanf(&str[i+1],"%d",&value);  /* get value */
			if (value>=10) i+=4;    
			else i+=3;      /* increment character counter */
			current.length=value;   /* set tone length */
			break;
		
		case 'p':       /* If 'p', then pause */
			sscanf(&str[i+1],"%d",&value);  /* get pause time */
			if (value>=10) i+=4;
			else i+=3;      /* increment character counter */
			nosound();      /* turn speaker off */
			delay((1000*(7.69230761/value/4)));  /* pause */
			break;

		default:        /* Any other character ...  */
			i+=soun(&str[i]); /* play note and increment */      
			break;
		}
else break;
}
nosound();                              /* turn speaker off */
if(bufclear!=1) clear_buffer();
}

/*---------------------- soun () --------------------------------------*\
| This function is passed a substrin g from the play() function. The    |
| passed substring begins with a note specifier. This function plays    |
| taht note.                                                            |
|               IN  : str, the passed substring to be played.           |
|               OUT : retruns the number of characters read from str.   |
\*---------------------------------------------------------------------*/
soun(str)
char *str;
{
int freq,value,returnvalue;

value=pow(2,current.octave);
	switch(*str)    /* examine first character and calculate frquency */
		{
		case 'c':       /* DO */
			freq=(16.35*value);returnvalue=2;
			if (*(str+1)=='#') {freq=(17.32*value);returnvalue=3;}
			break;
		case 'd':       /* RE */
			freq=(18.35*value);returnvalue=2;
			if (*(str+1)=='#') {freq=(19.45*value);returnvalue=3;}
			break;
		case 'e':       /* ME */
			freq=(20.6*value);returnvalue=2;
			break;
		case 'f':       /* FA */
			freq=(21.83*value);returnvalue=2;
			if (*(str+1)=='#') {freq=(23.12*value);returnvalue=3;}
			break;
		case 'g':       /* SOL */
			freq=(24.5*value);returnvalue=2;
			if (*(str+1)=='#') {freq=(25.96*value);returnvalue=3;}
			break;
		case 'a':       /* LA */
			freq=(27.5*value);returnvalue=2;
			if (*(str+1)=='#') {freq=(29.14*value);returnvalue=3;}
			break;
		case 'b':       /* CE */
			freq=(30.87*value);returnvalue=2;
			break;

		}
if ((current.last_freq!=freq) 
   || (current.last_leg_or_stac==staccato) || (
   current.leg_or_stac==staccato)) 
      sound(freq);
if (current.leg_or_stac==staccato) 
   delay((1000*(7.6923076/current.length/4))*7/8);
else 
   delay((1000*(7.6923076/current.length/4)));
if (current.leg_or_stac==1) nosound();
if (current.leg_or_stac==1) delay((1000*(7.6923076/current.length/4))*1/8);
if(current.leg_or_stac!=1) current.last_freq=freq;
current.last_leg_or_stac=current.leg_or_stac;
return(returnvalue);
}
