#include <graphics.h>
#include <stdio.h>
#include <time.h>
#include <stdlib.h>
#include <dos.h>
#include <math.h>
#include <process.h>
#include "arabic.c"
#include "mouse.c"
#include "muslib.c"
#define beep putch(7)
#define display_line arabic_text(st,editx,edity,0,1)
#define UP 72
#define DOWN 80
#define ESC 27
#define ENTER 13
char st[51];
int slow=0;
int far *pt;
float ratiox,ratioy;
int positionx,positiony;

/*---------------------- main () --------------------------------------*\
| This is the main function of the program. Execution starts here.      |
|       IN  : argc, number of command-line parameters,                  |
|             argv, pointers to command-line parameters.                |
|       OUT : NONE.                                                     |
\*---------------------------------------------------------------------*/
main(int argc,char *argv[])
{
initialize_graph();                     /* get into graphics mode */

if(farcoreleft()>=36000)                /* if enough heap */
	pt=(int far*)farmalloc(35496);  /* prepare to store letters info */
else                                    /* otherwise... */
	{slow=1;init16=0;}              /* ... set slow mode */
start_mouse();                          /* detect mouse and enable it */
while(1)
	ques_menu(argc,argv);           /* display menu */
}

/*---------------------- ques_menu () ---------------------------------*\
| This function displays the menu of the program.                       |
| It takes the command-line parameters of the main() function.          |
|       IN  : argc, number of comm.-line parameters,                    |
|             argv, pointers to those parameters,                       |
|               argv[1] is the file containing questions.               |
|               argv[2] is the program to be executed after the exam.   |
|       OUT : NONE.                                                     |
\*---------------------------------------------------------------------*/
ques_menu(int argc,char *argv[])
{
int end=0,choice=0,quesno[]={10,20,30};
char ch;
struct palettetype pal;
disable_cursor();
cleardevice();                          /* clear screen */
getpalette(&pal);
setcolor(15);line(20,50,620,50);
arabic_text("HsJJJzJJJgJJJm",400,27,0,2);       /* display menu */
arabic_text("01 HsJJzJJgJm",400,140,0,1);
arabic_text("02 sJJJJJJchg",400,160,0,1);
arabic_text("03 sJJJJJJchg",400,180,0,1);
draw_frame();
f1_message();                   /* display "Press F1 for Help" in Arabic */
reverse(220,140,420,159);               /* highlight 1st choice */
arabic_text("hojv u]] hGszgm :",560,100,0,1);
setfillstyle(1,12);floodfill(30,40,15);
enable_cursor();
while(end!=1)
	{                       /* while user does not want to get back */
	if(!kbhit() && !check_buttons())
				/* if no mouse button or key was pressed */
		animate_frame();                        /* animate image */
	else                    /* if a key or a button was pressed */
		{
		ch=getch();             /* what key? */
		if(ch==0)               /* if an extended key */
			{
			ch=getch();     /* get Scan code */
			if(ch!=59)      /* if not F1 */
			   choice=menu(220,140,200,20,2,choice,ch,0);
					/* perform user's action */
			else help(0);   /* otherwise, help the user */
			}
		else                    /* if a normal key */
			switch(ch)
				{       /* examine the pressed key */
				case ENTER: enter_music();
						setallpalette(&pal);
					     ques_load(argv[1],quesno[choice]); /* load questions */
					     end=1;break;
				 case ESC :esc_music();
					   closegraph();
					   if(execl(argv[2],0)==-1)     /* try to execute */
					      file_error(argv[2]);break;        /* on error, tell the user and exit */
				}
		}
	}


}


/*---------------------- initialize_graph () --------------------------*\
| This function initializes the screen into graphices mode EGAHigh.     |
|       IN  : NONE.                                                     |
|       OUT : NONE.                                                     |
\*---------------------------------------------------------------------*/
initialize_graph()
{
int g=EGA,gm=EGAHI;
registerbgidriver(EGAVGA_driver);
initgraph(&g,&gm,"");                   /* initialize graph! */
}

/*---------------------- ques_load () ---------------------------------*\
| This function loads questions from a disk file. It then displays the  |
| questions to the user and waits for the answer.                       |
|       IN  : fn, name of the questions file,                           |
|             ques, number of required questions.                       |
|       OUT : NONE.                                                     |
\*---------------------------------------------------------------------*/
ques_load(fn,ques)
char *fn;
int ques;
{
FILE *fptr;
int i,choice=0,end=0,handle,quesno=0,rand_no,cnt=0,cntr=0,right=0,percent,disp_message=1;
char ch;
struct question
	{
	char header[41],choices[3][21];
	int answer;
	} questions[60];                /* maximum 60 questions */

randomize();                            /* prepare to pick a random quest. */
disable_cursor();cleardevice();         /* clear screen */
brushed_background(4);                  /* draw a brushed background */
fptr=fopen(fn,"rb");                    /* open questions file */
handle=fileno(fptr);                    /* get file handler */
quesno=filelength(handle)/106;          /* total number of questions in the file */
						/* note: question size = 106 btes */
if(quesno>59) quesno=59;
while(cnt<quesno)             /* while the required number of quest. isn't read yet */
{fread(&questions[cnt],106,1,fptr);cnt++;}      /* read a question from file */
fcloseall();                                    /* close questions file */
setcolor(15);rectangle(0,0,639,30);rectangle(3,3,635,26);
arabic_text("HsJJJJzJJJJgJJJJi",430,7,0,2);     /* title */
setfillstyle(1,6);floodfill(5,5,15);setfillstyle(1,12);floodfill(2,2,15);
rectangle(0,30,639,349);
enable_cursor();                                /* show mouse cursor */
for(cntr=0;cntr<ques;cntr++)
	{                       /* for every question */
	choice=end=0;rand_no=rand()%quesno;     /* pick a random number */
	disable_cursor();                       /* hide cursor */
	f1_message();                           /* display help message */
	setfillstyle(1,14);bar(30,69,610,91);
	arabic_text(questions[rand_no].header,595,70,0,1);      /* display question header */
	setfillstyle(1,0);setcolor(15);bar(30,199,610,221);rectangle(29,198,611,222);
	for(cnt=0;cnt<=2;cnt++)
	   {
	   rectangle(174,92+(cnt*23),466,115+(cnt*23));
	   bar(175,93+(cnt*23),465,114+(cnt*23));             
	   }
	setcolor(6);rectangle(29,68,611,92);
	for(cnt=0;cnt<=2;cnt++)         /* display the 3 available choices */
	   arabic_text(questions[rand_no].choices[cnt],447,93+(23*cnt),0,0);
	reverse(175,93,465,114);                /* highlight the first one */
	enable_cursor();                        /* show cursor */
	while(end!=1)
		{               
		if(kbhit() || check_buttons())
		{       /* if a key or a button was pressed */
		ch=getch();
		if(ch==0)       /* if an extended key */
			{
			ch=getch();     /* get Scan code */
			if(ch!=59)      /* if not F1 */
			   choice=menu(175,93,290,22,2,choice,ch,1);
						/* perform user's action */
			else help(0);   /* if F1, display a help message */
			}
		else                    /* if a normal key */
			switch(ch)
				{       /* what key */
				case ESC:esc_music();
					end=1;cntr=ques+2;disp_message=0;break;
				case ENTER:     /* if ENTER */
					   if(choice==questions[rand_no].answer)        /* if the right answer was chosen */
						{arabic_text("hT[hfm wpdpm",400,200,0,1);right_music();right++; /* tell the user and increment the right counter */
						if(wait_key_or_mouse()==27) {end=1;cntr=ques;disp_message=0;break;}
						}
					else                    /* if wrong answer */
						{arabic_text("hT[hfm hgwpdpm id :",596,200,0,1);arabic_text(questions[rand_no].choices[questions[rand_no].answer],345,200,0,1);wrong_music();
						if(wait_key_or_mouse()==27) {end=1;cntr=ques;disp_message=0;break;}
						}
					end=1;break;
				default: beep;
				}
			}
		}
	}
percent=ceil((float)right/ques*100);/* calculate percentage of right answers */
if(disp_message==1) display_degree(percent);
}

/*---------------------- display_degree () ----------------------------*\
| This function displays the overall percentage of the right answers.   |
| It uses a very attractive way to display the percentage value. It     |
| shows a scale containing the differnt percentages and a horse is      |
| running from 0% towards the actual value of user's percentage. It     |
| stops at the right percentage.                                        |
|       IN  : percent, the user's percentage.                           |
|       OUT : NONE.                                                     |
\*---------------------------------------------------------------------*/
display_degree(percent)
int percent;
{
char *messages[]={"qudt >","lrf,g >","[d] >","[d] []h >","lljh. >"}     /* grades */
     ,buffer[10];
int message,frame_no=0,cnt;
int hills[]={-20,-36,43,16,55,11,60,10,65,11,75,14,80,17,91,25,108,40,120,31,124,26,
	     132,17,137,13,140,11,145,10,150,11,160,14,165,18,172,23,184,40,-91,-25,108,20,110,19,112,20,
	     124,25};

disable_cursor();cleardevice();brushed_background(6);    /* clear screen */
setcolor(15);rectangle(0,0,639,30);rectangle(3,3,635,26);
arabic_text("hgJJkJJjJJdJJ[JJJm",430,7,0,1);
setfillstyle(1,6);floodfill(5,5,15);setfillstyle(1,12);floodfill(2,2,15);
rectangle(0,30,639,349);
setfillstyle(1,0);setcolor(15);bar(30,79,610,101);rectangle(29,78,611,102);
arabic_text("gr] pwgj ugd :      >",596,80,0,1);
sprintf(buffer,"%d",percent);number_ltext(buffer,400,80,1);
line(373,83,360,96);putpixel(373,96,15);putpixel(360,83,15);
if(percent<50) message=0;                       /* determine the grade */
if(percent>=50 && percent<=69) message=1;
if(percent>=70 && percent<=75) message=2;
if(percent>=76 && percent<=83) message=3;
if(percent>=84) message=4;
arabic_text("hgjr]dv :",301,80,0,1);
arabic_text(messages[message],168,80,0,1);              /* display grade */
save_letters();                            /* store letters info in heap */
load_horse();                                   /* load horse images */
setfillstyle(1,14);bar(59,140,580,320);
setcolor(6);rectangle(59,140,580,320);
ratiox=1.54;ratioy=1;
positionx=28;positiony=160;setcolor(BROWN);
draw(hills,(sizeof(hills)/2-1));                /* draw background */
ratiox=1.66;positionx=275;draw(hills,(sizeof(hills)/2-1));
setfillstyle(1,9);floodfill(60,141,6);
setfillstyle(1,14);
enable_cursor();
for(cnt=0;cnt<=percent;cnt++)
	{                       /* animate horse up to the right percentage */
	disable_cursor();                       /* hide cursor */
	putimage(70+floor((float)(4.1*cnt)),240,&letters[1504*frame_no],COPY_PUT);      /* put a frame */
	bar(60+floor((float)(4.1*cnt)),240,69+floor((float)(4.1*cnt)),317);
	enable_cursor();                        /* show cursor */
	delay(30);
	frame_no+=1;                            /* to next frame */
	if(frame_no==11) frame_no=0;            /* if the last one, start over */
	}
clear_buffer();                                 /* clear keyboard buffer */
load_letters();                                 /* get letters from heap */
disable_cursor();f1_message();enable_cursor();  /* a help message */
if(percent==100) anthems();                     /* if a 100% score, play an anthem */
wait_key_mouse();                               /* pause */
}
int colo[]={12,13,14,15};
/*-------------------------draw_frame() ----------------------------*\
| This function draws a frame of coloured boxes aaround the screen   |
| The function rectangle() is used to draw the boxes and floodfill() |
| is used to paint them .                                            |
| IN    : NONE                                                       |
| OUT   : NONE							     |
\*------------------------------------------------------------------*/
draw_frame()
{
int col,i;
rectangle(0,0,639,20);
rectangle(0,0,20,339);
rectangle(0,300,639,319);
rectangle(620,0,639,339);
col=10;
for(i=0;i<=639;i+=20) line(i,0,i,19);
for(i=0;i<=639;i+=20)
	{setfillstyle(SOLID_FILL,col);col+=1;floodfill(i+1,1,15);
	if(col==14) col=10;}col=13;
for(i=20;i<=339;i+=20) line(0,i,20,i);
for(i=20;i<=339;i+=20)
	{setfillstyle(SOLID_FILL,col);col-=1;floodfill(1,i+1,15);
	if (col==9) col=13;} col=10;
for(i=20;i<=639;i+=20) line(i,300,i,319);
for(i=20;i<=639;i+=20)
	{setfillstyle(SOLID_FILL,col);col-=1;floodfill(i+1,301,15);
	if (col==9) col=13;} col=10;

for(i=20;i<=320;i+=20) line(620,i,639,i);

for(i=20;i<=320;i+=20)
	{setfillstyle(SOLID_FILL,col);col++;floodfill(621,i+1,15);
	if(col==14) col=10;}
}

/*-------------------------animate_frame() ----------------------------*\
| This function is used to move the boxes of the frame drawn by the 	|
| function draw_frame() , the animating process is done by changing the |
| pallette of colours using the setpallette() function .		|
| IN    : NONE                                                          |
| OUT   : NONE							        |
\*---------------------------------------------------------------------*/
animate_frame()
{
int tempvalue,cntr;
tempvalue=colo[0];

for(cntr=0;cntr<=2;cntr++)
	colo[cntr]=colo[cntr+1];
colo[3]=tempvalue;
for(cntr=0;cntr<=3;cntr++)
	setpalette(10+cntr,colo[cntr]);
}


/*------------------------brushed_background()---------------------------*\
| This function draws an air brushed background , this is done by using   |
| the bar function with different fill patterns , the fill patterns is    |
| is choosen using the setfillpattern() function .			  |
| IN    : NONE                                                            |
| OUT   : NONE							          |
\*-----------------------------------------------------------------------*/
brushed_background(c)
int c;
{
char f3[]={0,32,0,0,0,2,0,0},f6[]={32,0,2,0,128,0,8,0},
f12[]={32,2,128,8,32,2,128,8},f25[]={68,17,68,17,68,17,68,17},
f37[]={146,41,148,73,164,73,146,73},f50[]={85,170,85,170,85,170,85,170},
f62[]={109,214,107,182,91,182,109,182},f75[]={187,238,187,238,187,238,187,238},
f87[]={223,253,127,247,223,253,127,247};
setfillpattern(f6,c);bar(0,35,639,70);
setfillpattern(f12,c);bar(0,70,639,105);setfillpattern(f25,c);bar(0,105,639,140);
setfillpattern(f37,c);bar(0,140,639,175);setfillpattern(f50,c);bar(0,175,639,210);
setfillpattern(f62,c);bar(0,210,639,245);setfillpattern(f75,c);bar(0,245,639,280);
setfillpattern(f87,c);bar(0,280,639,315);setfillstyle(1,c);bar(0,315,639,349);
}
/*---------------------- draw () --------------------------------------*\
| This function draws a picture which is divided into many lines with   |
| coordinates stored in the array argument with length in the argument  |
| size. The x and y scales must be sent in the global vaariables ratiox |
| and ratioy . The origin point x,y coordinates is stored in the global |
| variables positionx and position y .                                  |
| In this function if the coordinates are +ve a line is drawn from the  |
| current position to the point and if the coordinates are -ve the      |
| current position is changed to the coordinates without drawing , this |
| helps in drawing the non-continuous pictures .                        |
|       IN: array: array of coordinates of the points                   |
|           size: size of the array                                     |
|       OUT: NONE                                                       |
\*---------------------------------------------------------------------*/
draw(array,size)
int array[],size;
{
int count,x,y;

for (count=0;count<=size;count+=2)              /* for each point */
{
float result;
if ( (array[count]<0) && (array[count+1]< 0) )
{       /* if negative coordinaes , then move without drawing */
x=positionx+floor((-array[count])*ratiox);      /* calculate x-ccord. */
y=positiony+floor((-array[count+1])*ratioy);    /* calculate y-coord. */
moveto(x,y);}                                   /* move to there */

else                                    /* otherwise, draw */
   {
   x=positionx+floor(array[count]*ratiox);      /* calculate x-coord. */
   y=positiony+floor(array[count+1]*ratioy);    /* calculate y-coord. */
   lineto(x,y);}                                /* draw a line */
   }
}

/*---------------------- ratio_fill () --------------------------------*\
| This function paints a specific area but it differs from the          |
| floodfill() function that the coordinates of the place is calculated  |
| using the x,y scales in the global variables ratiox and ratioy and it |
| paints starting from the origin point with coordinates positionx and  |
| positiony .                                                           |
|       IN    : xcord,ycord: x,y coordinates of the place to paint      |
|               color: the colour to paint with.                        |
|               border: the border                                      |
|               pattern: The fill pattern .                             |
|               See floodfill() and setfillstyle() for more information |
|               about the border and thepattern arguments .             |
|       OUT   : NONE                                                    |
\*---------------------------------------------------------------------*/
ratio_fill(xcord,ycord,color,border,pattern)
int xcord,ycord,color,border,pattern;
{
setfillstyle(pattern,color);
xcord=positionx+floor(xcord*ratiox);
ycord=positiony+floor(ycord*ratioy);
floodfill(xcord,ycord,border);
}
/*---------------------- load_horse () --------------------------------*\
| This function loads the horse's image array into the array letters    |
|       IN    : NONE                                                    |
|       OUT   : NONE                                                    |
\*---------------------------------------------------------------------*/
load_horse()
{
FILE *fptr;
if ((fptr=fopen("horse.img","rb"))==NULL)       /* try to open HORSE.IMG */
   file_error("horse.img");     /* on error, tell the user and exit */
fread(letters,2,16544,fptr);    /* read images information */
fclose(fptr);                   /* close file */
}

/*anthems(): This function is specified with opening the file "anthems.dat"
	     and reading the anthems until it reaches the desiered country
	     then it starts plays the anthem by calling the play() function.
	     It's used here for playing the anthem of Lybia which is the
	     "Allahu Akbar" song .
	IN : country: no. of the selected country
	OUT: NONE.*/
anthems(country)
int country;
{
int cnt,len;
char anthem[1234];
FILE *fptr;
	if((fptr=fopen("anthems.dat","r"))==NULL)
			file_error("anthems.dat");
	for(cnt=1;cnt<=5;cnt++)
		{
		fread(&len,2,1,fptr);
		fread(anthem,1,len,fptr);
		}
	fclose(fptr);
	play(anthem,2);
}

/*---------------------- number_ltext () ------------------------------*\
| This function uses the arabic_text() function to display arabic       |
| numerals in a direction from right to left  .                         |
|       IN      : buf: The pointer to the string containing the number. |
|                 x,y: x,y coords for the number to be displayed        |
|                 put: The put which will be send to the putimage()     |
|       OUT     : NONE                                                  |
\*---------------------------------------------------------------------*/
number_ltext(buf,x,y,put)
char buf[20];
int x,y,put;
{
char buf1[20];
int cnt;
			/*--- reverse digits order ---*/
for(cnt=0;cnt<=strlen(buf)-1;cnt++)     /* for each character in buf */
	{if(buf[cnt]=='.')              /* if char is '.' */
		buf[cnt]='>';           /* change to its Arabic equivalent */
	buf1[strlen(buf)-1-cnt]=buf[cnt];}
buf1[strlen(buf)]='\x0';                /* terminating character */
arabic_text(buf1,x,y,0,put);            /* display number */
}

/*---------------------- save_letters () ------------------------------*\
| This function copies the array letters to far memory if the memory is |
| available and this is checked through the variable slow which is set  |
| on to (1) in the main() function and if the far memory isn't          |
| available it does. nothing.                                           |
|       IN      : NONE                                                  |
|       OUT     : NONE                                                  |
\*---------------------------------------------------------------------*/
save_letters()
{
int i;

if(slow!=1)    /* if we are not in the slow mode, ie. letters are in memory */
for(i=0;i<=17748;i++)   /* for each character in letters[] array */
   *(pt+i)=letters[i];  /* copy it to heap */
}

/*---------------------- load_letters () ------------------------------*\
| This function copies the memory at the offset *pt to the letters[]    |
| array and this memory contains the array of the arabic letters and if |
| the memory wasn't available and the save_letters function hasn't      |
| copied the letters[] array to the memory it sets the global variable  |
| (init16) to (0) which will cause the arabic_text() function to load   |
| the arabic letters array from the file letdat.16c and this needs more |
| time than copying it from memory so, the program is in the slow mode. |
|       IN       : NONE.                                                |
|       OUT      : NONE.                                                |
\*---------------------------------------------------------------------*/
load_letters()
{
int i;
if(slow!=1)                     /* if not in slow mode */
for(i=0;i<=17748;i++)           /* for each charcater in heap */
	letters[i]=*(pt+i);             /* copy it in letters[] */
else
	init16=0;            /* else mark that characters are not in array */
}

/*---------------------- enter_music () -------------------------------*\
| This function plays the music when ENTER is pressed.                  |
|       IN      : NONE                                                  |
|       OUT     : NONE                                                  |
\*---------------------------------------------------------------------*/
enter_music()
{
play("ml o5 l32 a b c d e d a c",0);
}

/*---------------------- esc_music () ---------------------------------*\
| This function plays the music when ESC is pressed.                    |
|       IN     : NONE                                                   |
|       OUT    : NONE                                                   |
\*---------------------------------------------------------------------*/
esc_music()
{
play("ml o5 l32 f c d a b c d f",0);
}

/*---------------------- f1_music () ----------------------------------*\
| This function plays the music when F1 is pressed.                     |
|       IN   : NONE                                                     |
|       OUT  : NONE                                                     |
\*---------------------------------------------------------------------*/
f1_music()
{
play("ml l20 o5 a b d a c d f",0);
}


wait_key_or_mouse()
{
int end=0;
char returnvalue;
while(end!=1)
	if(kbhit() || check_buttons())
		{
		returnvalue=getch();
		if(returnvalue==0) getch();
		end=1;
		}
return(returnvalue);
}

/*wait_key_mouse(): This function waits for either a keystroke from
		    the keyboard or a click from the mouse
	IN        : NONE
	OUT       : NONE*/
wait_key_mouse()
{
int end=0;
char ch;
while(end!=1)
	if (kbhit() || check_buttons()!=0)
		switch(getch())
			{
			case ESC: esc_music();end=1;break;
			case 0: if((char)(ch=getch())==-127){enter_music();end=1;}
				else if(ch==59) help(1);break;
			case ENTER: enter_music();end=1;break;
			default: beep;
			}
}




/*---------------------- right_music () -------------------------------*\
| This function plays a tone when the answer is right.                  |
|       IN  : NONE.                                                     |
|       OUT : NONE.                                                     |
\*---------------------------------------------------------------------*/
right_music()
{play("ml o5 l32 a b d c g f b c d e f",0);}

/*---------------------- wrong_music () -------------------------------*\
| This function plays a tone when the answer is wrong.                  |
|       IN  : NONE.                                                     |
|       OUT : NONE.                                                     |
\*---------------------------------------------------------------------*/
wrong_music()
{play("ml o1 l2 c",0);}
/*---------------------- menu () --------------------------------------*\
| This function moves a menu bar with a specific width and coordinates  |
| returning the position of the bar among the choices. It has an        |
| advantage as it doesn't suspend the computer until the bar is moved   |
| and this enables doing any thing while the menu is displayed such as  |
| animating the map in the main menu or playing music .                 |
|   IN   :  xcord:  x coordinate of the menu                            |
|           ycord:  y coordinate of the menu                            |
|           width:  width of the menu                                   |
|           step:   no. of pixels betweem each choice and the next      |
|           itemsno:no. of items in the menu                            |
|           choice: current choice                                      |
|           excode: scan code of the key pressed                        |
|           stepping: the no. of pixels stepped between every item      |
|                     and another .                                     |
|   OUT  :  choice: current choice                                      |
\*---------------------------------------------------------------------*/
menu(xcord,ycord,width,step,itemsno,choice,excode,stepping)
int xcord,ycord,width,step,itemsno,choice,stepping;
char excode;
{
#define inverse_choice disable_cursor();reverse(xcord,ycord+(step*choice)+(stepping*choice),xcord+width,ycord+step+(step*choice)-1+(stepping*choice));enable_cursor()
union REGS r;
int mousex,mousey,cnt,old_choice,cntr;

switch(excode)
	{               /* examine the pressed key */
	case UP:        /* if UP arrow was pressed */
		if (choice!=0)          /* if old choice isn't the first */
		   {inverse_choice;choice--;inverse_choice;}    /* decrement */
		else {inverse_choice;choice=itemsno;inverse_choice;}
				/* otherwise, point to the last item */
		break;

	case DOWN:      /* if DOWN arrow was pressed */
		if (choice!=itemsno)    /* if old item isn't the last */
		   {inverse_choice;choice++;inverse_choice;}
		else            /* otherwise, point to the first item */
		   {inverse_choice;choice=0;inverse_choice;}
		break;

	case -127:      /* mouse button */
		mousex=get_mousex();mousey=get_mousey();
					/* get mouse coordinates */
		if (mousex>xcord && mousex<xcord+width)
			if(mousey>ycord && mousey<ycord+step+(step*itemsno))
			       /* if mouse is inside the specific rectangle */
				for(cnt=0;cnt<=itemsno;cnt++)   /* for each prvious item */
					if (mousey>ycord+(step*cnt)+(stepping*choice) &&
					    mousey<ycord+step+(step*cnt)+(stepping*choice))
						{       /* if mouse is inside that rectangle */
						inverse_choice;         /* highlight it */
						for(cntr=0;cntr<=6;cntr++)
							{
							choice=cnt;
							inverse_choice;
							delay(50);
							}
						/* insert in keyboard buffer */
						r.h.ah=5;
						r.h.ch=0x1c;
						r.h.cl=0x0d;
						int86(0x16,&r,&r);
						}
		break;
	default:
		beep;
	}
return(choice);
}



/*---------------------- file_error () --------------------------------*\
| This function displays an error message indicating that an error      |
| occured while opening a file.                                         |
|         IN  : fn: pointer to the filename                             |
|         OUT : NONE                                                    |
\*---------------------------------------------------------------------*/
file_error(fn)
char *fn;
{
closegraph();                   /* switch back to text mode */
printf("\nAn error occured while opening \"%s\" .",fn);
printf("\nCheck and rerun ....\n");
exit(2);                        /* exit with errorlevel of 2 */
}

/*---------------------- reverse () -----------------------------------*\
| This function reverses the colour of a portion of the screen.         |
|       IN : x1,y1:start x,y coordinates of the area                    |
|            x1,y2:end x,y coordinates of the area                      |
|       OUT: NONE                                                       |
\*---------------------------------------------------------------------*/
reverse(x1,y1,x2,y2)
int x1,y1,x2,y2;
{
char buffer[4000];
getimage(x1,y1,x2,y2,buffer);                   /* get the image */
putimage(x1,y1,buffer,NOT_PUT);                 /* put it reversed */
}

/*---------------------- clear_buffer () ------------------------------*\
| This function checks the keyboard's buffer and emptys it.             |
|       IN        : NONE                                                |
|       OUT       : NONE                                                |
\*---------------------------------------------------------------------*/
clear_buffer()
{
while (kbhit())                 /* while the buffer isn't empty... */
	getch();                        /* ... remove a character from it */
}

/*---------------------- help () --------------------------------------*\
| This function is responsible for displaying help messages. It copies  |
| the part of the screen in which the help message will be displayed to |
| page no. 1 then it recopies it back to its place in page no. 0 after  |
| the user reads th help message.                                       |
|     IN  : message : message no , It may be either 0 or 1              |
|     OUT : None .                                                      |
\*---------------------------------------------------------------------*/
/* help() : This function is responsible for displaying help messages
      IN  : message : message no , It may be either 0 or 1
      OUT : None .*/
help(message)
int message;
{
char *messages[]={"jpv; fhGsil H, fhgtHvm >","Yojv fJ     H, f.v hgtHvm hGdlk >",
"Hqy'     H, .v hgtHvm hGdsv","ggrhzlm hgshfrm >",
"Yqy'    H,     H, Hd lk H.vhv","hgtHvm hGdlk , hGdsv ggrhzlm","hgshfrm >"," "};
int enter_xs[]={398,357},enter_ys[]={120,98},esc_xs[]={440,448},esc_ys[]={142,98},i,end=0;
f1_music();
save_letters();disable_cursor();
getimage(102,89,553,182,letters);
setactivepage(1);putimage(102,89,letters,COPY_PUT);setactivepage(0);
setfillstyle(1,6);bar(105,91,553,182);
setfillstyle(1,14);bar(102,89,550,180);
setcolor(0);rectangle(102,89,550,180);
load_letters();
for(i=0;i<=3;i++) arabic_text(messages[(message*4)+i],530,91+(22*i),0,1);
setcolor(4);outtextxy(enter_xs[message],enter_ys[message],"Enter");
outtextxy(esc_xs[message],esc_ys[message],"Esc");
enable_cursor();
while(end!=1)
	if (kbhit() || check_buttons()!=0)
		switch(getch())
			{
			case ESC: esc_music();end=1;break;
			case 0: if((char)getch()==-127){enter_music();end=1;} else beep;
				break;
			case ENTER: enter_music();end=1;break;
			default: beep;
			}
disable_cursor();
setactivepage(1);getimage(102,89,553,182,letters);setactivepage(0);putimage(102,89,letters,COPY_PUT);
load_letters();
enable_cursor();
}
/*---------------------- f1_message () --------------------------------*\
| This function displays a message at the bottom of the screen that     |
| tells the user to press F1 for help.                                  |
|       IN  : NONE                                                      |
|       OUT : NONE                                                      |
\*---------------------------------------------------------------------*/
f1_message()
{
arabic_text("hqy'    H, .v hgtHvm hG,s' gglshu]m",536,325,0,2);
setcolor(11);outtextxy(460,332,"F1");
}
